
/*************************************************************************
 *  t@C     : main.c
 *  e           : EBhEj[eXg
 *                 ` ܂ IEMyEMe `
 *  vtBbNX : Main
 *  쐬         :  j (Yoshio Hashiguchi)
 *  쐬         : 98-06-19 쐬Jn
 *  Rg       :
 *  o[W     : 0.01
 ************************************************************************/

#define __MAIN_C

/*
######## CN[ht@C ########
*/

#include <ninja.h>
#include <ninjawin.h>
#include <njdef.h>
#include <htfont.h>
#include <htwindow.h>

#include "wintex.h"
#include "topwin.h"

#include "main.h"

/*
######## 萔錾 ########
*/

#define MAX_MATRIX_DEPTH (32)
#define MAX_VERTEXES (10000)
#define MAX_TEXTURE_NUM (256)

#define BGCOLOR_LEFTTOP (ARGB(255, 50, 50, 200))
#define BGCOLOR_RIGHTTOP (ARGB(255, 50, 50, 200))
#define BGCOLOR_LEFTBOTTOM (ARGB(255, 0, 0, 0))

/*
######## }N ########
*/

/*
######## \̐錾 ########
*/

/*
######## Ŏg֐̃vg^Cv錾 ########
*/

/*
######## ÓIϐ ########
*/

static NJS_MATRIX matrix[MAX_MATRIX_DEPTH];
static NJS_VERTEX_BUF vBuf[MAX_VERTEXES];
static NJS_VIEW view;
static NJS_LIGHT light;

static NJS_TEXMEMLIST texMemList[MAX_TEXTURE_NUM];

/* t[vZp */
static Uint32 frame;
static Uint32 wframe;
static Uint32 timer;

/*
######## O[o֐ ##################################################
*/

/*************************************************************************
 *  ֐  : njUserInit
 *  e    : 
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-06-19 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
void njUserInit(void)
{
    /* VXe */
    njInitSystem(NJD_RESOLUTION_VGA, NJD_FRAMEBUFFER_MODE_ARGB1555, 1);
    /* _f[^o^pobt@AP[g(1̒_*64/4oCg) */
    njInitVertexBuffer(MAX_VERTEXES * 64 / 4, 0, MAX_VERTEXES * 64 / 4, 0);
    /* }gNXX^bN */
    njInitMatrix(matrix, MAX_MATRIX_DEPTH, 1);
    /* RcVXȅ(f`̂߂̃[Nobt@) */
    njInit3D(vBuf, MAX_VERTEXES);
    /* fAIuWFNg̕`Rg[ */
    njControl3D(NJD_CONTROL_3D_CONSTANT_ATTR);
    /* ̎ނ߃CgVɐݒu(so^)
      (ʒu0,0,0ji0,0,-1) */
    njCreateLight(&light, NJD_DIR_LIGHT);
    /*eNX`i[̈ݒ*/
    njInitTexture(texMemList, MAX_TEXTURE_NUM);
    /* r[̏(ʒu=0,0,0)(=0,0,-1)(X=0x) */
    njInitView(&view);
    /* [U̗pӂr[Jgr[Ɏw */
    njSetView(&view);

    /* obNOEhJ[ݒ */
    njSetBackColor(BGCOLOR_LEFTTOP, BGCOLOR_RIGHTTOP, BGCOLOR_LEFTBOTTOM);

    /* EBhEVXȅ */
    htFontInit();
    htFontLoad("jpnhn16x.fnt", "jpnzn16x.x11");
    htFontLoadAnk("roman1.fnt");
    HTWindowInit();

    /* EBhEVXẽeNX`쐬 */
    WinTex_CreateTexture();

    /* gbvEBhE쐬 */
    TopWin_CreateWindow();

    /* t[JE^̏ */
    wframe = 0;
    timer = GetCurrentTime();
    njPrintSize(16);
}


/*************************************************************************
 *  ֐  : njUserMain
 *  e    : s郁C
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-06-19 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: NJD_USER_CONTINUE
 *************************************************************************
 */
Sint32 njUserMain(void)
{
    /* EBhE[v */
    njPushMatrix(NULL);
    HTDrawWindowLoop();
    njPopMatrix(1);

    /* t[̌vZ */
    wframe++;
    if (GetCurrentTime() > (timer + (5 * 1000))) {
        frame = wframe / 5;
        wframe = 0;
        timer = GetCurrentTime();
    }
    njPrintD(NJM_LOCATION(27, 29), frame, 3);
    njPrintC(NJM_LOCATION(31, 29), "Frame/Sec");

    return NJD_USER_CONTINUE;
}

/*************************************************************************
 *  ֐  : njUserExit
 *  e    : I֐
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-05-29 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
void njUserExit(void)
{
    /* eNX` */
    njExitTexture();
    /* VXȅI */
    njExitSystem();
}

/*
######## [J֐ ####################################################
*/

/*
######## ܂ ########################################################
*/
