
/*************************************************************************
 *  t@C     : sakusenshituwin.c
 *  e           : 펺j[EBhE쐬Ǘ
 *  vtBbNX : SakusenshituWin
 *  쐬         :  j (Yoshio Hashiguchi)
 *  쐬         : 98-06-19 쐬Jn
 *  Rg       :
 *  o[W     : 0.01
 ************************************************************************/

#define __SAKUSENSHITUWIN_C

/*
######## CN[ht@C ########
*/

#include <htwindow.h>
#include <htwinbuttonarray.h>

#include "windef.h"
#include "wintex.h"
#include "ikuseiwin.h"
#include "dajunhenkouwin.h"
#include "positionketteiwin.h"
#include "toushurotationwin.h"

#include "sakusenshituwin.h"

/*
######## 萔錾 ########
*/

#define WINFGCOLOR (ARGB(0, 0, 0, 0)) /* OʐF(iKł͕sgp) */
#define WINBGCOLOR (ARGB(150, 75, 50, 75)) /* wiF */

#define WINPOS_LEFT (MAINMENU_POS_LEFT + 150) /* W */
#define WINPOS_TOP (MAINMENU_POS_TOP) /* EBhEW */

#define BTNNUM (4) /* {^ */
#define BTNSIZE_X (ONESTRTEX_X * 8) /* {^wTCY */
#define BTNSIZE_Y (ONESTRTEX_Y * 2) /* {^xTCY */

/*
######## }N ########
*/

/*
######## \̐錾 ########
*/

/*
######## Ŏg֐̃vg^Cv錾 ########
*/

static void SetBtnAttr(void);
static void SetBtnCallBack(void);

static void ToDajunHenkouMode(LPHTtButtonArg arg);
static void ToPositionKetteiMode(LPHTtButtonArg arg);
static void ToToushuRotationMode(LPHTtButtonArg arg);
static void ReturnToIkuseiMenu(LPHTtButtonArg arg);

/*
######## ÓIϐ ########
*/

/* EBhEnh */
static HTWINHANDLE sakusenshituWin;

/* {^EBhEpp[^ */
static HTtButtonArg btnArg[BTNNUM];

/* {^pACẽAgr[g */
static HTtItemAttr itemAttr[] = {
  /* Polygon/Texture       TextureID                 COLOR        UV */
    ITEM_ATTR_TEXTURE, WINTEXID_DAJUNHENKOU,    COL4_RED_WHITE, UV4_88,
    ITEM_ATTR_TEXTURE, WINTEXID_POSITIONKETTEI, COL4_RED_WHITE, UV4_88,
    ITEM_ATTR_TEXTURE, WINTEXID_TOUSYUROTATION, COL4_RED_WHITE, UV4_88,
    ITEM_ATTR_TEXTURE, WINTEXID_RETURN,         COL4_RED_WHITE, UV4_88,
};

/* {^pACe̍쐬 */
static HTtItem btnItem[BTNNUM] = {
  /*  ItemPtr           TCY          iӖj */
    1, &itemAttr[0], BTNSIZE_X, BTNSIZE_Y,  0, 0,
    1, &itemAttr[1], BTNSIZE_X, BTNSIZE_Y,  0, 0,
    1, &itemAttr[2], BTNSIZE_X, BTNSIZE_Y,  0, 0,
    1, &itemAttr[3], BTNSIZE_X, BTNSIZE_Y,  0, 0,
};

/* J[\{^ɂƂɌĂ΂R[obN֐ */
static void (*onBtnCallBack[BTNNUM])(LPHTtButtonArg arg) = {
    NULL,
    NULL,
    NULL,
    NULL,
};

/* {^IꂽƂɌĂ΂R[obN֐ */
static void (*pushBtnCallBack[BTNNUM])(LPHTtButtonArg arg) = {
    ToDajunHenkouMode,
    ToPositionKetteiMode,
    ToToushuRotationMode,
    ReturnToIkuseiMenu,
};

/*
######## O[o֐ ##################################################
*/

/*************************************************************************
 *  ֐  : SakusenshituWin_CreateWindow
 *  e    : EBhE쐬
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-06-19 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
void SakusenshituWin_CreateWindow(void)
{
    extern NJS_TEXLIST winTexList; /* eNX`Xg(wintex.c) */

    /* {^̑̐ݒ */
    SetBtnAttr();

    /* {^ACcɕׂ */
    HTtSetButtonArrayAttribute(HTBUTTONARRAY_ATTR_VERT);

    /* EBhE쐬 */
    sakusenshituWin = HTtCreateButtonArrayWindow(WINPOS_LEFT, WINPOS_TOP,
        btnArg, BTNNUM, WINFGCOLOR, WINBGCOLOR);

    /* eNX`Xg̐ݒ */
    HTSetTextureList(sakusenshituWin, &winTexList);

    /* EBhER[obN֐ݒ */
    SetBtnCallBack();
}

/*************************************************************************
 *  ֐  : SakusenshituWin_MapWindow
 *  e    : EBhEĕ\
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-06-19 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
void SakusenshituWin_MapWindow(void)
{
    HTMapWindow(sakusenshituWin);
}

/*
######## [J֐ ####################################################
*/

/*************************************************************************
 *  ֐  : SetBtnAttr
 *  e    : {^̑̐ݒ
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-06-19 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
static void SetBtnAttr(void)
{
    Sint8 i;
    HTtButtonArg* pBtnArg = &btnArg[0];
    HTtItem* pItem = &btnItem[0];

    for (i = 0; i < BTNNUM; i++) {
        pBtnArg->item = *pItem;
        pBtnArg++;
        pItem++;
    }
}

/*************************************************************************
 *  ֐  : SetBtnCallBack
 *  e    : {^̃R[obN֐̐ݒ
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-06-19 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
static void SetBtnCallBack(void)
{
    Sint8 i;
    HTtButtonArg* pBtnArg = &btnArg[0];
    void (**pOnBtnCallBack)(LPHTtButtonArg arg) = &onBtnCallBack[0];
    void (**pPushBtnCallBack)(LPHTtButtonArg arg) = &pushBtnCallBack[0];

    for (i = 0; i < BTNNUM; i++) {
        /* J[\{^ɗƂ̃R[obN */
        HTtSetOnButtonCallBack(pBtnArg, *pOnBtnCallBack);
        /* {^IꂽƂ̃R[obN */
        HTtSetPushButtonCallBack(pBtnArg, *pPushBtnCallBack);
        pBtnArg++;
        pOnBtnCallBack++;
        pPushBtnCallBack++;
    }
}

/*************************************************************************
 *  ֐  : ToDajunHenkouMode
 *  e    : ŏύX[h
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-06-19 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
static void ToDajunHenkouMode(LPHTtButtonArg arg)
{
    IkuseiWin_UnMapWindow();
    HTUnMapWindow(sakusenshituWin);
    DajunHenkouWin_CreateWindow();
}

/*************************************************************************
 *  ֐  : ToPositionKetteiMode
 *  e    : |WV胂[h
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-06-19 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
static void ToPositionKetteiMode(LPHTtButtonArg arg)
{
    IkuseiWin_UnMapWindow();
    HTUnMapWindow(sakusenshituWin);
    PositionKetteiWin_CreateWindow();
}

/*************************************************************************
 *  ֐  : ToToushuRotationMode
 *  e    : 胍[e胂[h
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-06-19 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
static void ToToushuRotationMode(LPHTtButtonArg arg)
{
    IkuseiWin_UnMapWindow();
    HTUnMapWindow(sakusenshituWin);
    ToushuRotationWin_CreateWindow();
}

/*************************************************************************
 *  ֐  : ReturnToIkuseiMenu
 *  e    : 琬j[֖߂
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-06-19 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
static void ReturnToIkuseiMenu(LPHTtButtonArg arg)
{
    HTCloseWindow(sakusenshituWin);
}

