
/*************************************************************************
 *  t@C     : main.c
 *  e           : {^j[eXg
 *  vtBbNX : Main
 *  쐬         :  j (Yoshio Hashiguchi)
 *  쐬         : 98-07-28
 *  Rg       :
 *  o[W     : 1.00
 ************************************************************************/

#define __MAIN_C

/*
######## CN[ht@C ########
*/

#include <ninjawin.h>
#include <njdef.h>
#include <ninja.h>

#include "winsys.h"
#include "winbtnmenu.h"

/*
######## 萔錾 ########
*/

#define MAX_MATRIX_DEPTH (32)
#define MAX_VERTEXES (10000)
#define MAX_TEXTURE_NUM (256)

/*
######## }N ########
*/

/*
######## \̐錾 ########
*/

/*
######## Ŏg֐̃vg^Cv錾 ########
*/

static void MoveFunc(Sint32 btnID);
static void PushFunc(Sint32 btnID);

/*
######## ÓIϐ ########
*/

static NJS_MATRIX matrix[MAX_MATRIX_DEPTH];
static NJS_VERTEX_BUF vBuf[MAX_VERTEXES];
static NJS_VIEW view;
static NJS_LIGHT light;
static NJS_TEXMEMLIST texMemList[MAX_TEXTURE_NUM];

/* fobOp */
static Sint32 curBtn = 0;
static Sint32 lastPush = 0;

/* t[vZp */
static Uint32 frame;
static Uint32 wframe;
static Uint32 timer;

/* eNX`ݒ */
NJS_TEXNAME texName[] = {
  /* t@C                          Agr[g                  ID */
    "sprite1.pvr",       NJD_TEXATTR_TYPE_FILE | NJD_TEXATTR_GLOBALINDEX, 0,
    "sprite2.pvr",       NJD_TEXATTR_TYPE_FILE | NJD_TEXATTR_GLOBALINDEX, 1,
    "fer_emblem_sb.pvr", NJD_TEXATTR_TYPE_FILE | NJD_TEXATTR_GLOBALINDEX, 2,
    "logo_backW.pvr",    NJD_TEXATTR_TYPE_FILE | NJD_TEXATTR_GLOBALINDEX, 3,
};
NJS_TEXLIST texList = {texName, 4};

/* S_̃J[tu(,E,E,) */
static WinCol4 texCol[] = {
    ARGB(255, 255, 255, 255), ARGB(255, 255, 255, 255),
        ARGB(255, 255, 255, 255), ARGB(255, 255, 255, 255), /* 0 */
    ARGB(200, 0, 255, 255), ARGB(200, 0, 255, 255),
        ARGB(0, 0, 255, 255), ARGB(0, 0, 255, 255),         /* 1 */
};
static WinUV4 texUV[] = {
    UV(0, 0), UV(255, 0), UV(255, 255), UV(0, 255), /* 0 */
    UV(255, 0), UV(0, 0), UV(0, 255), UV(255, 255), /* 1 */
};

/* t[̃p[cƂȂeNX`╽ʂ̃Agr[gPƂɖL */
static WinPartsItem partsItem[] = {
                /* TEXNO      J[               tu */
    WIN_TEXTURE_ATTR(0, WIN_COL4(texCol[0]), WIN_UV4(texUV[0])),  /* 0 */
    WIN_TEXTURE_ATTR(1, WIN_COL4(texCol[0]), WIN_UV4(texUV[0])),  /* 1 */
    WIN_TEXTURE_ATTR(2, WIN_COL4(texCol[0]), WIN_UV4(texUV[0])),  /* 2 */
    WIN_TEXTURE_ATTR(3, WIN_COL4(texCol[0]), WIN_UV4(texUV[0])),  /* 3 */
    WIN_TEXTURE_ATTR(3, WIN_COL4(texCol[0]), WIN_UV4(texUV[1])),  /* 4 */
                        /* J[ */
    WIN_POLYGON_ATTR(WIN_COL4(texCol[1])),                        /* 5 */
};

/* Aj[VPt[ƂɃp[c̑gݍ킹𖾋L */
static WinFrame frame000[] = {
                 /* PARTS_ITEM    TCY ItZbg */
    WIN_PARTS_ATTR(&partsItem[1], 64, 64, 0, 0),
};
static WinFrame frame100[] = {
    WIN_PARTS_ATTR(&partsItem[0], 64, 64, 0, 0),
};
static WinFrame frame101[] = {
    WIN_PARTS_ATTR(&partsItem[1], 64, 64, 0, 0),
};
static WinFrame frame102[] = {
    WIN_PARTS_ATTR(&partsItem[2], 64, 64, 0, 0),
};
static WinFrame frame103[] = {
    WIN_PARTS_ATTR(&partsItem[3], 64, 64, 0, 0),
};
static WinFrame frame200[] = {
    WIN_PARTS_ATTR(&partsItem[0], 32, 32, 0, 0),
    WIN_PARTS_ATTR(&partsItem[1], 32, 32, 32, 0),
    WIN_PARTS_ATTR(&partsItem[2], 32, 32, 32, 32),
    WIN_PARTS_ATTR(&partsItem[3], 32, 32, 0, 32),
};
static WinFrame frame201[] = {
    WIN_PARTS_ATTR(&partsItem[3], 32, 32, 0, 0),
    WIN_PARTS_ATTR(&partsItem[0], 32, 32, 32, 0),
    WIN_PARTS_ATTR(&partsItem[1], 32, 32, 32, 32),
    WIN_PARTS_ATTR(&partsItem[2], 32, 32, 0, 32),
};
static WinFrame frame202[] = {
    WIN_PARTS_ATTR(&partsItem[2], 32, 32, 0, 0),
    WIN_PARTS_ATTR(&partsItem[3], 32, 32, 32, 0),
    WIN_PARTS_ATTR(&partsItem[0], 32, 32, 32, 32),
    WIN_PARTS_ATTR(&partsItem[1], 32, 32, 0, 32),
};
static WinFrame frame203[] = {
    WIN_PARTS_ATTR(&partsItem[1], 32, 32, 0, 0),
    WIN_PARTS_ATTR(&partsItem[2], 32, 32, 32, 0),
    WIN_PARTS_ATTR(&partsItem[3], 32, 32, 32, 32),
    WIN_PARTS_ATTR(&partsItem[0], 32, 32, 0, 32),
};
static WinFrame frame300[] = {
    WIN_PARTS_ATTR(&partsItem[1], 64, 64, 0, 0),
};
static WinFrame frame301[] = {
    WIN_PARTS_ATTR(&partsItem[0], 64, 16, 0, 0),
    WIN_PARTS_ATTR(&partsItem[1], 64, 48, 0, 16),
};
static WinFrame frame302[] = {
    WIN_PARTS_ATTR(&partsItem[0], 64, 32, 0, 0),
    WIN_PARTS_ATTR(&partsItem[1], 64, 32, 0, 32),
};
static WinFrame frame303[] = {
    WIN_PARTS_ATTR(&partsItem[0], 64, 48, 0, 0),
    WIN_PARTS_ATTR(&partsItem[1], 64, 16, 0, 48),
};
static WinFrame frame304[] = {
    WIN_PARTS_ATTR(&partsItem[0], 64, 64, 0, 0),
};
static WinFrame frame310[] = {
    WIN_PARTS_ATTR(&partsItem[3], 64, 64, 0, 0),
};
static WinFrame frame311[] = {
    WIN_PARTS_ATTR(&partsItem[2], 64, 16, 0, 0),
    WIN_PARTS_ATTR(&partsItem[3], 64, 48, 0, 16),
};
static WinFrame frame312[] = {
    WIN_PARTS_ATTR(&partsItem[2], 64, 32, 0, 0),
    WIN_PARTS_ATTR(&partsItem[3], 64, 32, 0, 32),
};
static WinFrame frame313[] = {
    WIN_PARTS_ATTR(&partsItem[2], 64, 48, 0, 0),
    WIN_PARTS_ATTR(&partsItem[3], 64, 16, 0, 48),
};
static WinFrame frame314[] = {
    WIN_PARTS_ATTR(&partsItem[2], 64, 64, 0, 0),
};
static WinFrame frame400[] = {
    WIN_PARTS_ATTR(&partsItem[3], 64, 64, 0, 0),
    WIN_PARTS_ATTR(&partsItem[5], 64, 64, 0, 0),
};
static WinFrame frame410[] = {
    WIN_PARTS_ATTR(&partsItem[4], 64, 64, 0, 0),
    WIN_PARTS_ATTR(&partsItem[5], 64, 64, 0, 0),
};
static WinFrame frame500[] = {
    WIN_PARTS_ATTR(&partsItem[0], 32, 128, 0, 0),
};
static WinFrame frame510[] = {
    WIN_PARTS_ATTR(&partsItem[0], 64, 64, 0, 0),
};
static WinFrame frame600[] = {
    WIN_PARTS_ATTR(&partsItem[2], 32, 32, 0, 0),
    WIN_PARTS_ATTR(&partsItem[2], 32, 32, 32, 0),
    WIN_PARTS_ATTR(&partsItem[2], 32, 32, 32, 32),
    WIN_PARTS_ATTR(&partsItem[2], 32, 32, 0, 32),
};
static WinFrame frame601[] = {
    WIN_PARTS_ATTR(&partsItem[2], 32, 32, 0, 8),
    WIN_PARTS_ATTR(&partsItem[2], 32, 32, 24, 0),
    WIN_PARTS_ATTR(&partsItem[2], 32, 32, 32, 24),
    WIN_PARTS_ATTR(&partsItem[2], 32, 32, 8, 32),
};
static WinFrame frame602[] = {
    WIN_PARTS_ATTR(&partsItem[2], 32, 32, 0, 16),
    WIN_PARTS_ATTR(&partsItem[2], 32, 32, 16, 0),
    WIN_PARTS_ATTR(&partsItem[2], 32, 32, 32, 16),
    WIN_PARTS_ATTR(&partsItem[2], 32, 32, 16, 32),
};
static WinFrame frame603[] = {
    WIN_PARTS_ATTR(&partsItem[2], 32, 32, 0, 24),
    WIN_PARTS_ATTR(&partsItem[2], 32, 32, 8, 0),
    WIN_PARTS_ATTR(&partsItem[2], 32, 32, 32, 8),
    WIN_PARTS_ATTR(&partsItem[2], 32, 32, 24, 32),
};

/* Aj[V邽߂̃t[̑gݍ킹(`̏)𖾋L */
static WinFrameSet frameSet00[] = {
                /* FRAME p[c */
    WIN_FRAME_ATTR(frame000, 1),
};
static WinFrameSet frameSet10[] = {
    WIN_FRAME_ATTR(frame100, 1),
    WIN_FRAME_ATTR(frame101, 1),
    WIN_FRAME_ATTR(frame102, 1),
    WIN_FRAME_ATTR(frame103, 1),
};
static WinFrameSet frameSet20[] = {
    WIN_FRAME_ATTR(frame200, 4),
    WIN_FRAME_ATTR(frame201, 4),
    WIN_FRAME_ATTR(frame202, 4),
    WIN_FRAME_ATTR(frame203, 4),
};
static WinFrameSet frameSet21[] = {
    WIN_FRAME_ATTR(frame200, 4),
    WIN_FRAME_ATTR(frame203, 4),
    WIN_FRAME_ATTR(frame202, 4),
    WIN_FRAME_ATTR(frame201, 4),
};
static WinFrameSet frameSet30[] = {
    WIN_FRAME_ATTR(frame300, 1),
    WIN_FRAME_ATTR(frame301, 2),
    WIN_FRAME_ATTR(frame302, 2),
    WIN_FRAME_ATTR(frame303, 2),
    WIN_FRAME_ATTR(frame304, 1),
    WIN_FRAME_ATTR(frame303, 2),
    WIN_FRAME_ATTR(frame302, 2),
    WIN_FRAME_ATTR(frame301, 2),
};
static WinFrameSet frameSet31[] = {
    WIN_FRAME_ATTR(frame310, 1),
    WIN_FRAME_ATTR(frame311, 2),
    WIN_FRAME_ATTR(frame312, 2),
    WIN_FRAME_ATTR(frame313, 2),
    WIN_FRAME_ATTR(frame314, 1),
    WIN_FRAME_ATTR(frame313, 2),
    WIN_FRAME_ATTR(frame312, 2),
    WIN_FRAME_ATTR(frame311, 2),
};
static WinFrameSet frameSet40[] = {
    WIN_FRAME_ATTR(frame400, 2),
};
static WinFrameSet frameSet41[] = {
    WIN_FRAME_ATTR(frame410, 2),
};
static WinFrameSet frameSet50[] = {
    WIN_FRAME_ATTR(frame500, 1),
};
static WinFrameSet frameSet51[] = {
    WIN_FRAME_ATTR(frame510, 1),
};
static WinFrameSet frameSet60[] = {
    WIN_FRAME_ATTR(frame600, 4),
    WIN_FRAME_ATTR(frame601, 4),
    WIN_FRAME_ATTR(frame602, 4),
    WIN_FRAME_ATTR(frame603, 4),
};
static WinFrameSet frameSet61[] = {
    WIN_FRAME_ATTR(frame600, 4),
    WIN_FRAME_ATTR(frame601, 4),
    WIN_FRAME_ATTR(frame602, 4),
    WIN_FRAME_ATTR(frame603, 4),
};

/* {^ɕ\Aj[V̓𖾋L({^Kv) */
static WinAnimation animOn[] = {
               /* frameSet t[ TCY AjԊu */
    WIN_FRAMESET_ATTR(frameSet00, 1, 64, 64, 0),
    WIN_FRAMESET_ATTR(frameSet10, 4, 64, 64, 5),
    WIN_FRAMESET_ATTR(frameSet20, 4, 64, 64, 20),
    WIN_FRAMESET_ATTR(frameSet30, 8, 64, 64, 10),
    WIN_FRAMESET_ATTR(frameSet40, 2, 64, 64, 0),
    WIN_FRAMESET_ATTR(frameSet50, 1, 32, 128, 0),
    WIN_FRAMESET_ATTR(frameSet60, 4, 64, 64, 10),
};
static WinAnimation animOff[] = {
    WIN_FRAMESET_ATTR(frameSet00, 1, 64, 64, 0),
    WIN_FRAMESET_ATTR(frameSet10, 4, 64, 64, 60),
    WIN_FRAMESET_ATTR(frameSet21, 4, 64, 64, 20),
    WIN_FRAMESET_ATTR(frameSet31, 8, 64, 64, 10),
    WIN_FRAMESET_ATTR(frameSet41, 2, 64, 64, 0),
    WIN_FRAMESET_ATTR(frameSet51, 1, 64, 64, 0),
    WIN_FRAMESET_ATTR(frameSet61, 4, 64, 64, 10),
};

/* {^j[X^C錾 */
static WinBtnMenuStyle btnMenuStyle;

/* EBhEhc */
static Sint32 winID;

/*
######## O[o֐ ##################################################
*/

/*************************************************************************
 *  ֐  : njUserInit
 *  e    : 
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-23
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
void njUserInit(void)
{
    /* VXe */
    njInitSystem(NJD_RESOLUTION_VGA, NJD_FRAMEBUFFER_MODE_ARGB1555, 1);

    /* _f[^o^pobt@AP[g(1̒_*64/4oCg) */
    njInitVertexBuffer(MAX_VERTEXES * 64 / 4, 0, MAX_VERTEXES * 64 / 4, 0);

    /* }gNXX^bN */
    njInitMatrix(matrix, MAX_MATRIX_DEPTH, 1);

    /* RcVXȅ(f`̂߂̃[Nobt@) */
    njInit3D(vBuf, MAX_VERTEXES);

    /* ̎ނ߃CgVɐݒu(so^)
      (ʒu0,0,0ji0,0,-1) */
    njCreateLight(&light, NJD_DIR_LIGHT);

    /* r[̏(ʒu=0,0,0)(=0,0,-1)(X=0x) */
    njInitView(&view);

    /* [U̗pӂr[Jgr[Ɏw */
    njSetView(&view);

    /*eNX`i[̈ݒ*/
    njInitTexture(texMemList, MAX_TEXTURE_NUM);

    /* eNX`[h */
    njLoadTexture(&texList);

    /* obNOEhJ[ݒ */
    njSetBackColor(0xffff0000, 0xffff0000, 0xff000000);

    /* EBhEVXȅ */
    WinInit();

    /* {^j[̏ */
    btnMenuStyle.winPos.x = 100;        /* EBhEʒu */
    btnMenuStyle.winPos.y = 100;
    btnMenuStyle.winSize.x = 400;       /* EBhETCY */
    btnMenuStyle.winSize.y = 300;
    btnMenuStyle.winBgColor =
                ARGB(50, 0, 255, 0);    /* EBhEwiF */
    btnMenuStyle.btnPos.x = 20;         /* {^Q̈ʒu(EBhE) */
    btnMenuStyle.btnPos.y = 20;
    btnMenuStyle.btnNum = 7;            /* {^̐ */
    btnMenuStyle.btnRow = 2;            /* {^̉̐ */
    btnMenuStyle.btnClip.x = 2;         /* ɕ\{^ */
    btnMenuStyle.btnClip.y = 3;
    btnMenuStyle.pAnimOn = animOn;      /* Aj[Vzւ̃|C^ */
    btnMenuStyle.pAnimOff = animOff;
    btnMenuStyle.pTexList = &texList;   /* eNX`Xgւ̃|C^ */
    btnMenuStyle.btnSpace.x = 80;       /* {^Ԋu */
    btnMenuStyle.btnSpace.y = 80;
    btnMenuStyle.btnLayout =            /* {^̕ו */
        WINBTNMENU_LAYOUT_XCYC;
    btnMenuStyle.initialBtnID = 3;      /* ŏɃJ[\o{^ԍ */
    btnMenuStyle.moveFunc = MoveFunc;   /* J[\ړR[obN */
    btnMenuStyle.pushFunc = PushFunc;   /* {^R[obN */

    /* {^j[쐬 */
    winID = WinBtnMenu_CreateMenu(&btnMenuStyle);

    /* t[JE^̏ */
    wframe = 0;
    timer = GetCurrentTime();
    njPrintSize(16);
}


/*************************************************************************
 *  ֐  : njUserMain
 *  e    : s郁C
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-23
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: NJD_USER_CONTINUE
 *************************************************************************
 */
Sint32 njUserMain(void)
{
    /* EBhE[v */
    WinLoop();

    /* {^̕\ */
    njPrintC(NJM_LOCATION(0, 0), "CURRENT  = ");
    njPrintD(NJM_LOCATION(11, 0), curBtn, 2);
    njPrintC(NJM_LOCATION(0, 1), "LASTPUSH = ");
    njPrintD(NJM_LOCATION(11, 1), lastPush, 2);

    /* t[̌vZ */
    wframe++;
    if (GetCurrentTime() > (timer + (5 * 1000))) {
        frame = wframe / 5;
        wframe = 0;
        timer = GetCurrentTime();
    }
    njPrintD(NJM_LOCATION(27, 29), frame, 3);
    njPrintC(NJM_LOCATION(31, 29), "Frame/Sec");

    return NJD_USER_CONTINUE;
}

/*************************************************************************
 *  ֐  : njUserExit
 *  e    : I֐
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-23
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
void njUserExit(void)
{
    /* eNX` */
    njExitTexture();
    /* VXȅI */
    njExitSystem();
}

/*
######## [J֐ ####################################################
*/

/*************************************************************************
 *  ֐  : MoveFunc
 *  e    : J[\ړuԂɌĂ΂R[obN
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-23
 *  Rg:
 *------------------------------------------------------------------------
 *  in : Sint32 btnID ({^ԍ)
 *  out: void
 *************************************************************************
 */
static void MoveFunc(Sint32 btnID)
{
    curBtn = btnID;
}

/*************************************************************************
 *  ֐  : PushFunc
 *  e    : {^ꂽuԂɌĂ΂R[obN
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-23
 *  Rg:
 *------------------------------------------------------------------------
 *  in : Sint32 btnID ({^ԍ)
 *  out: void
 *************************************************************************
 */
static void PushFunc(Sint32 btnID)
{
    lastPush = btnID;
}

/*
######## ܂ ########################################################
*/

