
/*************************************************************************
 *  t@C     : winbtn.c
 *  e           : {^Ǘ
 *  vtBbNX : WinBtn
 *  쐬         :  j (Yoshio Hashiguchi)
 *  쐬         : 98-07-27
 *  Rg       :
 *  o[W     : 1.00
 ************************************************************************/

#define __WINBTN_C

/*
######## CN[ht@C ########
*/

#include <htwindow.h>
#include "winsys.h"
#include "winanim.h"
#include "winbtn.h"

/*
######## 萔錾 ########
*/

enum { /* {^(rbgtO(1,2,4,8...)) */
    BTNSTATE_CURSOR_ON = 1,
    BTNSTATE_CLIP_IN = 2,

    BTNSTATE_END
};

/*
######## }N ########
*/

/*
######## \̐錾 ########
*/

/*
######## ÓIϐ ########
*/

/*
######## Ŏg֐̃vg^Cv錾 ########
*/

static void ButtonMethod(WinBtn* pBtn, Sint32 state);

/*
######## O[o֐ ##################################################
*/

/*************************************************************************
 *  ֐    : WinBtn_CreateBtn
 *  e    : {^P(o^)
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-23
 *  Rg:
 *------------------------------------------------------------------------
 *  in : WinBtn* pBtn ({^\̂ւ̃|C^)
 *  out: void
 *************************************************************************
 */
void WinBtn_CreateBtn(WinBtn* pBtn)
{
    HTManagedGadget(pBtn->win, (LPHTWINGadget)pBtn);
    pBtn->node.method = ButtonMethod;
}

/*************************************************************************
 *  ֐    : WinBtn_RemoveBtn
 *  e    : {^P(Ǘ͂)
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-27
 *  Rg:
 *------------------------------------------------------------------------
 *  in : WinBtn* pBtn ({^\̂ւ̃|C^)
 *  out: void
 *************************************************************************
 */
void WinBtn_RemoveBtn(WinBtn* pBtn)
{
    HTUnManagedGadget(pBtn->win, (LPHTWINGadget)pBtn);
}

/*************************************************************************
 *  ֐    : WinBtn_SetCursorFlag
 *  e    : {^̃J[\tOύX
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-23
 *  Rg:
 *------------------------------------------------------------------------
 *  in : WinBtn* pBtn ({^\̂ւ̃|C^)
 *       Sint32 flag (tOWINBTN_CURSOR)
 *  out: void
 *************************************************************************
 */
void WinBtn_SetCursorFlag(WinBtn* pBtn, Sint32 flag)
{
    switch (flag) {
    case WINBTN_CURSOR_ON : /* J[\ */
        pBtn->state |= BTNSTATE_CURSOR_ON;
        break;
    case WINBTN_CURSOR_OFF : /* J[\ĂȂ */
        pBtn->state &= ~BTNSTATE_CURSOR_ON;
        break;
    }
}

/*************************************************************************
 *  ֐    : WinBtn_SetClipFlag
 *  e    : {^̃NbvtOύX
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-23
 *  Rg:
 *------------------------------------------------------------------------
 *  in : WinBtn* pBtn ({^\̂ւ̃|C^)
 *       Sint32 flag (tOWINBTN_CLIP)
 *  out: void
 *************************************************************************
 */
void WinBtn_SetClipFlag(WinBtn* pBtn, Sint32 flag)
{
    switch (flag) {
    case WINBTN_CLIP_IN : /* Nbv */
        pBtn->state |= BTNSTATE_CLIP_IN;
        break;
    case WINBTN_CLIP_OUT : /* NbvO */
        pBtn->state &= ~BTNSTATE_CLIP_IN;
        break;
    }
}

/*************************************************************************
 *  ֐    : WinBtn_DrawBtn
 *  e    : {^\
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-23
 *  Rg:
 *------------------------------------------------------------------------
 *  in : WinBtn* pBtn ({^f[^ւ̃|C^)
 *  out: void
 *************************************************************************
 */
void WinBtn_DrawBtn(WinBtn* pBtn)
{
    /* ԃtÕ`FbN */
    /* NbvOȂ\Ȃ */
    if (!(pBtn->state & BTNSTATE_CLIP_IN)) {
        return;
    }
    /* J[\Ă */
    if (pBtn->state & BTNSTATE_CURSOR_ON) {
        WinAnim_DrawAnimation(pBtn->pAnimOn, &pBtn->animTimer, &pBtn->pos);
    }
    /* J[\ĂȂ */
    else {
        WinAnim_DrawAnimation(pBtn->pAnimOff, &pBtn->animTimer, &pBtn->pos);
    }
}

/*
######## [J֐ ####################################################
*/

/*************************************************************************
 *  ֐  : ButtonMethod
 *  e    : {^̕WR[obN
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-23
 *  Rg:
 *------------------------------------------------------------------------
 *  in : WinBtn* pBtn ({^\̂ւ̃|C^)
 *       Sint32 state ()
 *  out: void
 *************************************************************************
 */
static void ButtonMethod(WinBtn* pBtn, Sint32 state)
{
    switch (state) {
    case GADGET_NONE: /* J[\ĂȂ */
        WinBtn_DrawBtn(pBtn);
        break;
    case GADGET_ONBUTTON: /* J[\Ă */
        /* {^̃R[obNΌĂ */
        if (pBtn->onBtnAction != NULL) {
            pBtn->onBtnAction(pBtn);
        }
        else {
            WinBtn_DrawBtn(pBtn);
        }
        /* J[\g\ */
        HTtDrawBox((Float)pBtn->pos.x - 1, (Float)pBtn->pos.y - 1,
                   (Float)pBtn->pos.x + pBtn->pAnimOn->size.x - 1 + 1,
                   (Float)pBtn->pos.y + pBtn->pAnimOn->size.y - 1 + 1,
                   0, 0x0000ffff);
        HTtDrawBox((Float)pBtn->pos.x - 2, (Float)pBtn->pos.y - 2,
                   (Float)pBtn->pos.x + pBtn->pAnimOn->size.x -1 + 2,
                   (Float)pBtn->pos.y + pBtn->pAnimOn->size.y -1 + 2,
                   0, 0x0000ffff);
        break;
    case GADGET_PUSH: /* {^ꂽ */
        /* {^̃R[obNΌĂ */
        if (pBtn->pushAction != NULL) {
            pBtn->pushAction(pBtn);
        }
        else {
            WinBtn_DrawBtn(pBtn);
        }
        break;
    }
}

/*
######## ܂ ########################################################
*/
