
/*************************************************************************
 *  t@C     : winbtn.h
 *  e           : {^Ǘ
 *  vtBbNX : WinBtn
 *  쐬         :  j (Yoshio Hashiguchi)
 *  쐬         : 98-07-27
 *  Rg       :
 *  o[W     : 1.00
 ************************************************************************/

#ifndef __WINBTN_H
#define __WINBTN_H

/*
######## CN[ht@C ########
*/

#include <htwindow.h>
#include "winsys.h"
#include "winanim.h"

/*
######## 萔錾 ########
*/

enum { /* J[\tO */
    WINBTN_CURSOR_ON,  /* J[\Ă */
    WINBTN_CURSOR_OFF, /* J[\ĂȂ */

    WINBTN_CURSOR_END
};

enum { /* NbvtO */
    WINBTN_CLIP_IN,  /* Nbv */
    WINBTN_CLIP_OUT, /* NbvO */

    WINBTN_CLIP_END
};

/*
######## }N ########
*/

/*
######## \̐錾 ########
*/

typedef struct { /* {^\ */
    HTWINGadget node;                  /* KWFbgm[h(擪ɕK{) */

    HTWINHANDLE win;                   /* {^Ԃ牺ĂEBhE */
    Sint32 btnID;                      /* {^hc */
    WinXY32 pos;                       /* {^ʒu(EBhE) */
    Sint32 state;                      /* {^(rbgtȌW܂) */

    WinAnimation* pAnimOn;             /* J[\IAjւ̃|C^ */
    WinAnimation* pAnimOff;            /* J[\ItAjւ̃|C^ */
    Sint32 animTimer;                  /* Aj[Ṽ^C}[ */

    LPHtWinGadgetCallBack pushAction;  /* {^̃R[obN */
    LPHtWinGadgetCallBack onBtnAction; /* {^ɗ̃R[obN */
} WinBtn;

/*
######## O[oϐ ########
*/

/*
######## ֐̐ƃvg^Cv錾 ########
*/

/*************************************************************************
 *  ֐    : WinBtn_CreateBtn
 *  e    : {^P(o^)
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-23
 *  Rg:
 *------------------------------------------------------------------------
 *  in : WinBtn* pBtn ({^\̂ւ̃|C^)
 *  out: void
 *************************************************************************
 */
void WinBtn_CreateBtn(WinBtn* pBtn);

/*************************************************************************
 *  ֐    : WinBtn_RemoveBtn
 *  e    : {^P(Ǘ͂)
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-27
 *  Rg:
 *------------------------------------------------------------------------
 *  in : WinBtn* pBtn ({^\̂ւ̃|C^)
 *  out: void
 *************************************************************************
 */
void WinBtn_RemoveBtn(WinBtn* pBtn);

/*************************************************************************
 *  ֐    : WinBtn_SetCursorFlag
 *  e    : {^̃J[\tOύX
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-23
 *  Rg:
 *------------------------------------------------------------------------
 *  in : WinBtn* pBtn ({^\̂ւ̃|C^)
 *       Sint32 flag (tOWINBTN_CURSOR)
 *  out: void
 *************************************************************************
 */
void WinBtn_SetCursorFlag(WinBtn* pBtn, Sint32 flag);

/*************************************************************************
 *  ֐    : WinBtn_SetClipFlag
 *  e    : {^̃NbvtOύX
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-23
 *  Rg:
 *------------------------------------------------------------------------
 *  in : WinBtn* pBtn ({^\̂ւ̃|C^)
 *       Sint32 flag (tOWINBTN_CLIP)
 *  out: void
 *************************************************************************
 */
void WinBtn_SetClipFlag(WinBtn* pBtn, Sint32 flag);

/*************************************************************************
 *  ֐    : WinBtn_DrawBtn
 *  e    : {^\
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-23
 *  Rg:
 *------------------------------------------------------------------------
 *  in : WinBtn* pBtn ({^\̂ւ̃|C^)
 *  out: void
 *************************************************************************
 */
void WinBtn_DrawBtn(WinBtn* pBtn);

#endif /* __WINBTN_H */

/*
######## ܂ ########
*/

