
/*************************************************************************
 *  t@C     : winbtnmenu.c
 *  e           : {^j[EBhE쐬Ǘ
 *  vtBbNX : WinBtnMenu
 *  쐬         :  j (Yoshio Hashiguchi)
 *  쐬         : 98-07-27
 *  Rg       :
 *  o[W     : 1.00
 ************************************************************************/

#define __WINBTNMENU_C

/*
######## CN[ht@C ########
*/

#include <htwindow.h>
#include "winsys.h"
#include "winbtn.h"
#include "winbtnmenu.h"

/*
######## 萔錾 ########
*/

#define MAXBTNMENUNUM 8   /* W\łH */

/*
######## }N ########
*/

/*
######## \̐錾 ########
*/

/* ŊǗ{^j[\ */
typedef struct {
    WinBtnMenuStyle style;   /* [U[ݒ肵X^C炤 */
    WinBtn* pBtn;            /* {^z̐擪ւ̃|C^ */
    Sint32 curBtnID;         /* {^j[݂̌̃{^ԍ */
    Sint32 lefttopBtnID;     /* ʏ̒ł̍̃{^ԍ */
} BtnMenu;

/* ̃{^j[Ǘ\ */
typedef struct {
    HTWINHANDLE win;   /* {^j[̃EBhEhc */
    BtnMenu* pBtnMenu; /* {^j[f[^ւ̃|C^ */
} BtnMenuManager;

/*
######## ÓIϐ ########
*/

static Sint32 btnMenuNum = 0; /* ݂̃j[ */
static BtnMenuManager btnMenuManager[MAXBTNMENUNUM]; /* j[̊Ǘ */

/*
######## Ŏg֐̃vg^Cv錾 ########
*/

static void WinProc(HTWINHANDLE win);
static void PushBtnAction(WinBtn* btn);
static void OnBtnAction(WinBtn* btn);
static void BtnMove(Sint32 menuID, Sint32 newBtnID);

/*
######## O[o֐ ##################################################
*/

/*************************************************************************
 *  ֐    : WinBtnMenu_CreateMenu
 *  e    : {^j[EBhE̍쐬
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-27
 *  Rg:
 *------------------------------------------------------------------------
 *  in : WinBtnMenuStyle* pBtnMenuStyle
 *       ({^j[X^C\̂ւ̃|C^)
 *  out: Sint32 win (EBhÊhc)
 *************************************************************************
 */
Sint32 WinBtnMenu_CreateMenu(WinBtnMenuStyle* pBtnMenuStyle)
{
    HTWINHANDLE win;
    BtnMenu* pBtnMenu;
    WinBtnMenuStyle* pStyle;
    WinBtn* pNewBtn;
    WinXY32 maxClip;

    if (btnMenuNum >= MAXBTNMENUNUM - 1) { /* EBhE̐ */
        return -1;
    }

    /* V{^j[p̃m */
    pBtnMenu = malloc(sizeof(BtnMenu));

    /* [U[̐ݒ肵j[X^C܂܃Rs[ */
    pStyle = &pBtnMenu->style;
    *pStyle = *pBtnMenuStyle;

    /* ő̃Nbv̈̌vZi{^Pʁj */
    maxClip.x = pStyle->btnRow;
    maxClip.y = (pStyle->btnNum - 1) / pStyle->btnRow + 1;

    /* Nbv̈敝`FbN(ςȂƂ͍őorŏɂ킹) */
    if (pStyle->btnClip.x < 1) {
        pStyle->btnClip.x = 1;
    }
    else if (pStyle->btnClip.x > maxClip.x) {
        pStyle->btnClip.x = maxClip.x;
    }
    if (pStyle->btnClip.y < 1) {
        pStyle->btnClip.y = 1;
    }
    else if (pStyle->btnClip.y > maxClip.y) {
        pStyle->btnClip.y = maxClip.y;
    }

    /* {^̏J[\ʒu`FbN(ςȂƂ͍őorŏɂ킹) */
    if (pStyle->initialBtnID < 0) {
        pStyle->initialBtnID = 0;
    }
    if (pStyle->initialBtnID > pStyle->btnNum - 1) {
        pStyle->initialBtnID = pStyle->btnNum - 1;
    }

    /* EBhE쐬 */
    win = HTCreateSimpleWindow(
        (Float)(pStyle->winPos.x),
        (Float)(pStyle->winPos.y),
        (Float)(pStyle->winPos.x + pStyle->winSize.x),
        (Float)(pStyle->winPos.y + pStyle->winSize.y),
        ARGB(0, 0, 0, 0), pStyle->winBgColor);

    /* EBhẼeNX`Xgݒ */
    HTSetTextureList(win, pStyle->pTexList);

    /* EBhEWR[obN֐ݒ */
    HTSetWinProc(win, WinProc);

    /* {^pm */
    pNewBtn = malloc(sizeof(WinBtn) * pStyle->btnNum);

    { /* {^(btnNum̐) */
        Sint32 i;
        WinBtn* pBtn;
        for (i = 0; i < pStyle->btnNum; i++) {
            pBtn = &pNewBtn[i];
            pBtn->win = win;
            pBtn->btnID = i;
            pBtn->state = 0;
            /* {^ʒuݒ */
            pBtn->pos.x = pStyle->btnPos.x +
                (pStyle->btnSpace.x * (i % pStyle->btnRow));
            pBtn->pos.y = pStyle->btnPos.y +
                (pStyle->btnSpace.y * (i / pStyle->btnRow));
            /* Aj[Vݒ */
            pBtn->pAnimOn = &pStyle->pAnimOn[i];
            pBtn->pAnimOff = &pStyle->pAnimOff[i];
            pBtn->animTimer = 0;
            /* R[obNݒ */
            pBtn->pushAction = PushBtnAction;
            pBtn->onBtnAction = OnBtnAction;
            /* {^ʒuוɂ킹ĕ␳ */
            switch (pStyle->btnLayout) {
            case WINBTNMENU_LAYOUT_XCYC: /* wZ^O */
            case WINBTNMENU_LAYOUT_XCYT:
            case WINBTNMENU_LAYOUT_XCYB:
                if (i == 0) { /* OԂ̃{^̓J[\Ȉ */
                    pBtn->pos.x +=
                        (pStyle->btnSpace.x - pBtn->pAnimOn->size.x) / 2;
                }
                else {
                    pBtn->pos.x +=
                        (pStyle->btnSpace.x - pBtn->pAnimOff->size.x) / 2;
                }
                break;
            case WINBTNMENU_LAYOUT_XRYC: /* wE */
            case WINBTNMENU_LAYOUT_XRYT:
            case WINBTNMENU_LAYOUT_XRYB:
                if (i == 0) {
                    pBtn->pos.x +=
                        (pStyle->btnSpace.x - pBtn->pAnimOn->size.x);
                }
                else {
                    pBtn->pos.x +=
                        (pStyle->btnSpace.x - pBtn->pAnimOff->size.x);
                }
                break;
            }
            switch (pStyle->btnLayout) {
            case WINBTNMENU_LAYOUT_XCYC: /* xZ^O */
            case WINBTNMENU_LAYOUT_XLYC:
            case WINBTNMENU_LAYOUT_XRYC:
                if (i == 0) {
                    pBtn->pos.y +=
                        (pStyle->btnSpace.y - pBtn->pAnimOn->size.y) / 2;
                }
                else {
                    pBtn->pos.y +=
                        (pStyle->btnSpace.y - pBtn->pAnimOff->size.y) / 2;
                }
                break;
            case WINBTNMENU_LAYOUT_XCYB: /* x */
            case WINBTNMENU_LAYOUT_XLYB:
            case WINBTNMENU_LAYOUT_XRYB:
                if (i == 0) {
                    pBtn->pos.y +=
                        (pStyle->btnSpace.y - pBtn->pAnimOn->size.y);
                }
                else {
                    pBtn->pos.y +=
                        (pStyle->btnSpace.y - pBtn->pAnimOff->size.y);
                }
                break;
            }
            /* {^o^ */
            WinBtn_CreateBtn(pBtn);
            /* {^I\ɂ */
            HTSetGadgetSelectable((LPHTWINGadget)pBtn);
        }
    }

    /* {^j[̃oݒ */
    pBtnMenu->pBtn = pNewBtn;
    pBtnMenu->curBtnID = 0;
    pBtnMenu->lefttopBtnID = 0;

    /* Ǘf[^XV */
    btnMenuManager[btnMenuNum].win = win;
    btnMenuManager[btnMenuNum].pBtnMenu = pBtnMenu;

    /* ̃{^ʒuֈړ */
    BtnMove(btnMenuNum, maxClip.x * maxClip.y - 1); /* ܂łE */
    BtnMove(btnMenuNum, pStyle->initialBtnID); /* オĂ */
    /* j[ɃR[obNΌĂ */
    if (pStyle->moveFunc != NULL) {
        pStyle->moveFunc(pStyle->initialBtnID);
    }
    /* {^̏ʒuݒ */
    HTSetGadgetDefault(win,
        (LPHTWINGadget)(&pNewBtn[pStyle->initialBtnID]));

    /* EBhE}bv */
    HTMapWindow(win);

    /* {^j[̐𑝂₷ */
    btnMenuNum++;

    return (Sint32)(win);
}

/*************************************************************************
 *  ֐    : WinBtnMenu_CloseMenu
 *  e    : {^j[EBhȄI
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-27
 *  Rg:
 *------------------------------------------------------------------------
 *  in : Sint32 win (EBhÊhc)
 *  out: void
 *************************************************************************
 */
void WinBtnMenu_CloseMenu(Sint32 win)
{
    Sint32 i, j;
    BtnMenu* pBtnMenu;
    WinBtnMenuStyle* pStyle;

    for (i = 0; i < btnMenuNum; i++) {
        /* EBhEĂ郁j[T */
        if (btnMenuManager[i].win == (HTWINHANDLE)win) {
            pBtnMenu = btnMenuManager[i].pBtnMenu;
            pStyle = &pBtnMenu->style;
            /* {^S */
            for (j = 0; j < pStyle->btnNum; j++) {
                WinBtn_RemoveBtn(&pBtnMenu->pBtn[j]);
            }
            /* {^p */
            free(pBtnMenu->pBtn);
            /* {^j[p */
            free(pBtnMenu);
            /* EBhE */
            HTCloseWindow(btnMenuManager[i].win);
            /* Ǘf[^l߂ */
            for (j = i; j < btnMenuNum - 1; j++) {
                btnMenuManager[j] = btnMenuManager[j+1];
            }
            /* {^j[̐炷 */
            btnMenuNum--;
            /* VJgj[̃{^ړR[obNĂ */
            if (btnMenuNum > 0) {
                Sint32 menuID = btnMenuNum - 1;
                pBtnMenu = btnMenuManager[menuID].pBtnMenu;
                pStyle = &pBtnMenu->style;
                if (pStyle->moveFunc != NULL) {
                    pStyle->moveFunc(pBtnMenu->curBtnID);
                }
            }
            return;
        }
    }
}

/*
######## [J֐ ####################################################
*/

/*************************************************************************
 *  ֐  : WinProc
 *  e    : EBhE̕WR[obN֐
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-27
 *  Rg:
 *------------------------------------------------------------------------
 *  in : HTWINHANDLE win EBhEhc
 *  out: void
 *************************************************************************
 */
static void WinProc(HTWINHANDLE win)
{
    Sint32 i;
    WinXY32 p0, p1; /* Nbv̈g̍W (さE) */
    WinBtnMenuStyle* pStyle;

    for (i = 0; i < btnMenuNum; i++) {
        /* EBhEĂ郁j[T */
        if (btnMenuManager[i].win == win) {
            pStyle = &btnMenuManager[i].pBtnMenu->style;
            /* Nbv̈g̕\ */
            p0.x = pStyle->btnPos.x;
            p0.y = pStyle->btnPos.y;
            p1.x = pStyle->btnPos.x + pStyle->btnClip.x * pStyle->btnSpace.x;
            p1.y = pStyle->btnPos.y + pStyle->btnClip.y * pStyle->btnSpace.y;
            HTtDrawBox((Float)p0.x - 3, (Float)p0.y - 3,
                       (Float)p1.x + 3, (Float)p1.y + 3, 0, 0x00ff00ff);
            break;
        }
    }
}

/*************************************************************************
 *  ֐  : PushBtnAction
 *  e    : {^ꂽƂɌĂ΂R[obN
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-27
 *  Rg:
 *------------------------------------------------------------------------
 *  in : WinBtn* pBtn ({^\̂ւ̃|C^)
 *  out: void
 *************************************************************************
 */
static void PushBtnAction(WinBtn* pBtn)
{
    Sint32 i;
    WinBtnMenuStyle* pStyle;

    for (i = 0; i < btnMenuNum; i++) {
        /* {^Ԃ牺Ă郁j[T */
        if (btnMenuManager[i].win == pBtn->win) {
            pStyle = &btnMenuManager[i].pBtnMenu->style;
            /* j[ɃR[obNΌĂ */
            if (pStyle->pushFunc != NULL) {
                pStyle->pushFunc(pBtn->btnID);
            }
            break;
        }
    }
    /* {^\ */
    WinBtn_DrawBtn(pBtn);
}

/*************************************************************************
 *  ֐  : OnBtnAction
 *  e    : {^ɃJ[\ƂɌĂ΂R[obN
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-27
 *  Rg:
 *------------------------------------------------------------------------
 *  in : WinBtn* pBtn ({^\̂ւ̃|C^)
 *  out: void
 *************************************************************************
 */
static void OnBtnAction(WinBtn* pBtn)
{
    Sint32 i;
    BtnMenu* pBtnMenu;
    WinBtnMenuStyle* pStyle;

    for (i = 0; i < btnMenuNum; i++) {
        /* {^Ԃ牺Ă郁j[T */
        if (btnMenuManager[i].win == pBtn->win) {
            pBtnMenu = btnMenuManager[i].pBtnMenu;
            /* {^ʒuړĂ΍XV */
            if (pBtnMenu->curBtnID != pBtn->btnID) {
                pStyle = &pBtnMenu->style;
                /* {^ʒuXV */
                BtnMove(i, pBtn->btnID);
                /* j[ɃR[obNΌĂ */
                if (pStyle->moveFunc != NULL) {
                    pStyle->moveFunc(pBtn->btnID);
                }
            }
            break;
        }
    }
    /* {^\ */
    WinBtn_DrawBtn(pBtn);
}

/*************************************************************************
 *  ֐  : BtnMove
 *  e    : EBhEj[̃{^J[\ʒuXV
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-27
 *  Rg:
 *------------------------------------------------------------------------
 *  in : Sint32 menuID ({^j[̊Ǘԍ)
 *     : Sint32 newBtnID (V{^ԍ)
 *  out: void
 *************************************************************************
 */
static void BtnMove(Sint32 menuID, Sint32 newBtnID)
{
    BtnMenu* pBtnMenu = btnMenuManager[menuID].pBtnMenu;
    WinBtnMenuStyle* pStyle = &pBtnMenu->style;
    Sint32 oldBtnID = pBtnMenu->curBtnID;
    Sint32 lefttopBtnID = pBtnMenu->lefttopBtnID;

    Sint32 i;
    Sint32 x, y;

    /* ÂJ[\̃{^f[^XV */
    if (oldBtnID < pStyle->btnNum) {
        WinBtn* pBtn = &pBtnMenu->pBtn[oldBtnID];
        /* Aj[Ṽ^C}[߂ */
        pBtn->animTimer = 0;
        /* {^̃J[\tOύX */
        WinBtn_SetCursorFlag(pBtn, WINBTN_CURSOR_OFF);
        /* {^ʒuוɂ킹ĕ␳ */
        switch (pStyle->btnLayout) {
        case WINBTNMENU_LAYOUT_XCYC: /* wZ^O */
        case WINBTNMENU_LAYOUT_XCYT:
        case WINBTNMENU_LAYOUT_XCYB:
            pBtn->pos.x +=
                (pBtn->pAnimOn->size.x - pBtn->pAnimOff->size.x) / 2;
            break;
        case WINBTNMENU_LAYOUT_XRYC: /* wE */
        case WINBTNMENU_LAYOUT_XRYT:
        case WINBTNMENU_LAYOUT_XRYB:
            pBtn->pos.x +=
                (pBtn->pAnimOn->size.x - pBtn->pAnimOff->size.x);
            break;
        }
        switch (pStyle->btnLayout) {
        case WINBTNMENU_LAYOUT_XCYC: /* xZ^O */
        case WINBTNMENU_LAYOUT_XLYC:
        case WINBTNMENU_LAYOUT_XRYC:
            pBtn->pos.y +=
                (pBtn->pAnimOn->size.y - pBtn->pAnimOff->size.y) / 2;
            break;
        case WINBTNMENU_LAYOUT_XCYB: /* x */
        case WINBTNMENU_LAYOUT_XLYB:
        case WINBTNMENU_LAYOUT_XRYB:
            pBtn->pos.y +=
                (pBtn->pAnimOn->size.y - pBtn->pAnimOff->size.y);
            break;
        }
    }

    /* ܂ŃI{^̃NbvtOׂăItɂ */
    for (x = 0; x < pStyle->btnClip.x; x++) {
        for (y = 0; y < pStyle->btnClip.y; y++) {
            Sint32 btnID = lefttopBtnID + x + pStyle->btnRow * y;
            if (btnID < pStyle->btnNum) {
                WinBtn_SetClipFlag(&pBtnMenu->pBtn[btnID], WINBTN_CLIP_OUT);
            }
        }
    }

    /* VJ[\̃{^Nbv̈OɂȂS{^ړ */
    {
        WinXY32 btnMove;
        btnMove.x = (newBtnID % pStyle->btnRow) -
                    (lefttopBtnID % pStyle->btnRow);
        if (btnMove.x > 0) { /* ݂EɈڂꍇ */
            /* Nbv̈̉E[Ƀ{^΂nj */
            btnMove.x -= (pStyle->btnClip.x - 1);
            if (btnMove.x < 0) { /* ̃Nbv̈ɂΈړiV */
                btnMove.x = 0;
            }
        }
        btnMove.y = (newBtnID / pStyle->btnRow) -
                    (lefttopBtnID / pStyle->btnRow);
        if (btnMove.y > 0) { /* ݂Ɉڂꍇ */
            /* Nbv̈̉[Ƀ{^΂nj */
            btnMove.y -= (pStyle->btnClip.y - 1);
            if (btnMove.y < 0) { /* ̃Nbv̈ɂΈړiV */
                btnMove.y = 0;
            }
        }
        /* ړ͈͂̕S{^𓮂 */
        for (i = 0; i < pStyle->btnNum; i++) {
            pBtnMenu->pBtn[i].pos.x -= (btnMove.x * pStyle->btnSpace.x);
            pBtnMenu->pBtn[i].pos.y -= (btnMove.y * pStyle->btnSpace.y);
        }
        /* Nbv̈̍̃{^ԍXV */
        lefttopBtnID += (btnMove.x + (btnMove.y * pStyle->btnRow));
    }

    /* VJ[\̃{^f[^XV */
    if (newBtnID < pStyle->btnNum) {
        WinBtn* pBtn = &pBtnMenu->pBtn[newBtnID];
        /* Aj[Ṽ^C}[߂ */
        pBtn->animTimer = 0;
        /* {^̃J[\tOύX */
        WinBtn_SetCursorFlag(pBtn, WINBTN_CURSOR_ON);
        /* {^ʒuוɂ킹ĕ␳ */
        switch (pStyle->btnLayout) {
        case WINBTNMENU_LAYOUT_XCYC: /* wZ^O */
        case WINBTNMENU_LAYOUT_XCYT:
        case WINBTNMENU_LAYOUT_XCYB:
            pBtn->pos.x +=
                (pBtn->pAnimOff->size.x - pBtn->pAnimOn->size.x) / 2;
            break;
        case WINBTNMENU_LAYOUT_XRYC: /* wE */
        case WINBTNMENU_LAYOUT_XRYT:
        case WINBTNMENU_LAYOUT_XRYB:
            pBtn->pos.x +=
                (pBtn->pAnimOff->size.x - pBtn->pAnimOn->size.x);
            break;
        }
        switch (pStyle->btnLayout) {
        case WINBTNMENU_LAYOUT_XCYC: /* xZ^O */
        case WINBTNMENU_LAYOUT_XLYC:
        case WINBTNMENU_LAYOUT_XRYC:
            pBtn->pos.y +=
                (pBtn->pAnimOff->size.y - pBtn->pAnimOn->size.y) / 2;
            break;
        case WINBTNMENU_LAYOUT_XCYB: /* x */
        case WINBTNMENU_LAYOUT_XLYB:
        case WINBTNMENU_LAYOUT_XRYB:
            pBtn->pos.y +=
                (pBtn->pAnimOff->size.y - pBtn->pAnimOn->size.y);
            break;
        }
    }

    /* VNbv̈̃{^̕\tOIɂ */
    for (x = 0; x < pStyle->btnClip.x; x++) {
        for (y = 0; y < pStyle->btnClip.y; y++) {
            Sint32 btnID = lefttopBtnID + x + pStyle->btnRow * y;
            WinBtn_SetClipFlag(&pBtnMenu->pBtn[btnID], WINBTN_CLIP_IN);
        }
    }

    /* Ǘf[^XV */
    pBtnMenu->curBtnID = newBtnID;
    pBtnMenu->lefttopBtnID = lefttopBtnID;
}

/*
######## ܂ ########################################################
*/

