
/*************************************************************************
 *  t@C     : winbtn.h
 *  e           : {^Ǘ
 *  vtBbNX : WinBtn
 *  쐬         :  j (Yoshio Hashiguchi)
 *  쐬         : 98-07-30
 *  Rg       :
 *  o[W     : 1.00
 ************************************************************************/

#ifndef __WINBTN_H
#define __WINBTN_H

/*
######## CN[ht@C ########
*/

#include <htwindow.h>
#include "wininterface.h"
#include "winanim.h"

/*
######## 萔錾 ########
*/

enum { /* tH[JXtO */
    WINBTN_FOCUS_ON,  /* tH[JXĂ */
    WINBTN_FOCUS_OFF, /* tH[JXĂȂ */

    WINBTN_FOCUS_END
};

enum { /* NbvtO */
    WINBTN_CLIP_IN,  /* Nbv */
    WINBTN_CLIP_OUT, /* NbvO */

    WINBTN_CLIP_END
};

enum { /* J[\g̎ */
    WINBTN_CURSOR_NONE,  /* J[\\Ȃ */
    WINBTN_CURSOR_FRAME, /* t[g */

    WINBTN_CURSOR_END
};

/*
######## }N ########
*/

/*
######## \̐錾 ########
*/

typedef struct { /* {^\ */
    HTWINGadget node;                  /* KWFbgm[h(擪ɕK{) */

    HTWINHANDLE win;                   /* {^Ԃ牺ĂEBhE */
    Sint32 btnID;                      /* {^hc */
    WinXY32 pos;                       /* {^ʒu(EBhE) */
    Sint32 state;                      /* {^(rbgtȌW܂) */

    WinAnimation* pAnimOn;             /* tH[JXIAjւ̃|C^ */
    WinAnimation* pAnimOff;            /* tH[JXItAjւ̃|C^ */
    Sint32 animTimer;                  /* Aj[Ṽ^C}[ */
    Sint32 cursor;                     /* J[\̎(WINBTN_CURSOR) */

    LPHtWinGadgetCallBack pushAction;  /* {^̃R[obN */
    LPHtWinGadgetCallBack onBtnAction; /* {^ɗ̃R[obN */
} WinBtn;

/*
######## O[oϐ ########
*/

/*
######## ֐̐ƃvg^Cv錾 ########
*/

/*************************************************************************
 *  ֐    : WinBtn_CreateBtn
 *  e    : {^P(o^)
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-23
 *  Rg:
 *------------------------------------------------------------------------
 *  in : WinBtn* pBtn ({^\̂ւ̃|C^)
 *  out: void
 *************************************************************************
 */
void WinBtn_CreateBtn(WinBtn* pBtn);

/*************************************************************************
 *  ֐    : WinBtn_RemoveBtn
 *  e    : {^P(Ǘ͂)
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-27
 *  Rg:
 *------------------------------------------------------------------------
 *  in : WinBtn* pBtn ({^\̂ւ̃|C^)
 *  out: void
 *************************************************************************
 */
void WinBtn_RemoveBtn(WinBtn* pBtn);

/*************************************************************************
 *  ֐    : WinBtn_SetFocusFlag
 *  e    : {^̃tH[JXtOύX
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-30
 *  Rg:
 *------------------------------------------------------------------------
 *  in : WinBtn* pBtn ({^\̂ւ̃|C^)
 *       Sint32 flag (tOWINBTN_FOCUS)
 *  out: void
 *************************************************************************
 */
void WinBtn_SetFocusFlag(WinBtn* pBtn, Sint32 flag);

/*************************************************************************
 *  ֐    : WinBtn_SetClipFlag
 *  e    : {^̃NbvtOύX
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-23
 *  Rg:
 *------------------------------------------------------------------------
 *  in : WinBtn* pBtn ({^\̂ւ̃|C^)
 *       Sint32 flag (tOWINBTN_CLIP)
 *  out: void
 *************************************************************************
 */
void WinBtn_SetClipFlag(WinBtn* pBtn, Sint32 flag);

/*************************************************************************
 *  ֐    : WinBtn_DrawBtn
 *  e    : {^\
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-23
 *  Rg:
 *------------------------------------------------------------------------
 *  in : WinBtn* pBtn ({^\̂ւ̃|C^)
 *  out: void
 *************************************************************************
 */
void WinBtn_DrawBtn(WinBtn* pBtn);

#endif /* __WINBTN_H */

/*
######## ܂ ########
*/

