
/************************************************************
 *  t@C     : main.c
 *  e           :
 *  vtBbNX :
 *  쐬         :  j (Yoshio Hashiguchi)
 *  쐬         : 98-07-09 쐬Jn
 *  Rg       :
 *  o[W     : 0.01
************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}

#define TEXNUM 1
#define MAX_VERTEXES 100

static NJS_VERTEX_BUF *VBuf;

/*eNX`ݒ*/
static NJS_TEXNAME Texname[] = {
    {"tes_g.PVR", NJD_TEXATTR_GLOBALINDEX, 0 },
};
static NJS_TEXLIST Texlist = {Texname, TEXNUM};
static NJS_TEXMEMLIST Texmemlist[TEXNUM];

/************************************************************
  ֐
************************************************************/
void njUserInit(void)
{
    /* VXe */
    sbInitSystem(NJD_RESOLUTION_640x480_NTSCI,
                 NJD_FRAMEBUFFER_MODE_RGB565, 1);

    /* obt@pAP[g */
    VBuf = (NJS_VERTEX_BUF *)syMalloc(sizeof (NJS_VERTEX_BUF) * MAX_VERTEXES);

    /* obNOEhJ[ݒ */
    njSetBackColor(ARGB(0, 0, 0, 64), ARGB(0, 0, 0, 64), ARGB(0, 64, 0, 0));

    /* eNX`obt@̊m */
    njInitTextureBuffer((Sint8 *)VBuf, 0x2ab000); /* TWIDDLED1024 */

    /*_f[^o^pobt@AP[g*/
    njInitVertexBuffer(MAX_VERTEXES * 64 / 4, 0, MAX_VERTEXES * 64 / 4, 0);

    /*eNX`i[̈ݒ*/
    njInitTexture(Texmemlist, TEXNUM);

    /*eNX`[h*/
    njLoadTexture(&Texlist);

    /* JgeNX`XgTexlistɂ */
    njSetTexture(&Texlist);
    njSetTextureNum(0);

    /* ʂ̃AXyNg␳ */
    njSetAspect(1.0F, 1.0F);

    /* fobO̐F */
    njPrintColor(ARGB(255, 150, 150, 150));
}

/************************************************************
  s郁C
************************************************************/
Sint32 njUserMain(void)
{
    static NJS_POINT2 pnt[4] = { 0, 0, 640, 0, 640, 480, 0, 480 };
    static NJS_COLOR col[4] = {
        ARGB(150, 255, 255, 255), ARGB(150, 255, 255, 255),
        ARGB(150, 255, 255, 255), ARGB(150, 255, 255, 255),
    };
    static NJS_COLOR uv[4] = {
        UV(0, 0),
        UV(640.0F / 1024.0F * 255.0F, 0),
        UV(640.0F / 1024.0F * 255.0F, 480.0F / 1024.0F * 255.0F),
        UV(0, 480.0F / 1024.0F * 255.0F),
    };
    static NJS_POINT2COL p2c = { pnt, col, uv, 4 };

    njDrawPolygon2D(&p2c, 4, -10.0F,
                    NJD_FILL | NJD_USE_TEXTURE | NJD_TRANSPARENT);

    njPrintC(NJM_LOCATION(6, 6), "TEST GRID!!");

    return NJD_USER_CONTINUE;
}

/************************************************************
  sIɌĂяoI
************************************************************/
void njUserExit(void)
{
    njExitTexture();
    syFree(VBuf);

    /* VXȅI */
    sbExitSystem();
}
