
/*************************************************************************
 *  t@C     : main.c
 *  e           : EBhEt[eXg
 *                 `gR̗Z^[`
 *  vtBbNX : Main
 *  쐬         :  j (Yoshio Hashiguchi)
 *  쐬         : 98-07-06 쐬Jn
 *  Rg       :
 *  o[W     : 0.01
 ************************************************************************/

#include <shinobi.h>
#include <njdef.h>

void main(void)
{
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}

#define BGCOLOR_LEFTTOP (ARGB(255, 50, 50, 200))
#define BGCOLOR_RIGHTTOP (ARGB(255, 50, 50, 200))
#define BGCOLOR_LEFTBOTTOM (ARGB(255, 0, 0, 0))

#define TEXNUM 2
#define MAX_MATRIX_DEPTH 10
#define MAX_VERTEXES 10000

static NJS_MATRIX *Matrix;
static NJS_VERTEX_BUF *VBuf;

static NJS_VIEW View;
static NJS_LIGHT Light;

/* eNX`ݒ */
static NJS_TEXNAME Texname[] = {
   /* t@C        Agr[g     hc */
    {"sprite1.pvr", NJD_TEXATTR_GLOBALINDEX, 0},
    {"sprite2.pvr", NJD_TEXATTR_GLOBALINDEX, 1},
};
static NJS_TEXLIST Texlist = {Texname, TEXNUM};

static NJS_TEXMEMLIST Texmemlist[TEXNUM];

static NJS_COLOR Color[4] = {
    ARGB(255, 255, 255, 255), ARGB(255, 255, 255, 255),
    ARGB(255, 255, 255, 255), ARGB(255, 255, 255, 255),
};

static NJS_POINT2 point[7][2]; /* eNX`̂S_̍W */
static NJS_POINT2 p[4]; /* eNX`̂S_̍W */
static NJS_COLOR uv[4];
static NJS_POINT2COL p2c = { p, Color, uv, 4 };

static Angle ang[7][2] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
static Angle vAng[7][2] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
static Float rad[7][2] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

/*
######## O[o֐ ##################################################
*/

/*************************************************************************
 *  ֐  : njUserInit
 *  e    : 
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-06 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
void njUserInit(void)
{
    /* VXe */
    sbInitSystem(NJD_RESOLUTION_VGA, NJD_FRAMEBUFFER_MODE_RGB565, 1);
    Matrix = (NJS_MATRIX *)syMalloc(sizeof (NJS_MATRIX) * MAX_MATRIX_DEPTH);
    VBuf = (NJS_VERTEX_BUF *)syMalloc(sizeof(NJS_VERTEX_BUF) * MAX_VERTEXES);
    /* obNOEhJ[ݒ */
    njSetBackColor(BGCOLOR_LEFTTOP, BGCOLOR_RIGHTTOP, BGCOLOR_LEFTBOTTOM);
    /* eNX`obt@̊m */
    njInitTextureBuffer((Sint8 *)VBuf,0x40800);
    /* _f[^o^pobt@AP[g(1̒_*64/4oCg) */
    njInitVertexBuffer(MAX_VERTEXES * 64 / 4, 0, MAX_VERTEXES * 64 / 4, 0);
    /* }gNXX^bN̏ */
    njInitMatrix(Matrix, MAX_MATRIX_DEPTH, 1);
    /* 3DVXȅ */
    njInit3D(VBuf, MAX_VERTEXES);
    /* ̏ */
    njCreateLight(&Light, NJD_DIR_LIGHT);
    /* r[̏ */
    njInitView(&View);
    /* r[̐ݒ */
    njSetView(&View);

    /*eNX`i[̈ݒ*/
    njInitTexture(Texmemlist, TEXNUM);
    /* eNX`̃[h */
    njLoadTexture(&Texlist);

    /* ̎ݒ */
    njRandomSeed(0);

    {
        int i;
        for (i = 0; i < 7; i++) {
            vAng[i][0] = NJM_DEG_ANG(njRandom() * 4 + 1);
            vAng[i][1] = NJM_DEG_ANG(njRandom() * 4 + 1);
            rad[i][0] = njRandom() * 15;
            rad[i][1] = njRandom() * 7;
        }
    }
}

/*************************************************************************
 *  ֐  : njUserMain
 *  e    : s郁C
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-06 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: NJD_USER_CONTINUE
 *************************************************************************
 */
Sint32 njUserMain(void)
{

    static int offset = 0;

    /* }gNXX^bÑNA */
    njClearMatrix();

    /* JgeNX`Xgtexlistɂ */
    njSetTexture(&Texlist);
    njSetTextureNum(0);

    uv[0].tex.u = 0 + offset; uv[0].tex.v = 0 + offset;
    uv[1].tex.u = 255 * 3 + offset; uv[1].tex.v = 0 + offset;
    uv[2].tex.u = 255 * 3 + offset; uv[2].tex.v = 255 * 4 + offset;
    uv[3].tex.u = 0 + offset; uv[3].tex.v = 255 * 4 + offset;

    /*offset += 5;
    if (offset > 255) {
        offset -= 255;
    }*/

    /*{
        int i;
        for (i = 0; i < 7; i++) {
            point[i][0].x = 100 * i + 100 + njRandom() * 20 - 10;
            point[i][0].y = 100 + njRandom() * 20 - 10;
            point[i][1].x = 100 * i + 100 + njRandom() * 20 - 10;
            point[i][1].y = 120 + njRandom() * 20 - 10;
        }
    }*/
    {
        int i;
        for (i = 0; i < 7; i++) {
            point[i][0].x = 100 * i + njCos(ang[i][0]) * rad[i][0];
            point[i][0].y = 100 + njSin(ang[i][0]) * rad[i][1];
            point[i][1].x = 100 * i + njCos(ang[i][1]) * rad[i][0];
            point[i][1].y = 150 + njSin(ang[i][1]) * rad[i][1];
            ang[i][0] += vAng[i][0];
            ang[i][1] += vAng[i][1];
        }
    }

    {
        int i;
        for (i = 0; i < 6; i++) {
            p[0] = point[i][0];
            p[1] = point[i + 1][0];
            p[2] = point[i + 1][1];
            p[3] = point[i][1];
            njDrawPolygon2D(&p2c, 4, -100, NJD_FILL | NJD_USE_TEXTURE);
        }
    }

    {
        int i;
        for (i = 0; i < 7; i++) {
            point[i][0].x = 100 * i + njCos(ang[i][0]) * rad[i][0];
            point[i][0].y = 300;
            point[i][1].x = 100 * i + njCos(ang[i][1]) * rad[i][0];
            point[i][1].y = 350;
            ang[i][0] += vAng[i][0];
            ang[i][1] += vAng[i][1];
        }
    }

    {
        int i;
        for (i = 0; i < 6; i++) {
            p[0] = point[i][0];
            p[1] = point[i + 1][0];
            p[2] = point[i + 1][1];
            p[3] = point[i][1];
            njDrawPolygon2D(&p2c, 4, -100, NJD_FILL | NJD_USE_TEXTURE);
        }
    }

    return NJD_USER_CONTINUE;
}

/*************************************************************************
 *  ֐  : njUserExit
 *  e    : I֐
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-06 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
void njUserExit(void)
{
    njExitTexture();

    /*  */
    syFree(Matrix);
    syFree(VBuf);

    /* VXȅI */
    sbExitSystem();
}
