
/*************************************************************************
 *  t@C     : goodssentakuwin.c
 *  e           : ObYIEBhE쐬Ǘ
 *  vtBbNX : GoodsSentakuWin
 *  쐬         :  j (Yoshio Hashiguchi)
 *  쐬         : 98-07-01 쐬Jn
 *  Rg       :
 *  o[W     : 0.01
 ************************************************************************/

#define __GOODSSENTAKUWIN_C

/*
######## CN[ht@C ########
*/

#include <ninja.h>
#include <ninjawin.h>
#include <njdef.h>

#include <htwindow.h>
#include <htwinbutton.h>

#include "windef.h"
#include "wintex.h"

#include "keieimenutask.h"
#include "taskid.h"

#include "goodssentakuwin.h"

/*
######## 萔錾 ########
*/

/* EBhEW */
#define WINPOS_LEFT (MODE_POS_LEFT)
#define WINPOS_TOP (MODE_POS_TOP)
#define WINPOS_RIGHT (640 - MODE_POS_LEFT)
#define WINPOS_BOTTOM (480 - MODE_POS_TOP)

/* EBhE̔zF */
#define WINFGCOLOR (ARGB(0, 0, 0, 0)) /* OʐF(iKł͕sgp) */
#define WINBGCOLOR (ARGB(64, 150, 150, 150)) /* wiF */

#define BTNNUM (1) /* {^ */
#define BTNSIZE_X (STRTEXSIZE_X(12)) /* {^(g)wTCY */
#define BTNSIZE_Y (STRTEXSIZE_Y(3))  /* {^(g)xTCY */
#define BTNPOS_X (320 - BTNSIZE_X / 2 - WINPOS_LEFT) /* {^ʒuw */
#define BTNPOS_Y (240 - BTNSIZE_Y / 2 - WINPOS_TOP) /* {^ʒux */

/*
######## }N ########
*/

/*
######## \̐錾 ########
*/

/*
######## Ŏg֐̃vg^Cv錾 ########
*/

static void CreateBtn(void);
static void SetBtnCallBack(void);

static void PushReturn(LPHTtButtonArg arg);

/*
######## ÓIϐ ########
*/

/* EBhEnh */
HTWINHANDLE goodsSentakuWin;

/* Ǘ^XN̂hc */
Sint32 taskID;

/* {^pp[^ */
static HTtButtonArg btnArg[BTNNUM];

/* {^pACẽAgr[g */
static HTtItemAttr itemAttr[] = {
  /* Polygon/Texture       TextureID           COLOR         UV */
    ITEM_ATTR_TEXTURE, WINTEXID_TO_GOODS, COL4_WHITE_GRAY, UV4_88,
};

/* {^ACe̍쐬 */
static HTtItem btnItem[BTNNUM] = {
  /*  ItemPtr           TCY                  */
    1, &itemAttr[0], BTNSIZE_X, BTNSIZE_Y,  BTNPOS_X, BTNPOS_Y,
};

/* J[\{^ɂƂɌĂ΂R[obN֐ */
static void (*onBtnCallBack[BTNNUM])(LPHTtButtonArg arg) = {
    NULL,
};

/* {^IꂽƂɌĂ΂R[obN֐ */
static void (*pushBtnCallBack[BTNNUM])(LPHTtButtonArg arg) = {
    PushReturn,
};

/*
######## O[o֐ ##################################################
*/

/*************************************************************************
 *  ֐  : GoodsSentakuWin_CreateWindow
 *  e    : ObYIEBhE̍쐬
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-01 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : Sint32 id EBhEǗ^XN̂hc (enumTASKID)
 *  out: void
 *************************************************************************
 */
void GoodsSentakuWin_CreateWindow(Sint32 id)
{
    extern NJS_TEXLIST winTexList; /* eNX`Xg(wintex.c) */

    /* EBhE쐬 */
    goodsSentakuWin = HTCreateSimpleWindow(WINPOS_LEFT, WINPOS_TOP,
        WINPOS_RIGHT, WINPOS_BOTTOM, WINFGCOLOR, WINBGCOLOR);

    /* eNX`Xg̐ݒ */
    HTSetTextureList(goodsSentakuWin, &winTexList);

    /* {^̑̐ݒ */
    CreateBtn();

    /* {^R[obN֐ݒ */
    SetBtnCallBack();

    /* ŏɑI{^ */
    HTSetGadgetDefault(goodsSentakuWin, (LPHTWINGadget)&btnArg[0]);

    /* Ǘ҃^XN̂hc𓾂 */
    taskID = id;

    /* EBhE}bv */
    HTMapWindow(goodsSentakuWin);
}

/*************************************************************************
 *  ֐  : GoodsSentakuWin_CloseWindow
 *  e    : ObYIEBhE
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-01 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
void GoodsSentakuWin_CloseWindow(void)
{
    HTCloseWindow(goodsSentakuWin);
}

/*
######## [J֐ ####################################################
*/

/*************************************************************************
 *  ֐  : CreateBtn
 *  e    : {^̍쐬
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-01 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
static void CreateBtn(void)
{
    Sint8 i;
    HTtButtonArg* pBtnArg = &btnArg[0];
    HTtItem* pItem = &btnItem[0];

    for (i = 0; i < BTNNUM; i++) {
        pBtnArg->item = *pItem;
        HTtCreateButton(goodsSentakuWin, pBtnArg);
        /* {^I\ɐݒ */
        HTSetGadgetButton((LPHTWINGadget)pBtnArg);
        HTSetGadgetSelectable((LPHTWINGadget)pBtnArg);
        pBtnArg++;
        pItem++;
    }
}

/*************************************************************************
 *  ֐  : SetBtnCallBack
 *  e    : {^R[obN֐̐ݒ
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-01 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
static void SetBtnCallBack(void)
{
    Sint8 i;
    HTtButtonArg* pBtnArg = &btnArg[0];
    void (**pOnBtnCallBack)(LPHTtButtonArg arg) = &onBtnCallBack[0];
    void (**pPushBtnCallBack)(LPHTtButtonArg arg) = &pushBtnCallBack[0];

    for (i = 0; i < BTNNUM; i++) {
        /* J[\{^ɗƂ̃R[obN */
        HTtSetOnButtonCallBack(pBtnArg, *pOnBtnCallBack);
        /* {^IꂽƂ̃R[obN */
        HTtSetPushButtonCallBack(pBtnArg, *pPushBtnCallBack);
        pBtnArg++;
        pOnBtnCallBack++;
        pPushBtnCallBack++;
    }
}

/*************************************************************************
 *  ֐  : PushReturn
 *  e    : Ƃɖ߂{^ꂽ̃R[obN
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-01 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : LPHTtButtonArg arg
 *  out: void
 *************************************************************************
 */
static void PushReturn(LPHTtButtonArg arg)
{
    /* ocj[^XÑtO𗧂Ă */
    KeieiMenuTask_ChangeFlag(KEIEIMENUTASK_FLAG_RETURN);
    HTtDrawButton(arg);
}

