
/*************************************************************************
 *  t@C     : ikuseimenutask.c
 *  e           : 琬j[^XN쐬Ǘ
 *  vtBbNX : IkuseiMenuTask
 *  쐬         :  j (Yoshio Hashiguchi)
 *  쐬         : 98-07-02 쐬Jn
 *  Rg       :
 *  o[W     : 0.01
 ************************************************************************/

#define __IKUSEIMENUTASK_C

/*
######## CN[ht@C ########
*/

#include <ninja.h>
#include <ninjawin.h>
#include <njdef.h>

#include <httask_mgr.h>

#include "toptask.h"

#include "taskid.h"
#include "ikuseimenuwin.h"
#include "sakusenshitumenuwin.h"
#include "dajunhenkouwin.h"
#include "positionketteiwin.h"
#include "toushurotationwin.h"
#include "senshusentakuwin.h"

#include "ikuseimenutask.h"


/*
######## 萔錾 ########
*/
enum{ /* ^XN̏ */
    TASK_STABLE,         /* ωiV */
    TASK_SHIAI,          /* I */
    TASK_JINJI,          /* lI */
    TASK_KEIEI,          /* ocI */
    TASK_JOUHOU,         /* I */
    TASK_RENSHUU,        /* KI */
    TASK_SAKUSENSHITU,   /* 펺I */
    TASK_MEETINGSHITU,   /* ~[eBOI */
    TASK_KIOKU,          /* LI */
    TASK_DAJUNHENKOU,    /* ŏύXI */
    TASK_POSITIONKETTEI, /* |WVI */
    TASK_TOUSHUROTATION, /* 胍[eI */
    TASK_RETURN,         /* Ƃɖ߂I */

    TASK_END
};

enum{ /* j[\ */
    MENU_R,
    MENU_R_SAKUSENSHITU,
    MENU_R_SAKUSENSHITU_DAJUNHENKOU,
    MENU_R_SAKUSENSHITU_POSITIONKETTEI,
    MENU_R_SAKUSENSHITU_TOUSHUROTATION,
    MENU_R_MEETINGSHITU,

    MENU_END
};

/*
######## }N ########
*/

/*
######## \̐錾 ########
*/

typedef struct { /* ocj[^XN\ */
    void* child;      /* q^XN*/
    Sint32 taskState; /* ^XN(enumTASK)*/
    Sint32 menuTree;  /* ݂̃j[\(enumMENU) */
} IkuseiMenuTask;

/*
######## Ŏg֐̃vg^Cv錾 ########
*/

static void InitIkuseiMenuTask(IkuseiMenuTask* this);
static void ControlIkuseiMenuTask(IkuseiMenuTask* this);
static void PrintTree(void);

/*
######## ÓIϐ ########
*/

/* ^XN */
static IkuseiMenuTask* ikuseiMenuTask;

/* ^XN֐̒` */
static HTTaskFunc taskFunc = {
    InitIkuseiMenuTask,    /*  */
    ControlIkuseiMenuTask, /* Rg[ */
    NULL, /* ` */
    NULL, /* I */
};

/*
######## O[o֐ ##################################################
*/

/*************************************************************************
 *  ֐    : IkuseiMenuTask_CreateTask
 *  e    : 琬j[^XN̍쐬
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-02 쐬Jn
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void* parent e^XNւ̃|C^
 *  out: void* ikuseiMenuTask ꂽ^XNւ̃|C^
 *************************************************************************
 */
void* IkuseiMenuTask_CreateTask(void* parent)
{
    ikuseiMenuTask = HTTask_CreateChild(parent,
        sizeof(IkuseiMenuTask), &taskFunc);
    return ikuseiMenuTask;
}

/*************************************************************************
 *  ֐    : IkuseiMenuTask_ChangeFlag
 *  e    : j[ItO𗧂Ă
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-02 쐬Jn
 *  Rg:
 *------------------------------------------------------------------------
 *  in : Sint32 flag tO(enumIKUSEIMENUTASK_FLAG)
 *  out: void
 *************************************************************************
 */
void IkuseiMenuTask_ChangeFlag(Sint32 flag)
{
    if (flag == IKUSEIMENUTASK_FLAG_SHIAI) { /* I */
        ikuseiMenuTask->taskState = TASK_SHIAI;
    }
    else if (flag == IKUSEIMENUTASK_FLAG_JINJI) { /* lI */
        ikuseiMenuTask->taskState = TASK_JINJI;
    }
    else if (flag == IKUSEIMENUTASK_FLAG_KEIEI) { /* ocI */
        ikuseiMenuTask->taskState = TASK_KEIEI;
    }
    else if (flag == IKUSEIMENUTASK_FLAG_JOUHOU) { /* I */
        ikuseiMenuTask->taskState = TASK_JOUHOU;
    }
    else if (flag == IKUSEIMENUTASK_FLAG_RENSHUU) { /* KI */
        ikuseiMenuTask->taskState = TASK_RENSHUU;
    }
    else if (flag == IKUSEIMENUTASK_FLAG_KIOKU) { /* LI */
        ikuseiMenuTask->taskState = TASK_KIOKU;
    }
    else if (flag == IKUSEIMENUTASK_FLAG_SAKUSENSHITU) { /* 펺I */
        ikuseiMenuTask->taskState = TASK_SAKUSENSHITU;
    }
    else if (flag == IKUSEIMENUTASK_FLAG_MEETINGSHITU) { /* lI */
        ikuseiMenuTask->taskState = TASK_MEETINGSHITU;
    }
    else if (flag == IKUSEIMENUTASK_FLAG_DAJUNHENKOU) { /* ŏύXI */
        ikuseiMenuTask->taskState = TASK_DAJUNHENKOU;
    }
    else if (flag == IKUSEIMENUTASK_FLAG_POSITIONKETTEI) { /* oI */
        ikuseiMenuTask->taskState = TASK_POSITIONKETTEI;
    }
    else if (flag == IKUSEIMENUTASK_FLAG_TOUSHUROTATION) { /* [eI */
        ikuseiMenuTask->taskState = TASK_TOUSHUROTATION;
    }
    else if (flag == IKUSEIMENUTASK_FLAG_RETURN) { /* Ƃɖ߂I */
        ikuseiMenuTask->taskState = TASK_RETURN;
    }
}

/*
######## [J֐ ####################################################
*/

/*************************************************************************
 *  ֐  : InitIkuseiMenuTask
 *  e    : 琬j[^XN̏
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-02 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : IkuseiMenuTask* this ^XNւ̃|C^
 *  out: void
 *************************************************************************
 */
static void InitIkuseiMenuTask(IkuseiMenuTask* this)
{
    /* ϐ */
    this->child = NULL;
    this->taskState = TASK_STABLE;
    this->menuTree = MENU_R;

    /* 琬j[EBhE쐬 */
    IkuseiMenuWin_CreateWindow(TASKID_IKUSEI);
}

/*************************************************************************
 *  ֐  : ControlIkuseiMenuTask
 *  e    : EBhE
 *            ^XÑRg[֐
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-02 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : IkuseiMenuTask* this ^XNւ̃|C^
 *  out: void
 *************************************************************************
 */
static void ControlIkuseiMenuTask(IkuseiMenuTask* this)
{
    /* ^XNԃ`FbN */
    if (this->taskState == TASK_STABLE) { /* ωiVȂ牽Ȃ */
    }
    else if (this->taskState == TASK_SHIAI) { /* I */
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_JINJI) { /* lI */
        /* gbv^XÑj[ړtO𗧂Ă */
        TopTask_ChangeFlag(TOPTASK_FLAG_JINJI);
        /* Cj[EBhE */
        IkuseiMenuWin_CloseWindow();
        /* ^XNI */
        HTTask_Delete();
    }
    else if (this->taskState == TASK_KEIEI) { /* ocI */
        TopTask_ChangeFlag(TOPTASK_FLAG_KEIEI);
        IkuseiMenuWin_CloseWindow();
        HTTask_Delete();
    }
    else if (this->taskState == TASK_JOUHOU) { /* I */
        TopTask_ChangeFlag(TOPTASK_FLAG_JOUHOU);
        IkuseiMenuWin_CloseWindow();
        HTTask_Delete();
    }
    else if (this->taskState == TASK_RENSHUU) { /* KI */
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_KIOKU) { /* LI */
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_SAKUSENSHITU) { /* 펺I */
        /* j[\ύX */
        this->menuTree = MENU_R_SAKUSENSHITU;
        /* 펺j[쐬 */
        SakusenshituMenuWin_CreateWindow(TASKID_IKUSEI);
        /* ^XNԂ߂ */
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_MEETINGSHITU) { /* ~[eBOI */
        /* j[\ύX */
        this->menuTree = MENU_R_MEETINGSHITU;
        /* ܂ł̃EChEB */
        IkuseiMenuWin_UnMapWindow();
        /* IIEBhE쐬 */
        SenshuSentakuWin_CreateWindow(TASKID_IKUSEI);
        /* ^XNԂ߂ */
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_DAJUNHENKOU) { /* ŏύXI */
        this->menuTree = MENU_R_SAKUSENSHITU_DAJUNHENKOU;
        IkuseiMenuWin_UnMapWindow();
        SakusenshituMenuWin_UnMapWindow();
        DajunHenkouWin_CreateWindow(TASKID_IKUSEI);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_POSITIONKETTEI) { /* oI */
        this->menuTree = MENU_R_SAKUSENSHITU_POSITIONKETTEI;
        IkuseiMenuWin_UnMapWindow();
        SakusenshituMenuWin_UnMapWindow();
        PositionKetteiWin_CreateWindow(TASKID_IKUSEI);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_TOUSHUROTATION) { /* [eI */
        this->menuTree = MENU_R_SAKUSENSHITU_TOUSHUROTATION;
        IkuseiMenuWin_UnMapWindow();
        SakusenshituMenuWin_UnMapWindow();
        ToushuRotationWin_CreateWindow(TASKID_IKUSEI);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_RETURN) { /* Ƃɖ߂I */
        /* ̈ʒu펺j[Ȃ */
        if (this->menuTree == MENU_R_SAKUSENSHITU) {
            this->menuTree = MENU_R;
            SakusenshituMenuWin_CloseWindow();
        }
        else if (this->menuTree == MENU_R_SAKUSENSHITU_DAJUNHENKOU) {
            this->menuTree = MENU_R_SAKUSENSHITU;
            DajunHenkouWin_CloseWindow();
            IkuseiMenuWin_MapWindow();
            SakusenshituMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_SAKUSENSHITU_POSITIONKETTEI) {
            this->menuTree = MENU_R_SAKUSENSHITU;
            PositionKetteiWin_CloseWindow();
            IkuseiMenuWin_MapWindow();
            SakusenshituMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_SAKUSENSHITU_TOUSHUROTATION) {
            this->menuTree = MENU_R_SAKUSENSHITU;
            ToushuRotationWin_CloseWindow();
            IkuseiMenuWin_MapWindow();
            SakusenshituMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_MEETINGSHITU) {
            this->menuTree = MENU_R;
            SenshuSentakuWin_CloseWindow();
            IkuseiMenuWin_MapWindow();
        }
        this->taskState = TASK_STABLE;
    }
    PrintTree(); /* j[c[\ */
}

/*************************************************************************
 *  ֐  : PrintTree
 *  e    : j[c[\(fobO)
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-02 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
static void PrintTree(void)
{
    if (ikuseiMenuTask->menuTree == MENU_R) {
        njPrintC(NJM_LOCATION(0,0), "IKUSEI");
    }
    else if (ikuseiMenuTask->menuTree == MENU_R_SAKUSENSHITU) {
        njPrintC(NJM_LOCATION(0,0), "IKUSEI_SAKUSENSHITU");
    }
    else if (ikuseiMenuTask->menuTree == MENU_R_SAKUSENSHITU_DAJUNHENKOU) {
        njPrintC(NJM_LOCATION(0,0), "IKUSEI_SAKUSENSHITU_DAJUNHENKOU");
    }
    else if (ikuseiMenuTask->menuTree == MENU_R_SAKUSENSHITU_POSITIONKETTEI) {
        njPrintC(NJM_LOCATION(0,0), "IKUSEI_SAKUSENSHITU_POSITIONKETTEI");
    }
    else if (ikuseiMenuTask->menuTree == MENU_R_SAKUSENSHITU_TOUSHUROTATION) {
        njPrintC(NJM_LOCATION(0,0), "IKUSEI_SAKUSENSHITU_TOUSHUROTATION");
    }
    else if (ikuseiMenuTask->menuTree == MENU_R_MEETINGSHITU) {
        njPrintC(NJM_LOCATION(0,0), "IKUSEI_MEETINGSHITU");
    }
}

/*
######## ܂ ########################################################
*/
