
/*************************************************************************
 *  t@C     : ikuseimenuwin.c
 *  e           : 琬j[EBhE쐬Ǘ
 *  vtBbNX : IkuseiMenuWin
 *  쐬         :  j (Yoshio Hashiguchi)
 *  쐬         : 98-07-02 쐬Jn
 *  Rg       :
 *  o[W     : 0.01
 ************************************************************************/

#define __IKUSEIMENUWIN_C

/*
######## CN[ht@C ########
*/

#include <ninja.h>
#include <ninjawin.h>
#include <njdef.h>

#include <htwindow.h>
#include <htwinbuttonarray.h>

#include "windef.h"
#include "wintex.h"

#include "ikuseimenutask.h"
#include "taskid.h"

#include "ikuseimenuwin.h"

/*
######## 萔錾 ########
*/

/* EBhEW */
#define WINPOS_LEFT (MAINMENU_POS_LEFT)
#define WINPOS_TOP (MAINMENU_POS_TOP)

/* EBhE̔zF */
#define WINFGCOLOR (ARGB(0, 0, 0, 0)) /* OʐF(iKł͕sgp) */
#define WINBGCOLOR (ARGB(150, 75, 75, 50)) /* wiF */

#define BTNNUM (8) /* {^ */
#define BTNSIZE_X (STRTEXSIZE_X(8)) /* {^wTCY */
#define BTNSIZE_Y (STRTEXSIZE_Y(2)) /* {^xTCY */

/*
######## }N ########
*/

/*
######## \̐錾 ########
*/

/*
######## Ŏg֐̃vg^Cv錾 ########
*/

static void SetBtnAttr(void);
static void SetBtnCallBack(void);

static void PushShiai(LPHTtButtonArg arg);
static void PushJinji(LPHTtButtonArg arg);
static void PushKeiei(LPHTtButtonArg arg);
static void PushJouhou(LPHTtButtonArg arg);
static void PushRenshuu(LPHTtButtonArg arg);
static void PushSakusenshitu(LPHTtButtonArg arg);
static void PushMeetingshitu(LPHTtButtonArg arg);
static void PushKioku(LPHTtButtonArg arg);

/*
######## ÓIϐ ########
*/

/* EBhEnh */
HTWINHANDLE ikuseiMenuWin;

/* Ǘ^XN̂hc */
Sint32 taskID;

/* {^EBhEpp[^ */
static HTtButtonArg btnArg[BTNNUM];

/* {^pACẽAgr[g */
static HTtItemAttr itemAttr[] = {
  /* Polygon/Texture       TextureID               COLOR         UV */
    ITEM_ATTR_TEXTURE, WINTEXID_SIAI,         COL4_RED_WHITE,  UV4_88,
    ITEM_ATTR_TEXTURE, WINTEXID_JINJI,        COL4_RED_WHITE,  UV4_88,
    ITEM_ATTR_TEXTURE, WINTEXID_KEIEI,        COL4_RED_WHITE,  UV4_88,
    ITEM_ATTR_TEXTURE, WINTEXID_JOUHOU,       COL4_RED_WHITE,  UV4_88,
    ITEM_ATTR_TEXTURE, WINTEXID_RENSHUU,      COL4_BLUE_WHITE, UV4_88,
    ITEM_ATTR_TEXTURE, WINTEXID_SAKUSENSHITU, COL4_BLUE_WHITE, UV4_88,
    ITEM_ATTR_TEXTURE, WINTEXID_MEETINGSHITU, COL4_BLUE_WHITE, UV4_88,
    ITEM_ATTR_TEXTURE, WINTEXID_KIOKU,        COL4_RED_WHITE,  UV4_88,
};

/* {^pACe̍쐬 */
static HTtItem btnItem[BTNNUM] = {
  /*  ItemPtr            TCY          iӖj */
    1, &itemAttr[0],  BTNSIZE_X, BTNSIZE_Y,  0, 0,
    1, &itemAttr[1],  BTNSIZE_X, BTNSIZE_Y,  0, 0,
    1, &itemAttr[2],  BTNSIZE_X, BTNSIZE_Y,  0, 0,
    1, &itemAttr[3],  BTNSIZE_X, BTNSIZE_Y,  0, 0,
    1, &itemAttr[4],  BTNSIZE_X, BTNSIZE_Y,  0, 0,
    1, &itemAttr[5],  BTNSIZE_X, BTNSIZE_Y,  0, 0,
    1, &itemAttr[6],  BTNSIZE_X, BTNSIZE_Y,  0, 0,
    1, &itemAttr[7],  BTNSIZE_X, BTNSIZE_Y,  0, 0,
};

/* J[\{^ɂƂɌĂ΂R[obN֐ */
static void (*onBtnCallBack[BTNNUM])(LPHTtButtonArg arg) = {
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL,
};

/* {^IꂽƂɌĂ΂R[obN֐ */
static void (*pushBtnCallBack[BTNNUM])(LPHTtButtonArg arg) = {
    PushShiai,
    PushJinji,
    PushKeiei,
    PushJouhou,
    PushRenshuu,
    PushSakusenshitu,
    PushMeetingshitu,
    PushKioku,
};

/*
######## O[o֐ ##################################################
*/

/*************************************************************************
 *  ֐  : IkuseiMenuWin_CreateWindow
 *  e    : 琬j[EBhE̍쐬
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-02 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : Sint32 id EBhEǗ^XN̂hc (enumTASKID)
 *  out: void
 *************************************************************************
 */
void IkuseiMenuWin_CreateWindow(Sint32 id)
{
    extern NJS_TEXLIST winTexList; /* eNX`Xg(wintex.c) */

    /* {^̑̐ݒ */
    SetBtnAttr();

    /* {^ACcɕׂ */
    HTtSetButtonArrayAttribute(HTBUTTONARRAY_ATTR_VERT);

    /* EBhE쐬 */
    ikuseiMenuWin = HTtCreateButtonArrayWindow(WINPOS_LEFT, WINPOS_TOP,
        btnArg, BTNNUM, WINFGCOLOR, WINBGCOLOR);

    /* eNX`Xg̐ݒ */
    HTSetTextureList(ikuseiMenuWin, &winTexList);

    /* EBhER[obN֐ݒ */
    SetBtnCallBack();

    /* ŏɑI{^ */
    HTSetGadgetDefault(ikuseiMenuWin, (LPHTWINGadget)&btnArg[4]);

    /* Ǘ҃^XN̂hc𓾂 */
    taskID = id;

    /* EBhE}bv */
    HTMapWindow(ikuseiMenuWin);
}


/*************************************************************************
 *  ֐  : IkuseiMenuWin_CloseWindow
 *  e    : 琬j[EBhE
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-02 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
void IkuseiMenuWin_CloseWindow(void)
{
    HTCloseWindow(ikuseiMenuWin);
}

/*************************************************************************
 *  ֐  : IkuseiMenuWin_MapWindow
 *  e    : 琬j[EBhEĕ\
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-02 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
void IkuseiMenuWin_MapWindow(void)
{
    HTMapWindow(ikuseiMenuWin);
}

/*************************************************************************
 *  ֐  : IkuseiMenuWin_UnMapWindow
 *  e    : 琬j[EBhEB
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-02 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
void IkuseiMenuWin_UnMapWindow(void)
{
    HTUnMapWindow(ikuseiMenuWin);
}

/*
######## [J֐ ####################################################
*/

/*************************************************************************
 *  ֐  : SetBtnAttr
 *  e    : {^̑̐ݒ
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-02 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
static void SetBtnAttr(void)
{
    Sint8 i;
    HTtButtonArg* pBtnArg = &btnArg[0];
    HTtItem* pItem = &btnItem[0];

    for (i = 0; i < BTNNUM; i++) {
        pBtnArg->item = *pItem;
        pBtnArg++;
        pItem++;
    }
}

/*************************************************************************
 *  ֐  : SetBtnCallBack
 *  e    : {^̃R[obN֐̐ݒ
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-02 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
static void SetBtnCallBack(void)
{
    Sint8 i;
    HTtButtonArg* pBtnArg = &btnArg[0];
    void (**pOnBtnCallBack)(LPHTtButtonArg arg) = &onBtnCallBack[0];
    void (**pPushBtnCallBack)(LPHTtButtonArg arg) = &pushBtnCallBack[0];

    for (i = 0; i < BTNNUM; i++) {
        /* J[\{^ɗƂ̃R[obN */
        HTtSetOnButtonCallBack(pBtnArg, *pOnBtnCallBack);
        /* {^IꂽƂ̃R[obN */
        HTtSetPushButtonCallBack(pBtnArg, *pPushBtnCallBack);
        pBtnArg++;
        pOnBtnCallBack++;
        pPushBtnCallBack++;
    }
}

/*************************************************************************
 *  ֐  : PushShiai
 *  e    : {^ꂽ̃R[obN
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-02 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : LPHTtButtonArg arg
 *  out: void
 *************************************************************************
 */
static void PushShiai(LPHTtButtonArg arg)
{
    /* 琬j[^XÑtO𗧂Ă */
    IkuseiMenuTask_ChangeFlag(IKUSEIMENUTASK_FLAG_SHIAI);
    HTtDrawButton(arg);
}

/*************************************************************************
 *  ֐  : PushJinji
 *  e    : l{^ꂽ̃R[obN
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-02 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : LPHTtButtonArg arg
 *  out: void
 *************************************************************************
 */
static void PushJinji(LPHTtButtonArg arg)
{
    /* 琬j[^XÑtO𗧂Ă */
    IkuseiMenuTask_ChangeFlag(IKUSEIMENUTASK_FLAG_JINJI);
    HTtDrawButton(arg);
}

/*************************************************************************
 *  ֐  : PushKeiei
 *  e    : oc{^ꂽ̃R[obN
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-02 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : LPHTtButtonArg arg
 *  out: void
 *************************************************************************
 */
static void PushKeiei(LPHTtButtonArg arg)
{
    /* 琬j[^XÑtO𗧂Ă */
    IkuseiMenuTask_ChangeFlag(IKUSEIMENUTASK_FLAG_KEIEI);
    HTtDrawButton(arg);
}

/*************************************************************************
 *  ֐  : PushJouhou
 *  e    : {^ꂽ̃R[obN
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-02 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : LPHTtButtonArg arg
 *  out: void
 *************************************************************************
 */
static void PushJouhou(LPHTtButtonArg arg)
{
    /* 琬j[^XÑtO𗧂Ă */
    IkuseiMenuTask_ChangeFlag(IKUSEIMENUTASK_FLAG_JOUHOU);
    HTtDrawButton(arg);
}

/*************************************************************************
 *  ֐  : PushRenshuu
 *  e    : K{^ꂽ̃R[obN
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-02 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : LPHTtButtonArg arg
 *  out: void
 *************************************************************************
 */
static void PushRenshuu(LPHTtButtonArg arg)
{
    /* 琬j[^XÑtO𗧂Ă */
    IkuseiMenuTask_ChangeFlag(IKUSEIMENUTASK_FLAG_RENSHUU);
    HTtDrawButton(arg);
}

/*************************************************************************
 *  ֐  : PushSakusenshitu
 *  e    : 펺{^ꂽ̃R[obN
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-02 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : LPHTtButtonArg arg
 *  out: void
 *************************************************************************
 */
static void PushSakusenshitu(LPHTtButtonArg arg)
{
    /* 琬j[^XÑtO𗧂Ă */
    IkuseiMenuTask_ChangeFlag(IKUSEIMENUTASK_FLAG_SAKUSENSHITU);
    HTtDrawButton(arg);
}

/*************************************************************************
 *  ֐  : PushMeetingshitu
 *  e    : ~[eBO{^ꂽ̃R[obN
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-02 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : LPHTtButtonArg arg
 *  out: void
 *************************************************************************
 */
static void PushMeetingshitu(LPHTtButtonArg arg)
{
    /* 琬j[^XÑtO𗧂Ă */
    IkuseiMenuTask_ChangeFlag(IKUSEIMENUTASK_FLAG_MEETINGSHITU);
    HTtDrawButton(arg);
}

/*************************************************************************
 *  ֐  : PushKioku
 *  e    : L{^ꂽ̃R[obN
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-02 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : LPHTtButtonArg arg
 *  out: void
 *************************************************************************
 */
static void PushKioku(LPHTtButtonArg arg)
{
    /* 琬j[^XÑtO𗧂Ă */
    IkuseiMenuTask_ChangeFlag(IKUSEIMENUTASK_FLAG_KIOKU);
    HTtDrawButton(arg);
}

