
/*************************************************************************
 *  t@C     : jinjimenutask.c
 *  e           : lj[^XN쐬Ǘ
 *  vtBbNX : JinjiMenuTask
 *  쐬         :  j (Yoshio Hashiguchi)
 *  쐬         : 98-06-29 쐬Jn
 *  Rg       :
 *  o[W     : 0.01
 ************************************************************************/

#define __JINJIMENUTASK_C

/*
######## CN[ht@C ########
*/

#include <ninja.h>
#include <ninjawin.h>
#include <njdef.h>

#include <httask_mgr.h>

#include "toptask.h"

#include "taskid.h"
#include "jinjimenuwin.h"
#include "shinjinmenuwin.h"
#include "gaikokujinmenuwin.h"
#include "chiikisentakujwin.h"
#include "shinjinlistwin.h"
#include "chiikisentakufwin.h"
#include "gaikokujinlistwin.h"
#include "teamsentakuwin.h"
#include "senshusentakuwin.h"
#include "sebangousentakuwin.h"

#include "jinjimenutask.h"


/*
######## 萔錾 ########
*/
enum{ /* ^XN̏ */
    TASK_STABLE,         /* ωiV */
    TASK_SHIAI,          /* I */
    TASK_KEIEI,          /* ocI */
    TASK_JOUHOU,         /* I */
    TASK_IKUSEI,         /* 琬I */
    TASK_KIOKU,          /* LI */
    TASK_SHINJIN,        /* VlI */
    TASK_GAIKOKUJIN,     /* OlI */
    TASK_TRADE,          /* g[hI */
    TASK_KAIKO,          /* ّI */
    TASK_STAFFKOUTAI,    /* X^btI */
    TASK_SEBANGOUHENKOU, /* wԍύXI */
    TASK_TANSAKU,        /* TI */
    TASK_KOUSHOU,        /* I */
    TASK_LIST,           /* XgI */
    TASK_RETURN,         /* Ƃɖ߂I */

    TASK_END
};

enum{ /* j[\ */
    MENU_R,
    MENU_R_SHINJIN,
    MENU_R_SHINJIN_TANSAKU,
    MENU_R_SHINJIN_KOUSHOU,
    MENU_R_SHINJIN_LIST,
    MENU_R_GAIKOKUJIN,
    MENU_R_GAIKOKUJIN_TANSAKU,
    MENU_R_GAIKOKUJIN_KOUSHOU,
    MENU_R_GAIKOKUJIN_LIST,
    MENU_R_TRADE,
    MENU_R_KAIKO,
    MENU_R_STAFFKOUTAI,
    MENU_R_SEBANGOUHENKOU,

    MENU_END
};

/*
######## }N ########
*/

/*
######## \̐錾 ########
*/

typedef struct { /* lj[^XN\ */
    void* child;      /* q^XN*/
    Sint32 taskState; /* ^XN(enumTASK)*/
    Sint32 menuTree;  /* ݂̃j[\(enumMENU) */
} JinjiMenuTask;

/*
######## Ŏg֐̃vg^Cv錾 ########
*/

static void InitJinjiMenuTask(JinjiMenuTask* this);
static void ControlJinjiMenuTask(JinjiMenuTask* this);
static void PrintTree(void);

/*
######## ÓIϐ ########
*/

/* ^XN */
static JinjiMenuTask* jinjiMenuTask;

/* ^XN֐̒` */
static HTTaskFunc taskFunc = {
    InitJinjiMenuTask,    /*  */
    ControlJinjiMenuTask, /* Rg[ */
    NULL, /* ` */
    NULL, /* I */
};

/*
######## O[o֐ ##################################################
*/

/*************************************************************************
 *  ֐    : JinjiMenuTask_CreateTask
 *  e    : lj[^XN̍쐬
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-06-29 쐬Jn
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void* parent e^XNւ̃|C^
 *  out: void* jinjiMenuTask ꂽ^XNւ̃|C^
 *************************************************************************
 */
void* JinjiMenuTask_CreateTask(void* parent)
{
    jinjiMenuTask = HTTask_CreateChild(parent,
        sizeof(JinjiMenuTask), &taskFunc);
    return jinjiMenuTask;
}

/*************************************************************************
 *  ֐    : JinjiMenuTask_ChangeFlag
 *  e    : j[ItO𗧂Ă
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-06-29 쐬Jn
 *  Rg:
 *------------------------------------------------------------------------
 *  in : Sint32 flag tO(enumJINJIMENUTASK_FLAG)
 *  out: void
 *************************************************************************
 */
void JinjiMenuTask_ChangeFlag(Sint32 flag)
{
    if (flag == JINJIMENUTASK_FLAG_SHIAI) { /* I */
        jinjiMenuTask->taskState = TASK_SHIAI;
    }
    else if (flag == JINJIMENUTASK_FLAG_KEIEI) { /* ocI */
        jinjiMenuTask->taskState = TASK_KEIEI;
    }
    else if (flag == JINJIMENUTASK_FLAG_JOUHOU) { /* I */
        jinjiMenuTask->taskState = TASK_JOUHOU;
    }
    else if (flag == JINJIMENUTASK_FLAG_IKUSEI) { /* 琬I */
        jinjiMenuTask->taskState = TASK_IKUSEI;
    }
    else if (flag == JINJIMENUTASK_FLAG_KIOKU) { /* LI */
        jinjiMenuTask->taskState = TASK_KIOKU;
    }
    else if (flag == JINJIMENUTASK_FLAG_SHINJIN) { /* VlI */
        jinjiMenuTask->taskState = TASK_SHINJIN;
    }
    else if (flag == JINJIMENUTASK_FLAG_GAIKOKUJIN) { /* OlI */
        jinjiMenuTask->taskState = TASK_GAIKOKUJIN;
    }
    else if (flag == JINJIMENUTASK_FLAG_TRADE) { /* g[hI */
        jinjiMenuTask->taskState = TASK_TRADE;
    }
    else if (flag == JINJIMENUTASK_FLAG_KAIKO) { /* ّI */
        jinjiMenuTask->taskState = TASK_KAIKO;
    }
    else if (flag == JINJIMENUTASK_FLAG_STAFFKOUTAI) { /* X^btI */
        jinjiMenuTask->taskState = TASK_STAFFKOUTAI;
    }
    else if (flag == JINJIMENUTASK_FLAG_SEBANGOUHENKOU) { /* wԍύXI */
        jinjiMenuTask->taskState = TASK_SEBANGOUHENKOU;
    }
    else if (flag == JINJIMENUTASK_FLAG_TANSAKU) { /* TI */
        jinjiMenuTask->taskState = TASK_TANSAKU;
    }
    else if (flag == JINJIMENUTASK_FLAG_KOUSHOU) { /* I */
        jinjiMenuTask->taskState = TASK_KOUSHOU;
    }
    else if (flag == JINJIMENUTASK_FLAG_LIST) { /* XgI */
        jinjiMenuTask->taskState = TASK_LIST;
    }
    else if (flag == JINJIMENUTASK_FLAG_RETURN) { /* Ƃɖ߂I */
        jinjiMenuTask->taskState = TASK_RETURN;
    }
}

/*
######## [J֐ ####################################################
*/

/*************************************************************************
 *  ֐  : InitJinjiMenuTask
 *  e    : lj[^XN̏
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-06-29 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : JinjiMenuTask* this ^XNւ̃|C^
 *  out: void
 *************************************************************************
 */
static void InitJinjiMenuTask(JinjiMenuTask* this)
{
    /* ϐ */
    this->child = NULL;
    this->taskState = TASK_STABLE;
    this->menuTree = MENU_R;

    /* lj[EBhE쐬 */
    JinjiMenuWin_CreateWindow(TASKID_JINJI);
}

/*************************************************************************
 *  ֐  : ControlJinjiMenuTask
 *  e    : EBhE
 *            ^XÑRg[֐
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-06-29 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : JinjiMenuTask* this ^XNւ̃|C^
 *  out: void
 *************************************************************************
 */
static void ControlJinjiMenuTask(JinjiMenuTask* this)
{
    /* ^XNԃ`FbN */
    if (this->taskState == TASK_STABLE) { /* ωiVȂ牽Ȃ */
    }
    else if (this->taskState == TASK_SHIAI) { /* I */
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_KEIEI) { /* ocI */
        /* gbv^XÑj[ړtO𗧂Ă */
        TopTask_ChangeFlag(TOPTASK_FLAG_KEIEI);
        /* Cj[EBhE */
        JinjiMenuWin_CloseWindow();
        /* ^XNI */
        HTTask_Delete();
    }
    else if (this->taskState == TASK_JOUHOU) { /* I */
        TopTask_ChangeFlag(TOPTASK_FLAG_JOUHOU);
        JinjiMenuWin_CloseWindow();
        HTTask_Delete();
    }
    else if (this->taskState == TASK_IKUSEI) { /* 琬I */
        TopTask_ChangeFlag(TOPTASK_FLAG_IKUSEI);
        JinjiMenuWin_CloseWindow();
        HTTask_Delete();
    }
    else if (this->taskState == TASK_KIOKU) { /* LI */
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_SHINJIN) { /* VlI */
        /* j[\ύX */
        this->menuTree = MENU_R_SHINJIN;
        /* Vlj[쐬 */
        ShinjinMenuWin_CreateWindow(TASKID_JINJI);
        /* ^XNԂ߂ */
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_GAIKOKUJIN) { /* OlI */
        this->menuTree = MENU_R_GAIKOKUJIN;
        GaikokujinMenuWin_CreateWindow(TASKID_JINJI);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_TRADE) { /* g[hI */
        /* j[\ύX */
        this->menuTree = MENU_R_TRADE;
        /* ܂ł̃EBhEB */
        JinjiMenuWin_UnMapWindow();
        /* `[IEBhE쐬 */
        TeamSentakuWin_CreateWindow(TASKID_JINJI);
        /* ^XNԂ߂ */
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_KAIKO) { /* ّI */
        this->menuTree = MENU_R_KAIKO;
        JinjiMenuWin_UnMapWindow();
        SenshuSentakuWin_CreateWindow(TASKID_JINJI);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_STAFFKOUTAI) { /* X^btI */
        this->menuTree = MENU_R_STAFFKOUTAI;
        JinjiMenuWin_UnMapWindow();
        SenshuSentakuWin_CreateWindow(TASKID_JINJI);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_SEBANGOUHENKOU) { /* wԍύXI */
        this->menuTree = MENU_R_SEBANGOUHENKOU;
        JinjiMenuWin_UnMapWindow();
        SebangouSentakuWin_CreateWindow(TASKID_JINJI);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_TANSAKU) { /* TI */
        /* ̈ʒuVlj[Ȃ */
        if (this->menuTree == MENU_R_SHINJIN) {
            /* j[\ύX */
            this->menuTree = MENU_R_SHINJIN_TANSAKU;
            /* ܂ł̃EBhEB */
            JinjiMenuWin_UnMapWindow();
            ShinjinMenuWin_UnMapWindow();
            /* nI()EBhE쐬 */
            ChiikiSentakuJWin_CreateWindow(TASKID_JINJI);
        }
        /* ̈ʒuOlj[Ȃ */
        else if (this->menuTree == MENU_R_GAIKOKUJIN) {
            this->menuTree = MENU_R_GAIKOKUJIN_TANSAKU;
            JinjiMenuWin_UnMapWindow();
            GaikokujinMenuWin_UnMapWindow();
            ChiikiSentakuFWin_CreateWindow(TASKID_JINJI);
        }
        /* ^XNԂ߂ */
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_KOUSHOU) { /* I */
        if (this->menuTree == MENU_R_SHINJIN) {
            this->menuTree = MENU_R_SHINJIN_KOUSHOU;
            JinjiMenuWin_UnMapWindow();
            ShinjinMenuWin_UnMapWindow();
            ShinjinListWin_CreateWindow(TASKID_JINJI);
        }
        else if (this->menuTree == MENU_R_GAIKOKUJIN) {
            this->menuTree = MENU_R_GAIKOKUJIN_KOUSHOU;
            JinjiMenuWin_UnMapWindow();
            GaikokujinMenuWin_UnMapWindow();
            GaikokujinListWin_CreateWindow(TASKID_JINJI);
        }
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_LIST) { /* XgI */
        if (this->menuTree == MENU_R_SHINJIN) {
            this->menuTree = MENU_R_SHINJIN_LIST;
            JinjiMenuWin_UnMapWindow();
            ShinjinMenuWin_UnMapWindow();
            ShinjinListWin_CreateWindow(TASKID_JINJI);
        }
        else if (this->menuTree == MENU_R_GAIKOKUJIN) {
            this->menuTree = MENU_R_GAIKOKUJIN_LIST;
            JinjiMenuWin_UnMapWindow();
            GaikokujinMenuWin_UnMapWindow();
            GaikokujinListWin_CreateWindow(TASKID_JINJI);
        }
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_RETURN) { /* Ƃɖ߂I */
        /* ̈ʒuVlj[Ȃ */
        if (this->menuTree == MENU_R_SHINJIN) {
            this->menuTree = MENU_R;
            ShinjinMenuWin_CloseWindow();
        }
        else if (this->menuTree == MENU_R_SHINJIN_TANSAKU) {
            this->menuTree = MENU_R_SHINJIN;
            ChiikiSentakuJWin_CloseWindow();
            JinjiMenuWin_MapWindow();
            ShinjinMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_SHINJIN_KOUSHOU) {
            this->menuTree = MENU_R_SHINJIN;
            ShinjinListWin_CloseWindow();
            JinjiMenuWin_MapWindow();
            ShinjinMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_SHINJIN_LIST) {
            this->menuTree = MENU_R_SHINJIN;
            ShinjinListWin_CloseWindow();
            JinjiMenuWin_MapWindow();
            ShinjinMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_GAIKOKUJIN) {
            this->menuTree = MENU_R;
            GaikokujinMenuWin_CloseWindow();
        }
        else if (this->menuTree == MENU_R_GAIKOKUJIN_TANSAKU) {
            this->menuTree = MENU_R_GAIKOKUJIN;
            ChiikiSentakuFWin_CloseWindow();
            JinjiMenuWin_MapWindow();
            GaikokujinMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_GAIKOKUJIN_KOUSHOU) {
            this->menuTree = MENU_R_GAIKOKUJIN;
            GaikokujinListWin_CloseWindow();
            JinjiMenuWin_MapWindow();
            GaikokujinMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_GAIKOKUJIN_LIST) {
            this->menuTree = MENU_R_GAIKOKUJIN;
            GaikokujinListWin_CloseWindow();
            JinjiMenuWin_MapWindow();
            GaikokujinMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_TRADE) {
            this->menuTree = MENU_R;
            TeamSentakuWin_CloseWindow();
            JinjiMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_KAIKO) {
            this->menuTree = MENU_R;
            SenshuSentakuWin_CloseWindow();
            JinjiMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_STAFFKOUTAI) {
            this->menuTree = MENU_R;
            SenshuSentakuWin_CloseWindow();
            JinjiMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_SEBANGOUHENKOU) {
            this->menuTree = MENU_R;
            SebangouSentakuWin_CloseWindow();
            JinjiMenuWin_MapWindow();
        }
        this->taskState = TASK_STABLE;
    }

    PrintTree(); /* j[c[\ */
}

/*************************************************************************
 *  ֐  : PrintTree
 *  e    : j[c[\(fobO)
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-01 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
static void PrintTree(void)
{
    if (jinjiMenuTask->menuTree == MENU_R) {
        njPrintC(NJM_LOCATION(0,0), "JINJI");
    }
    if (jinjiMenuTask->menuTree == MENU_R_SHINJIN) {
        njPrintC(NJM_LOCATION(0,0), "JINJI_SHINJIN");
    }
    if (jinjiMenuTask->menuTree == MENU_R_SHINJIN_TANSAKU) {
        njPrintC(NJM_LOCATION(0,0), "JINJI_SHINJIN_TANSAKU");
    }
    if (jinjiMenuTask->menuTree == MENU_R_SHINJIN_KOUSHOU) {
        njPrintC(NJM_LOCATION(0,0), "JINJI_SHINJIN_KOUSHOU");
    }
    if (jinjiMenuTask->menuTree == MENU_R_SHINJIN_LIST) {
        njPrintC(NJM_LOCATION(0,0), "JINJI_SHINJIN_LIST");
    }
    if (jinjiMenuTask->menuTree == MENU_R_GAIKOKUJIN) {
        njPrintC(NJM_LOCATION(0,0), "JINJI_GAIKOKUJIN");
    }
    if (jinjiMenuTask->menuTree == MENU_R_GAIKOKUJIN_TANSAKU) {
        njPrintC(NJM_LOCATION(0,0), "JINJI_GAIKOKUJIN_TANSAKU");
    }
    if (jinjiMenuTask->menuTree == MENU_R_GAIKOKUJIN_KOUSHOU) {
        njPrintC(NJM_LOCATION(0,0), "JINJI_GAIKOKUJIN_KOUSHOU");
    }
    if (jinjiMenuTask->menuTree == MENU_R_GAIKOKUJIN_LIST) {
        njPrintC(NJM_LOCATION(0,0), "JINJI_GAIKOKUJIN_LIST");
    }
    if (jinjiMenuTask->menuTree == MENU_R_TRADE) {
        njPrintC(NJM_LOCATION(0,0), "JINJI_TRADE");
    }
    if (jinjiMenuTask->menuTree == MENU_R_KAIKO) {
        njPrintC(NJM_LOCATION(0,0), "JINJI_KAIKO");
    }
    if (jinjiMenuTask->menuTree == MENU_R_STAFFKOUTAI) {
        njPrintC(NJM_LOCATION(0,0), "JINJI_STAFFKOUTAI");
    }
    if (jinjiMenuTask->menuTree == MENU_R_SEBANGOUHENKOU) {
        njPrintC(NJM_LOCATION(0,0), "JINJI_SEBANGOUHENKOU");
    }
}

/*
######## ܂ ########################################################
*/
