
/*************************************************************************
 *  t@C     : jouhoumenutask.c
 *  e           : 񃁃j[^XN쐬Ǘ
 *  vtBbNX : JouhouMenuTask
 *  쐬         :  j (Yoshio Hashiguchi)
 *  쐬         : 98-07-01 쐬Jn
 *  Rg       :
 *  o[W     : 0.01
 ************************************************************************/

#define __JOUHOUMENUTASK_C

/*
######## CN[ht@C ########
*/

#include <ninja.h>
#include <ninjawin.h>
#include <njdef.h>

#include <httask_mgr.h>

#include "toptask.h"

#include "taskid.h"
#include "jouhoumenuwin.h"
#include "penantracemenuwin.h"
#include "houkokumenuwin.h"
#include "teamnoayumimenuwin.h"
#include "yakyuudendoumenuwin.h"
#include "shouhaihyouwin.h"
#include "senshuseisekiwin.h"
#include "senshurankingwin.h"
#include "schedulewin.h"
#include "shuushiwin.h"
#include "memowin.h"
#include "shiaiseisekiwin.h"
#include "tuusankeieiwin.h"
#include "rekidaititlewin.h"
#include "senshuretudenwin.h"

#include "jouhoumenutask.h"


/*
######## 萔錾 ########
*/
enum{ /* ^XN̏ */
    TASK_STABLE,         /* ωiV */
    TASK_SHIAI,          /* I */
    TASK_JINJI,          /* lI */
    TASK_KEIEI,          /* ocI(݃j[Ƌp) */
    TASK_IKUSEI,         /* 琬I */
    TASK_SHINBUN,        /* VI */
    TASK_YOUGOJITEN,     /* pꎫTI */
    TASK_KIOKU,          /* LI */
    TASK_PENANTRACE,     /* yig[XI */
    TASK_HOUKOKU,        /* 񍐑I */
    TASK_TEAMNOAYUMI,    /* `[̕ݑI */
    TASK_YAKYUUDENDOU,   /* 싅aI */
    TASK_SHOUHAIHYOU,    /* s\I */
    TASK_KOJINSEISEKI,   /* `[lёI */
    TASK_RANKING,        /* LOI */
    TASK_SCHEDULE,       /* XPW[I */
    TASK_SHUUSHI,        /* xI */
    TASK_MEMO,           /* I */
    TASK_SHIAISEISEKI,   /* ёI */
    TASK_REKIDAITITLE,   /* ^CgI */
    TASK_SENSHURETUDEN,  /* I`I */
    TASK_RETURN,         /* Ƃɖ߂I */

    TASK_END
};

enum{ /* j[\ */
    MENU_R,
    MENU_R_PENANTRACE,
    MENU_R_PENANTRACE_SHOUHAIHYOU,
    MENU_R_PENANTRACE_KOJINSEISEKI,
    MENU_R_PENANTRACE_RANKING,
    MENU_R_PENANTRACE_SCHEDULE,
    MENU_R_HOUKOKU,
    MENU_R_HOUKOKU_SHUUSHI,
    MENU_R_HOUKOKU_MEMO,
    MENU_R_TEAMNOAYUMI,
    MENU_R_TEAMNOAYUMI_SHIAISEISEKI,
    MENU_R_TEAMNOAYUMI_KEIEI,
    MENU_R_YAKYUUDENDOU,
    MENU_R_YAKYUUDENDOU_REKIDAITITLE,
    MENU_R_YAKYUUDENDOU_SENSHURETUDEN,

    MENU_END
};

/*
######## }N ########
*/

/*
######## \̐錾 ########
*/

typedef struct { /* ocj[^XN\ */
    void* child;      /* q^XN*/
    Sint32 taskState; /* ^XN(enumTASK)*/
    Sint32 menuTree;  /* ݂̃j[\(enumMENU) */
} JouhouMenuTask;

/*
######## Ŏg֐̃vg^Cv錾 ########
*/

static void InitJouhouMenuTask(JouhouMenuTask* this);
static void ControlJouhouMenuTask(JouhouMenuTask* this);
static void PrintTree(void);

/*
######## ÓIϐ ########
*/

/* ^XN */
static JouhouMenuTask* jouhouMenuTask;

/* ^XN֐̒` */
static HTTaskFunc taskFunc = {
    InitJouhouMenuTask,    /*  */
    ControlJouhouMenuTask, /* Rg[ */
    NULL, /* ` */
    NULL, /* I */
};

/*
######## O[o֐ ##################################################
*/

/*************************************************************************
 *  ֐    : JouhouMenuTask_CreateTask
 *  e    : 񃁃j[^XN̍쐬
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-01 쐬Jn
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void* parent e^XNւ̃|C^
 *  out: void* jouhouMenuTask ꂽ^XNւ̃|C^
 *************************************************************************
 */
void* JouhouMenuTask_CreateTask(void* parent)
{
    jouhouMenuTask = HTTask_CreateChild(parent,
        sizeof(JouhouMenuTask), &taskFunc);
    return jouhouMenuTask;
}

/*************************************************************************
 *  ֐    : JouhouMenuTask_ChangeFlag
 *  e    : j[ItO𗧂Ă
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-01 쐬Jn
 *  Rg:
 *------------------------------------------------------------------------
 *  in : Sint32 flag tO(enumJOUHOUMENUTASK_FLAG)
 *  out: void
 *************************************************************************
 */
void JouhouMenuTask_ChangeFlag(Sint32 flag)
{
    if (flag == JOUHOUMENUTASK_FLAG_SHIAI) { /* I */
        jouhouMenuTask->taskState = TASK_SHIAI;
    }
    else if (flag == JOUHOUMENUTASK_FLAG_JINJI) { /* lI */
        jouhouMenuTask->taskState = TASK_JINJI;
    }
    else if (flag == JOUHOUMENUTASK_FLAG_KEIEI) { /* ocI */
        jouhouMenuTask->taskState = TASK_KEIEI;
    }
    else if (flag == JOUHOUMENUTASK_FLAG_IKUSEI) { /* 琬I */
        jouhouMenuTask->taskState = TASK_IKUSEI;
    }
    else if (flag == JOUHOUMENUTASK_FLAG_SHINBUN) { /* VI */
        jouhouMenuTask->taskState = TASK_SHINBUN;
    }
    else if (flag == JOUHOUMENUTASK_FLAG_YOUGOJITEN) { /* pꎫTI */
        jouhouMenuTask->taskState = TASK_YOUGOJITEN;
    }
    else if (flag == JOUHOUMENUTASK_FLAG_KIOKU) { /* LI */
        jouhouMenuTask->taskState = TASK_KIOKU;
    }
    else if (flag == JOUHOUMENUTASK_FLAG_PENANTRACE) { /* o[XI */
        jouhouMenuTask->taskState = TASK_PENANTRACE;
    }
    else if (flag == JOUHOUMENUTASK_FLAG_HOUKOKU) { /* 񍐑I */
        jouhouMenuTask->taskState = TASK_HOUKOKU;
    }
    else if (flag == JOUHOUMENUTASK_FLAG_TEAMNOAYUMI) { /* `[̕ݑI */
        jouhouMenuTask->taskState = TASK_TEAMNOAYUMI;
    }
    else if (flag == JOUHOUMENUTASK_FLAG_YAKYUUDENDOU) { /* 싅aI */
        jouhouMenuTask->taskState = TASK_YAKYUUDENDOU;
    }
    else if (flag == JOUHOUMENUTASK_FLAG_SHOUHAIHYOU) { /* s\I */
        jouhouMenuTask->taskState = TASK_SHOUHAIHYOU;
    }
    else if (flag == JOUHOUMENUTASK_FLAG_KOJINSEISEKI) { /* lёI */
        jouhouMenuTask->taskState = TASK_KOJINSEISEKI;
    }
    else if (flag == JOUHOUMENUTASK_FLAG_RANKING) { /* LOI */
        jouhouMenuTask->taskState = TASK_RANKING;
    }
    else if (flag == JOUHOUMENUTASK_FLAG_SCHEDULE) { /* XPW[I */
        jouhouMenuTask->taskState = TASK_SCHEDULE;
    }
    else if (flag == JOUHOUMENUTASK_FLAG_SHUUSHI) { /* xI */
        jouhouMenuTask->taskState = TASK_SHUUSHI;
    }
    else if (flag == JOUHOUMENUTASK_FLAG_MEMO) { /* I */
        jouhouMenuTask->taskState = TASK_MEMO;
    }
    else if (flag == JOUHOUMENUTASK_FLAG_SHIAISEISEKI) { /* ёI */
        jouhouMenuTask->taskState = TASK_SHIAISEISEKI;
    }
    else if (flag == JOUHOUMENUTASK_FLAG_REKIDAITITLE) { /* sI */
        jouhouMenuTask->taskState = TASK_REKIDAITITLE;
    }
    else if (flag == JOUHOUMENUTASK_FLAG_SENSHURETUDEN) { /* I`I */
        jouhouMenuTask->taskState = TASK_SENSHURETUDEN;
    }
    else if (flag == JOUHOUMENUTASK_FLAG_RETURN) { /* Ƃɖ߂I */
        jouhouMenuTask->taskState = TASK_RETURN;
    }
}

/*
######## [J֐ ####################################################
*/

/*************************************************************************
 *  ֐  : InitJouhouMenuTask
 *  e    : 񃁃j[^XN̏
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-01 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : JouhouMenuTask* this ^XNւ̃|C^
 *  out: void
 *************************************************************************
 */
static void InitJouhouMenuTask(JouhouMenuTask* this)
{
    /* ϐ */
    this->child = NULL;
    this->taskState = TASK_STABLE;
    this->menuTree = MENU_R;

    /* 񃁃j[EBhE쐬 */
    JouhouMenuWin_CreateWindow(TASKID_JOUHOU);
}

/*************************************************************************
 *  ֐  : ControlJouhouMenuTask
 *  e    : EBhE
 *            ^XÑRg[֐
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-01 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : JouhouMenuTask* this ^XNւ̃|C^
 *  out: void
 *************************************************************************
 */
static void ControlJouhouMenuTask(JouhouMenuTask* this)
{
    /* ^XNԃ`FbN */
    if (this->taskState == TASK_STABLE) { /* ωiVȂ牽Ȃ */
    }
    else if (this->taskState == TASK_SHIAI) { /* I */
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_JINJI) { /* lI */
        /* gbv^XÑj[ړtO𗧂Ă */
        TopTask_ChangeFlag(TOPTASK_FLAG_JINJI);
        /* Cj[EBhE */
        JouhouMenuWin_CloseWindow();
        /* ^XNI */
        HTTask_Delete();
    }
    else if (this->taskState == TASK_KEIEI) { /* ocI */
        /* ̈ʒuCj[Ȃ */
        if (this->menuTree == MENU_R) {
            TopTask_ChangeFlag(TOPTASK_FLAG_KEIEI);
            JouhouMenuWin_CloseWindow();
            HTTask_Delete();
        }
        /* ̈ʒu`[݃̕j[Ȃ */
        else if (this->menuTree == MENU_R_TEAMNOAYUMI) {
            this->menuTree = MENU_R_TEAMNOAYUMI_KEIEI;
            JouhouMenuWin_UnMapWindow();
            TeamNoAyumiMenuWin_UnMapWindow();
            TuusanKeieiWin_CreateWindow(TASKID_JOUHOU);
            this->taskState = TASK_STABLE;
        }
    }
    else if (this->taskState == TASK_IKUSEI) { /* 琬I */
        TopTask_ChangeFlag(TOPTASK_FLAG_IKUSEI);
        JouhouMenuWin_CloseWindow();
        HTTask_Delete();
    }
    else if (this->taskState == TASK_SHINBUN) { /* VI */
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_YOUGOJITEN) { /* pꎫTI */
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_KIOKU) { /* LI */
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_PENANTRACE) { /* yig[XI */
        /* j[\ύX */
        this->menuTree = MENU_R_PENANTRACE;
        /* yig[Xj[쐬 */
        PenantRaceMenuWin_CreateWindow(TASKID_JOUHOU);
        /* ^XNԂ߂ */
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_HOUKOKU) { /* 񍐑I */
        this->menuTree = MENU_R_HOUKOKU;
        HoukokuMenuWin_CreateWindow(TASKID_JOUHOU);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_TEAMNOAYUMI) { /* `[̕ݑI */
        this->menuTree = MENU_R_TEAMNOAYUMI;
        TeamNoAyumiMenuWin_CreateWindow(TASKID_JOUHOU);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_YAKYUUDENDOU) { /* 싅aI */
        this->menuTree = MENU_R_YAKYUUDENDOU;
        YakyuuDendouMenuWin_CreateWindow(TASKID_JOUHOU);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_SHOUHAIHYOU) { /*s\I */
        this->menuTree = MENU_R_PENANTRACE_SHOUHAIHYOU;
        JouhouMenuWin_UnMapWindow();
        PenantRaceMenuWin_UnMapWindow();
        ShouhaihyouWin_CreateWindow(TASKID_JOUHOU);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_KOJINSEISEKI) { /*`[lёI */
        this->menuTree = MENU_R_PENANTRACE_KOJINSEISEKI;
        JouhouMenuWin_UnMapWindow();
        PenantRaceMenuWin_UnMapWindow();
        SenshuSeisekiWin_CreateWindow(TASKID_JOUHOU);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_RANKING) { /*LOI */
        this->menuTree = MENU_R_PENANTRACE_RANKING;
        JouhouMenuWin_UnMapWindow();
        PenantRaceMenuWin_UnMapWindow();
        SenshuRankingWin_CreateWindow(TASKID_JOUHOU);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_SCHEDULE) { /*XPW[I */
        this->menuTree = MENU_R_PENANTRACE_SCHEDULE;
        JouhouMenuWin_UnMapWindow();
        PenantRaceMenuWin_UnMapWindow();
        ScheduleWin_CreateWindow(TASKID_JOUHOU);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_SHUUSHI) { /* xI */
        this->menuTree = MENU_R_HOUKOKU_SHUUSHI;
        JouhouMenuWin_UnMapWindow();
        HoukokuMenuWin_UnMapWindow();
        ShuushiWin_CreateWindow(TASKID_JOUHOU);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_MEMO) { /* I */
        this->menuTree = MENU_R_HOUKOKU_MEMO;
        JouhouMenuWin_UnMapWindow();
        HoukokuMenuWin_UnMapWindow();
        MemoWin_CreateWindow(TASKID_JOUHOU);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_SHIAISEISEKI) { /* ёI */
        this->menuTree = MENU_R_TEAMNOAYUMI_SHIAISEISEKI;
        JouhouMenuWin_UnMapWindow();
        TeamNoAyumiMenuWin_UnMapWindow();
        ShiaiSeisekiWin_CreateWindow(TASKID_JOUHOU);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_REKIDAITITLE) { /* ^CgI */
        this->menuTree = MENU_R_YAKYUUDENDOU_REKIDAITITLE;
        JouhouMenuWin_UnMapWindow();
        YakyuuDendouMenuWin_UnMapWindow();
        RekidaiTitleWin_CreateWindow(TASKID_JOUHOU);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_SENSHURETUDEN) { /* I`I */
        this->menuTree = MENU_R_YAKYUUDENDOU_SENSHURETUDEN;
        JouhouMenuWin_UnMapWindow();
        YakyuuDendouMenuWin_UnMapWindow();
        SenshuRetudenWin_CreateWindow(TASKID_JOUHOU);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_RETURN) { /* Ƃɖ߂I */
        /* ̈ʒuyig[Xj[Ȃ */
        if (this->menuTree == MENU_R_PENANTRACE) {
            this->menuTree = MENU_R;
            PenantRaceMenuWin_CloseWindow();
        }
        else if (this->menuTree == MENU_R_PENANTRACE_SHOUHAIHYOU) {
            this->menuTree = MENU_R_PENANTRACE;
            ShouhaihyouWin_CloseWindow();
            JouhouMenuWin_MapWindow();
            PenantRaceMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_PENANTRACE_KOJINSEISEKI) {
            this->menuTree = MENU_R_PENANTRACE;
            SenshuSeisekiWin_CloseWindow();
            JouhouMenuWin_MapWindow();
            PenantRaceMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_PENANTRACE_RANKING) {
            this->menuTree = MENU_R_PENANTRACE;
            SenshuRankingWin_CloseWindow();
            JouhouMenuWin_MapWindow();
            PenantRaceMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_PENANTRACE_SCHEDULE) {
            this->menuTree = MENU_R_PENANTRACE;
            ScheduleWin_CloseWindow();
            JouhouMenuWin_MapWindow();
            PenantRaceMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_HOUKOKU) {
            this->menuTree = MENU_R;
            HoukokuMenuWin_CloseWindow();
        }
        else if (this->menuTree == MENU_R_HOUKOKU_SHUUSHI) {
            this->menuTree = MENU_R_HOUKOKU;
            ShuushiWin_CloseWindow();
            JouhouMenuWin_MapWindow();
            HoukokuMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_HOUKOKU_MEMO) {
            this->menuTree = MENU_R_HOUKOKU;
            MemoWin_CloseWindow();
            JouhouMenuWin_MapWindow();
            HoukokuMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_TEAMNOAYUMI) {
            this->menuTree = MENU_R;
            TeamNoAyumiMenuWin_CloseWindow();
        }
        else if (this->menuTree == MENU_R_TEAMNOAYUMI_SHIAISEISEKI) {
            this->menuTree = MENU_R_TEAMNOAYUMI;
            ShiaiSeisekiWin_CloseWindow();
            JouhouMenuWin_MapWindow();
            TeamNoAyumiMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_TEAMNOAYUMI_KEIEI) {
            this->menuTree = MENU_R_TEAMNOAYUMI;
            TuusanKeieiWin_CloseWindow();
            JouhouMenuWin_MapWindow();
            TeamNoAyumiMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_YAKYUUDENDOU) {
            this->menuTree = MENU_R;
            YakyuuDendouMenuWin_CloseWindow();
        }
        else if (this->menuTree == MENU_R_YAKYUUDENDOU_REKIDAITITLE) {
            this->menuTree = MENU_R_YAKYUUDENDOU;
            RekidaiTitleWin_CloseWindow();
            JouhouMenuWin_MapWindow();
            YakyuuDendouMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_YAKYUUDENDOU_SENSHURETUDEN) {
            this->menuTree = MENU_R_YAKYUUDENDOU;
            SenshuRetudenWin_CloseWindow();
            JouhouMenuWin_MapWindow();
            YakyuuDendouMenuWin_MapWindow();
        }
        this->taskState = TASK_STABLE;
    }
    PrintTree(); /* j[c[\ */
}

/*************************************************************************
 *  ֐  : PrintTree
 *  e    : j[c[\(fobO)
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-01 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
static void PrintTree(void)
{
    if (jouhouMenuTask->menuTree == MENU_R) {
        njPrintC(NJM_LOCATION(0,0), "JOUHOU");
    }
    else if (jouhouMenuTask->menuTree == MENU_R_PENANTRACE) {
        njPrintC(NJM_LOCATION(0,0), "JOUHOU_PENANTRACE");
    }
    else if (jouhouMenuTask->menuTree == MENU_R_PENANTRACE_SHOUHAIHYOU) {
        njPrintC(NJM_LOCATION(0,0), "JOUHOU_PENANTRACE_SHOUHAIHYOU");
    }
    else if (jouhouMenuTask->menuTree == MENU_R_PENANTRACE_KOJINSEISEKI) {
        njPrintC(NJM_LOCATION(0,0), "JOUHOU_PENANTRACE_KOJINSEISEKI");
    }
    else if (jouhouMenuTask->menuTree == MENU_R_PENANTRACE_RANKING) {
        njPrintC(NJM_LOCATION(0,0), "JOUHOU_PENANTRACE_RANKING");
    }
    else if (jouhouMenuTask->menuTree == MENU_R_PENANTRACE_SCHEDULE) {
        njPrintC(NJM_LOCATION(0,0), "JOUHOU_PENANTRACE_SCHEDULE");
    }
    else if (jouhouMenuTask->menuTree == MENU_R_HOUKOKU) {
        njPrintC(NJM_LOCATION(0,0), "JOUHOU_HOUKOKU");
    }
    else if (jouhouMenuTask->menuTree == MENU_R_HOUKOKU_SHUUSHI) {
        njPrintC(NJM_LOCATION(0,0), "JOUHOU_HOUKOKU_SHUUSHI");
    }
    else if (jouhouMenuTask->menuTree == MENU_R_HOUKOKU_MEMO) {
        njPrintC(NJM_LOCATION(0,0), "JOUHOU_HOUKOKU_MEMO");
    }
    else if (jouhouMenuTask->menuTree == MENU_R_TEAMNOAYUMI) {
        njPrintC(NJM_LOCATION(0,0), "JOUHOU_TEAMNOAYUMI");
    }
    else if (jouhouMenuTask->menuTree == MENU_R_TEAMNOAYUMI_SHIAISEISEKI) {
        njPrintC(NJM_LOCATION(0,0), "JOUHOU_TEAMNOAYUMI_SHIAISEISEKI");
    }
    else if (jouhouMenuTask->menuTree == MENU_R_TEAMNOAYUMI_KEIEI) {
        njPrintC(NJM_LOCATION(0,0), "JOUHOU_TEAMNOAYUMI_KEIEI");
    }
    else if (jouhouMenuTask->menuTree == MENU_R_YAKYUUDENDOU) {
        njPrintC(NJM_LOCATION(0,0), "JOUHOU_YAKYUUDENDOU");
    }
    else if (jouhouMenuTask->menuTree == MENU_R_YAKYUUDENDOU_REKIDAITITLE) {
        njPrintC(NJM_LOCATION(0,0), "JOUHOU_YAKYUUDENDOU_REKIDAITITLE");
    }
    else if (jouhouMenuTask->menuTree == MENU_R_YAKYUUDENDOU_SENSHURETUDEN) {
        njPrintC(NJM_LOCATION(0,0), "JOUHOU_YAKYUUDENDOU_SENSHURETUDEN");
    }
}

/*
######## ܂ ########################################################
*/
