
/*************************************************************************
 *  t@C     : keieimenutask.c
 *  e           : ocj[^XN쐬Ǘ
 *  vtBbNX : KeieiMenuTask
 *  쐬         :  j (Yoshio Hashiguchi)
 *  쐬         : 98-07-01 쐬Jn
 *  Rg       :
 *  o[W     : 0.01
 ************************************************************************/

#define __KEIEIMENUTASK_C

/*
######## CN[ht@C ########
*/

#include <ninja.h>
#include <ninjawin.h>
#include <njdef.h>

#include <httask_mgr.h>

#include "toptask.h"

#include "taskid.h"
#include "keieimenuwin.h"
#include "shisetuseibimenuwin.h"
#include "kouhoumenuwin.h"
#include "kenkyuukaihatumenuwin.h"
#include "sidebusinessmenuwin.h"
#include "toushimenuwin.h"
#include "kyuujousentakuwin.h"
#include "groundsetubisentakuwin.h"
#include "goodssentakuwin.h"
#include "itemsentakuwin.h"
#include "keiretujigyousentakuwin.h"
#include "chiikisentakujwin.h"
#include "chiikisentakufwin.h"

#include "keieimenutask.h"


/*
######## 萔錾 ########
*/
enum{ /* ^XN̏ */
    TASK_STABLE,         /* ωiV */
    TASK_SHIAI,          /* I */
    TASK_JINJI,          /* lI */
    TASK_JOUHOU,         /* I */
    TASK_IKUSEI,         /* 琬I */
    TASK_KIOKU,          /* LI */
    TASK_SHISETUSEIBI,   /* {݁EI */
    TASK_KOUHOU,         /* LI */
    TASK_KENKYUUKAIHATU, /* JI */
    TASK_SIDEBUSINESS,   /* TChrWlXI */
    TASK_KYUJOTUKU,      /* ザI */
    TASK_GROUND,         /* OEhI */
    TASK_JINKOUKAKUDAI,  /* 싅l̊gI */
    TASK_KYUUDANAPPEAL,  /* c̃As[I */
    TASK_SENSHUAPPEAL,   /* ĨAs[I */
    TASK_GOODS,          /* ObYI */
    TASK_ITEM,           /* ACeI */
    TASK_KEIRETUJIGYOU,  /* n񎖋ƑI */
    TASK_TOUSHI,         /* I */
    TASK_KOKUNAI,        /* I */
    TASK_KAIGAI,         /* COI */
    TASK_RETURN,         /* Ƃɖ߂I */

    TASK_END
};

enum{ /* j[\ */
    MENU_R,
    MENU_R_SHISETUSEIBI,
    MENU_R_SHISETUSEIBI_KYUJOTUKU,
    MENU_R_SHISETUSEIBI_GROUND,
    MENU_R_KOUHOU,
    MENU_R_KOUHOU_JINKOUKAKUDAI,
    MENU_R_KOUHOU_KYUUDANAPPEAL,
    MENU_R_KOUHOU_SENSHUAPPEAL,
    MENU_R_KENKYUUKAIHATU,
    MENU_R_KENKYUUKAIHATU_GOODS,
    MENU_R_KENKYUUKAIHATU_ITEM,
    MENU_R_SIDEBUSINESS,
    MENU_R_SIDEBUSINESS_KEIRETUJIGYOU,
    MENU_R_SIDEBUSINESS_TOUSHI,
    MENU_R_SIDEBUSINESS_TOUSHI_KOKUNAI,
    MENU_R_SIDEBUSINESS_TOUSHI_KAIGAI,

    MENU_END
};

/*
######## }N ########
*/

/*
######## \̐錾 ########
*/

typedef struct { /* ocj[^XN\ */
    void* child;      /* q^XN*/
    Sint32 taskState; /* ^XN(enumTASK)*/
    Sint32 menuTree;  /* ݂̃j[\(enumMENU) */
} KeieiMenuTask;

/*
######## Ŏg֐̃vg^Cv錾 ########
*/

static void InitKeieiMenuTask(KeieiMenuTask* this);
static void ControlKeieiMenuTask(KeieiMenuTask* this);
static void PrintTree(void);

/*
######## ÓIϐ ########
*/

/* ^XN */
static KeieiMenuTask* keieiMenuTask;

/* ^XN֐̒` */
static HTTaskFunc taskFunc = {
    InitKeieiMenuTask,    /*  */
    ControlKeieiMenuTask, /* Rg[ */
    NULL, /* ` */
    NULL, /* I */
};

/*
######## O[o֐ ##################################################
*/

/*************************************************************************
 *  ֐    : KeieiMenuTask_CreateTask
 *  e    : ocj[^XN̍쐬
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-01 쐬Jn
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void* parent e^XNւ̃|C^
 *  out: void* keieiMenuTask ꂽ^XNւ̃|C^
 *************************************************************************
 */
void* KeieiMenuTask_CreateTask(void* parent)
{
    keieiMenuTask = HTTask_CreateChild(parent,
        sizeof(KeieiMenuTask), &taskFunc);
    return keieiMenuTask;
}

/*************************************************************************
 *  ֐    : KeieiMenuTask_ChangeFlag
 *  e    : j[ItO𗧂Ă
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-01 쐬Jn
 *  Rg:
 *------------------------------------------------------------------------
 *  in : Sint32 flag tO(enumKEIEIMENUTASK_FLAG)
 *  out: void
 *************************************************************************
 */
void KeieiMenuTask_ChangeFlag(Sint32 flag)
{
    if (flag == KEIEIMENUTASK_FLAG_SHIAI) { /* I */
        keieiMenuTask->taskState = TASK_SHIAI;
    }
    else if (flag == KEIEIMENUTASK_FLAG_JINJI) { /* lI */
        keieiMenuTask->taskState = TASK_JINJI;
    }
    else if (flag == KEIEIMENUTASK_FLAG_JOUHOU) { /* I */
        keieiMenuTask->taskState = TASK_JOUHOU;
    }
    else if (flag == KEIEIMENUTASK_FLAG_IKUSEI) { /* 琬I */
        keieiMenuTask->taskState = TASK_IKUSEI;
    }
    else if (flag == KEIEIMENUTASK_FLAG_KIOKU) { /* LI */
        keieiMenuTask->taskState = TASK_KIOKU;
    }
    else if (flag == KEIEIMENUTASK_FLAG_SHISETUSEIBI) { /* {݁EI */
        keieiMenuTask->taskState = TASK_SHISETUSEIBI;
    }
    else if (flag == KEIEIMENUTASK_FLAG_KOUHOU) { /* LI */
        keieiMenuTask->taskState = TASK_KOUHOU;
    }
    else if (flag == KEIEIMENUTASK_FLAG_KENKYUUKAIHATU) { /* JI */
        keieiMenuTask->taskState = TASK_KENKYUUKAIHATU;
    }
    else if (flag == KEIEIMENUTASK_FLAG_SIDEBUSINESS) { /* TChrWlX */
        keieiMenuTask->taskState = TASK_SIDEBUSINESS;
    }
    else if (flag == KEIEIMENUTASK_FLAG_KYUJOTUKU) { /* ザI */
        keieiMenuTask->taskState = TASK_KYUJOTUKU;
    }
    else if (flag == KEIEIMENUTASK_FLAG_GROUND) { /* OEhI */
        keieiMenuTask->taskState = TASK_GROUND;
    }
    else if (flag == KEIEIMENUTASK_FLAG_JINKOUKAKUDAI) { /* lgI */
        keieiMenuTask->taskState = TASK_JINKOUKAKUDAI;
    }
    else if (flag == KEIEIMENUTASK_FLAG_KYUUDANAPPEAL) { /* cAs[ */
        keieiMenuTask->taskState = TASK_KYUUDANAPPEAL;
    }
    else if (flag == KEIEIMENUTASK_FLAG_SENSHUAPPEAL) { /* IAs[ */
        keieiMenuTask->taskState = TASK_SENSHUAPPEAL;
    }
    else if (flag == KEIEIMENUTASK_FLAG_GOODS) { /* ObYI */
        keieiMenuTask->taskState = TASK_GOODS;
    }
    else if (flag == KEIEIMENUTASK_FLAG_ITEM) { /* ACeI */
        keieiMenuTask->taskState = TASK_ITEM;
    }
    else if (flag == KEIEIMENUTASK_FLAG_KEIRETUJIGYOU) { /* n񎖋ƑI */
        keieiMenuTask->taskState = TASK_KEIRETUJIGYOU;
    }
    else if (flag == KEIEIMENUTASK_FLAG_TOUSHI) { /* I */
        keieiMenuTask->taskState = TASK_TOUSHI;
    }
    else if (flag == KEIEIMENUTASK_FLAG_KOKUNAI) { /* I */
        keieiMenuTask->taskState = TASK_KOKUNAI;
    }
    else if (flag == KEIEIMENUTASK_FLAG_KAIGAI) { /* COI */
        keieiMenuTask->taskState = TASK_KAIGAI;
    }
    else if (flag == KEIEIMENUTASK_FLAG_RETURN) { /* Ƃɖ߂I */
        keieiMenuTask->taskState = TASK_RETURN;
    }
}

/*
######## [J֐ ####################################################
*/

/*************************************************************************
 *  ֐  : InitKeieiMenuTask
 *  e    : ocj[^XN̏
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-01 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : KeieiMenuTask* this ^XNւ̃|C^
 *  out: void
 *************************************************************************
 */
static void InitKeieiMenuTask(KeieiMenuTask* this)
{
    /* ϐ */
    this->child = NULL;
    this->taskState = TASK_STABLE;
    this->menuTree = MENU_R;

    /* ocj[EBhE쐬 */
    KeieiMenuWin_CreateWindow(TASKID_KEIEI);
}

/*************************************************************************
 *  ֐  : ControlKeieiMenuTask
 *  e    : EBhE
 *            ^XÑRg[֐
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-01 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : KeieiMenuTask* this ^XNւ̃|C^
 *  out: void
 *************************************************************************
 */
static void ControlKeieiMenuTask(KeieiMenuTask* this)
{
    /* ^XNԃ`FbN */
    if (this->taskState == TASK_STABLE) { /* ωiVȂ牽Ȃ */
    }
    else if (this->taskState == TASK_SHIAI) { /* I */
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_JINJI) { /* lI */
        /* gbv^XÑj[ړtO𗧂Ă */
        TopTask_ChangeFlag(TOPTASK_FLAG_JINJI);
        /* Cj[EBhE */
        KeieiMenuWin_CloseWindow();
        /* ^XNI */
        HTTask_Delete();
    }
    else if (this->taskState == TASK_JOUHOU) { /* I */
        TopTask_ChangeFlag(TOPTASK_FLAG_JOUHOU);
        KeieiMenuWin_CloseWindow();
        HTTask_Delete();
    }
    else if (this->taskState == TASK_IKUSEI) { /* 琬I */
        TopTask_ChangeFlag(TOPTASK_FLAG_IKUSEI);
        KeieiMenuWin_CloseWindow();
        HTTask_Delete();
    }
    else if (this->taskState == TASK_KIOKU) { /* LI */
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_SHISETUSEIBI) { /* {݁EI */
        /* j[\ύX */
        this->menuTree = MENU_R_SHISETUSEIBI;
        /* {݁Ej[쐬 */
        ShisetuSeibiMenuWin_CreateWindow(TASKID_KEIEI);
        /* ^XNԂ߂ */
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_KOUHOU) { /* LI */
        this->menuTree = MENU_R_KOUHOU;
        KouhouMenuWin_CreateWindow(TASKID_KEIEI);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_KENKYUUKAIHATU) { /* JI */
        this->menuTree = MENU_R_KENKYUUKAIHATU;
        KenkyuuKaihatuMenuWin_CreateWindow(TASKID_KEIEI);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_SIDEBUSINESS) { /* TChrWlXI */
        this->menuTree = MENU_R_SIDEBUSINESS;
        SideBusinessMenuWin_CreateWindow(TASKID_KEIEI);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_KYUJOTUKU) { /* ザI */
        /* j[\ύX */
        this->menuTree = MENU_R_SHISETUSEIBI_KYUJOTUKU;
        /* ܂ł̃EBhEB */
        KeieiMenuWin_UnMapWindow();
        ShisetuSeibiMenuWin_UnMapWindow();
        /* IEBhE쐬 */
        KyuujouSentakuWin_CreateWindow(TASKID_KEIEI);
        /* ^XNԂ߂ */
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_GROUND) { /* OEhI */
        this->menuTree = MENU_R_SHISETUSEIBI_GROUND;
        KeieiMenuWin_UnMapWindow();
        ShisetuSeibiMenuWin_UnMapWindow();
        GroundSetubiSentakuWin_CreateWindow(TASKID_KEIEI);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_JINKOUKAKUDAI) { /* lgI */
        this->menuTree = MENU_R_KOUHOU_JINKOUKAKUDAI;
        KeieiMenuWin_UnMapWindow();
        KouhouMenuWin_UnMapWindow();
        ChiikiSentakuJWin_CreateWindow(TASKID_KEIEI);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_KYUUDANAPPEAL) { /* cAs[I */
        this->menuTree = MENU_R_KOUHOU_KYUUDANAPPEAL;
        KeieiMenuWin_UnMapWindow();
        KouhouMenuWin_UnMapWindow();
        ChiikiSentakuJWin_CreateWindow(TASKID_KEIEI);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_SENSHUAPPEAL) { /* IAs[I */
        this->menuTree = MENU_R_KOUHOU_SENSHUAPPEAL;
        KeieiMenuWin_UnMapWindow();
        KouhouMenuWin_UnMapWindow();
        ChiikiSentakuJWin_CreateWindow(TASKID_KEIEI);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_GOODS) { /* ObYI */
        this->menuTree = MENU_R_KENKYUUKAIHATU_GOODS;
        KeieiMenuWin_UnMapWindow();
        KenkyuuKaihatuMenuWin_UnMapWindow();
        GoodsSentakuWin_CreateWindow(TASKID_KEIEI);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_ITEM) { /* ACeI */
        this->menuTree = MENU_R_KENKYUUKAIHATU_ITEM;
        KeieiMenuWin_UnMapWindow();
        KenkyuuKaihatuMenuWin_UnMapWindow();
        ItemSentakuWin_CreateWindow(TASKID_KEIEI);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_KEIRETUJIGYOU) { /* n񎖋ƑI */
        this->menuTree = MENU_R_SIDEBUSINESS_KEIRETUJIGYOU;
        KeieiMenuWin_UnMapWindow();
        SideBusinessMenuWin_UnMapWindow();
        KeiretuJigyouSentakuWin_CreateWindow(TASKID_KEIEI);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_TOUSHI) { /* I */
        this->menuTree = MENU_R_SIDEBUSINESS_TOUSHI;
        ToushiMenuWin_CreateWindow(TASKID_KEIEI);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_KOKUNAI) { /* I */
        this->menuTree = MENU_R_SIDEBUSINESS_TOUSHI_KOKUNAI;
        KeieiMenuWin_UnMapWindow();
        SideBusinessMenuWin_UnMapWindow();
        ToushiMenuWin_UnMapWindow();
        ChiikiSentakuJWin_CreateWindow(TASKID_KEIEI);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_KAIGAI) { /* COI */
        this->menuTree = MENU_R_SIDEBUSINESS_TOUSHI_KAIGAI;
        KeieiMenuWin_UnMapWindow();
        SideBusinessMenuWin_UnMapWindow();
        ToushiMenuWin_UnMapWindow();
        ChiikiSentakuFWin_CreateWindow(TASKID_KEIEI);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_RETURN) { /* Ƃɖ߂I */
        /* ̈ʒu{ݐj[Ȃ */
        if (this->menuTree == MENU_R_SHISETUSEIBI) {
            this->menuTree = MENU_R;
            ShisetuSeibiMenuWin_CloseWindow();
        }
        else if (this->menuTree == MENU_R_SHISETUSEIBI_KYUJOTUKU) {
            this->menuTree = MENU_R_SHISETUSEIBI;
            KyuujouSentakuWin_CloseWindow();
            KeieiMenuWin_MapWindow();
            ShisetuSeibiMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_SHISETUSEIBI_GROUND) {
            this->menuTree = MENU_R_SHISETUSEIBI;
            GroundSetubiSentakuWin_CloseWindow();
            KeieiMenuWin_MapWindow();
            ShisetuSeibiMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_KOUHOU) {
            this->menuTree = MENU_R;
            KouhouMenuWin_CloseWindow();
        }
        else if (this->menuTree == MENU_R_KOUHOU_JINKOUKAKUDAI) {
            this->menuTree = MENU_R_KOUHOU;
            ChiikiSentakuJWin_CloseWindow();
            KeieiMenuWin_MapWindow();
            KouhouMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_KOUHOU_KYUUDANAPPEAL) {
            this->menuTree = MENU_R_KOUHOU;
            ChiikiSentakuJWin_CloseWindow();
            KeieiMenuWin_MapWindow();
            KouhouMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_KOUHOU_SENSHUAPPEAL) {
            this->menuTree = MENU_R_KOUHOU;
            ChiikiSentakuJWin_CloseWindow();
            KeieiMenuWin_MapWindow();
            KouhouMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_KENKYUUKAIHATU) {
            this->menuTree = MENU_R;
            KenkyuuKaihatuMenuWin_CloseWindow();
        }
        else if (this->menuTree == MENU_R_KENKYUUKAIHATU_GOODS) {
            this->menuTree = MENU_R_KENKYUUKAIHATU;
            GoodsSentakuWin_CloseWindow();
            KeieiMenuWin_MapWindow();
            KenkyuuKaihatuMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_KENKYUUKAIHATU_ITEM) {
            this->menuTree = MENU_R_KENKYUUKAIHATU;
            ItemSentakuWin_CloseWindow();
            KeieiMenuWin_MapWindow();
            KenkyuuKaihatuMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_SIDEBUSINESS) {
            this->menuTree = MENU_R;
            SideBusinessMenuWin_CloseWindow();
        }
        else if (this->menuTree == MENU_R_SIDEBUSINESS_KEIRETUJIGYOU) {
            this->menuTree = MENU_R_SIDEBUSINESS;
            KeiretuJigyouSentakuWin_CloseWindow();
            KeieiMenuWin_MapWindow();
            SideBusinessMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_SIDEBUSINESS_TOUSHI) {
            this->menuTree = MENU_R_SIDEBUSINESS;
            ToushiMenuWin_CloseWindow();
        }
        else if (this->menuTree == MENU_R_SIDEBUSINESS_TOUSHI_KOKUNAI) {
            this->menuTree = MENU_R_SIDEBUSINESS_TOUSHI;
            ChiikiSentakuJWin_CloseWindow();
            KeieiMenuWin_MapWindow();
            SideBusinessMenuWin_MapWindow();
            ToushiMenuWin_MapWindow();
        }
        else if (this->menuTree == MENU_R_SIDEBUSINESS_TOUSHI_KAIGAI) {
            this->menuTree = MENU_R_SIDEBUSINESS_TOUSHI;
            ChiikiSentakuFWin_CloseWindow();
            KeieiMenuWin_MapWindow();
            SideBusinessMenuWin_MapWindow();
            ToushiMenuWin_MapWindow();
        }
        this->taskState = TASK_STABLE;
    }
    PrintTree(); /* j[c[\ */
}

/*************************************************************************
 *  ֐  : PrintTree
 *  e    : j[c[\(fobO)
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-01 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
static void PrintTree(void)
{
    if (keieiMenuTask->menuTree == MENU_R) {
        njPrintC(NJM_LOCATION(0,0), "KEIEI");
    }
    else if (keieiMenuTask->menuTree == MENU_R_SHISETUSEIBI) {
        njPrintC(NJM_LOCATION(0,0), "KEIEI_SHISETUSEIBI");
    }
    else if (keieiMenuTask->menuTree == MENU_R_SHISETUSEIBI_KYUJOTUKU) {
        njPrintC(NJM_LOCATION(0,0), "KEIEI_SHISETUSEIBI_KYUJOTUKU");
    }
    else if (keieiMenuTask->menuTree == MENU_R_SHISETUSEIBI_GROUND) {
        njPrintC(NJM_LOCATION(0,0), "KEIEI_SHISETUSEIBI_GROUND");
    }
    else if (keieiMenuTask->menuTree == MENU_R_KOUHOU) {
        njPrintC(NJM_LOCATION(0,0), "KEIEI_KOUHOU");
    }
    else if (keieiMenuTask->menuTree == MENU_R_KOUHOU_JINKOUKAKUDAI) {
        njPrintC(NJM_LOCATION(0,0), "KEIEI_KOUHOU_JINKOUKAKUDAI");
    }
    else if (keieiMenuTask->menuTree == MENU_R_KOUHOU_KYUUDANAPPEAL) {
        njPrintC(NJM_LOCATION(0,0), "KEIEI_KOUHOU_KYUUDANAPPEAL");
    }
    else if (keieiMenuTask->menuTree == MENU_R_KOUHOU_SENSHUAPPEAL) {
        njPrintC(NJM_LOCATION(0,0), "KEIEI_KOUHOU_SENSHUAPPEAL");
    }
    else if (keieiMenuTask->menuTree == MENU_R_KENKYUUKAIHATU) {
        njPrintC(NJM_LOCATION(0,0), "KEIEI_KENKYUUKAIHATU");
    }
    else if (keieiMenuTask->menuTree == MENU_R_KENKYUUKAIHATU_GOODS) {
        njPrintC(NJM_LOCATION(0,0), "KEIEI_KENKYUUKAIHATU_GOODS");
    }
    else if (keieiMenuTask->menuTree == MENU_R_KENKYUUKAIHATU_ITEM) {
        njPrintC(NJM_LOCATION(0,0), "KEIEI_KENKYUUKAIHATU_ITEM");
    }
    else if (keieiMenuTask->menuTree == MENU_R_SIDEBUSINESS) {
        njPrintC(NJM_LOCATION(0,0), "KEIEI_SIDEBUSINESS");
    }
    else if (keieiMenuTask->menuTree == MENU_R_SIDEBUSINESS_KEIRETUJIGYOU) {
        njPrintC(NJM_LOCATION(0,0), "KEIEI_SIDEBUSINESS_KEIRETUJIGYOU");
    }
    else if (keieiMenuTask->menuTree == MENU_R_SIDEBUSINESS_TOUSHI) {
        njPrintC(NJM_LOCATION(0,0), "KEIEI_SIDEBUSINESS_TOUSHI");
    }
    else if (keieiMenuTask->menuTree == MENU_R_SIDEBUSINESS_TOUSHI_KOKUNAI) {
        njPrintC(NJM_LOCATION(0,0), "KEIEI_SIDEBUSINESS_TOUSHI_KOKUNAI");
    }
    else if (keieiMenuTask->menuTree == MENU_R_SIDEBUSINESS_TOUSHI_KAIGAI) {
        njPrintC(NJM_LOCATION(0,0), "KEIEI_SIDEBUSINESS_TOUSHI_KAIGAI");
    }
}

/*
######## ܂ ########################################################
*/
