
/*************************************************************************
 *  t@C     : kenkyuukaihatumenuwin.c
 *  e           : Jj[EBhE쐬Ǘ
 *  vtBbNX : KenkyuuKaihatuMenuWin
 *  쐬         :  j (Yoshio Hashiguchi)
 *  쐬         : 98-07-01 쐬Jn
 *  Rg       :
 *  o[W     : 0.01
 ************************************************************************/

#define __KENKYUUKAIHATUMENUWIN_C

/*
######## CN[ht@C ########
*/

#include <ninja.h>
#include <ninjawin.h>
#include <njdef.h>

#include <htwindow.h>
#include <htwinbuttonarray.h>

#include "windef.h"
#include "wintex.h"

#include "keieimenutask.h"
#include "taskid.h"

#include "kenkyuukaihatumenuwin.h"

/*
######## 萔錾 ########
*/

/* EBhEW */
#define WINPOS_LEFT (SUBMENU1_POS_LEFT)
#define WINPOS_TOP (SUBMENU1_POS_TOP)

/* EBhE̔zF */
#define WINFGCOLOR (ARGB(0, 0, 0, 0)) /* OʐF(iKł͕sgp) */
#define WINBGCOLOR (ARGB(150, 75, 75, 50)) /* wiF */

#define BTNNUM (3) /* {^ */
#define BTNSIZE_X (STRTEXSIZE_X(8)) /* {^wTCY */
#define BTNSIZE_Y (STRTEXSIZE_Y(2)) /* {^xTCY */

/*
######## }N ########
*/

/*
######## \̐錾 ########
*/

/*
######## Ŏg֐̃vg^Cv錾 ########
*/

static void SetBtnAttr(void);
static void SetBtnCallBack(void);

static void PushGoods(LPHTtButtonArg arg);
static void PushItem(LPHTtButtonArg arg);
static void PushReturn(LPHTtButtonArg arg);

/*
######## ÓIϐ ########
*/

/* EBhEnh */
HTWINHANDLE kenkyuuKaihatuMenuWin;

/* Ǘ^XN̂hc */
Sint32 taskID;

/* {^EBhEpp[^ */
static HTtButtonArg btnArg[BTNNUM];

/* {^pACẽAgr[g */
static HTtItemAttr itemAttr[] = {
  /* Polygon/Texture      TextureID          COLOR          UV */
    ITEM_ATTR_TEXTURE, WINTEXID_GOODS,  COL4_BLUE_WHITE,  UV4_88,
    ITEM_ATTR_TEXTURE, WINTEXID_ITEM,   COL4_BLUE_WHITE,  UV4_88,
    ITEM_ATTR_TEXTURE, WINTEXID_RETURN, COL4_RED_WHITE,   UV4_88,
};

/* {^pACe̍쐬 */
static HTtItem btnItem[BTNNUM] = {
  /*  ItemPtr            TCY          iӖj */
    1, &itemAttr[0],  BTNSIZE_X, BTNSIZE_Y,  0, 0,
    1, &itemAttr[1],  BTNSIZE_X, BTNSIZE_Y,  0, 0,
    1, &itemAttr[2],  BTNSIZE_X, BTNSIZE_Y,  0, 0,
};

/* J[\{^ɂƂɌĂ΂R[obN֐ */
static void (*onBtnCallBack[BTNNUM])(LPHTtButtonArg arg) = {
    NULL,
    NULL,
    NULL,
};

/* {^IꂽƂɌĂ΂R[obN֐ */
static void (*pushBtnCallBack[BTNNUM])(LPHTtButtonArg arg) = {
    PushGoods,
    PushItem,
    PushReturn,
};

/*
######## O[o֐ ##################################################
*/

/*************************************************************************
 *  ֐  : KenkyuuKaihatuMenuWin_CreateWindow
 *  e    : Jj[EBhE̍쐬
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-01 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : Sint32 id EBhEǗ^XN̂hc (enumTASKID)
 *  out: void
 *************************************************************************
 */
void KenkyuuKaihatuMenuWin_CreateWindow(Sint32 id)
{
    extern NJS_TEXLIST winTexList; /* eNX`Xg(wintex.c) */

    /* {^̑̐ݒ */
    SetBtnAttr();

    /* {^ACcɕׂ */
    HTtSetButtonArrayAttribute(HTBUTTONARRAY_ATTR_VERT);

    /* EBhE쐬 */
    kenkyuuKaihatuMenuWin = HTtCreateButtonArrayWindow(WINPOS_LEFT,
        WINPOS_TOP, btnArg, BTNNUM, WINFGCOLOR, WINBGCOLOR);

    /* eNX`Xg̐ݒ */
    HTSetTextureList(kenkyuuKaihatuMenuWin, &winTexList);

    /* EBhER[obN֐ݒ */
    SetBtnCallBack();

    /* ŏɑI{^ */
    HTSetGadgetDefault(kenkyuuKaihatuMenuWin, (LPHTWINGadget)&btnArg[0]);

    /* Ǘ҃^XN̂hc𓾂 */
    taskID = id;

    /* EBhE}bv */
    HTMapWindow(kenkyuuKaihatuMenuWin);
}


/*************************************************************************
 *  ֐  : KenkyuuKaihatuMenuWin_CloseWindow
 *  e    : Jj[EBhE
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-01 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
void KenkyuuKaihatuMenuWin_CloseWindow(void)
{
    HTCloseWindow(kenkyuuKaihatuMenuWin);
}

/*************************************************************************
 *  ֐  : KenkyuuKaihatuMenuWin_MapWindow
 *  e    : Jj[EBhEĕ\
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-01 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
void KenkyuuKaihatuMenuWin_MapWindow(void)
{
    HTMapWindow(kenkyuuKaihatuMenuWin);
}

/*************************************************************************
 *  ֐  : KenkyuuKaihatuMenuWin_UnMapWindow
 *  e    : Jj[EBhEB
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-01 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
void KenkyuuKaihatuMenuWin_UnMapWindow(void)
{
    HTUnMapWindow(kenkyuuKaihatuMenuWin);
}

/*
######## [J֐ ####################################################
*/

/*************************************************************************
 *  ֐  : SetBtnAttr
 *  e    : {^̑̐ݒ
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-01 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
static void SetBtnAttr(void)
{
    Sint8 i;
    HTtButtonArg* pBtnArg = &btnArg[0];
    HTtItem* pItem = &btnItem[0];

    for (i = 0; i < BTNNUM; i++) {
        pBtnArg->item = *pItem;
        pBtnArg++;
        pItem++;
    }
}

/*************************************************************************
 *  ֐  : SetBtnCallBack
 *  e    : {^̃R[obN֐̐ݒ
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-01 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
static void SetBtnCallBack(void)
{
    Sint8 i;
    HTtButtonArg* pBtnArg = &btnArg[0];
    void (**pOnBtnCallBack)(LPHTtButtonArg arg) = &onBtnCallBack[0];
    void (**pPushBtnCallBack)(LPHTtButtonArg arg) = &pushBtnCallBack[0];

    for (i = 0; i < BTNNUM; i++) {
        /* J[\{^ɗƂ̃R[obN */
        HTtSetOnButtonCallBack(pBtnArg, *pOnBtnCallBack);
        /* {^IꂽƂ̃R[obN */
        HTtSetPushButtonCallBack(pBtnArg, *pPushBtnCallBack);
        pBtnArg++;
        pOnBtnCallBack++;
        pPushBtnCallBack++;
    }
}

/*************************************************************************
 *  ֐  : PushGoods
 *  e    : ObY{^ꂽ̃R[obN
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-01 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : LPHTtButtonArg arg
 *  out: void
 *************************************************************************
 */
static void PushGoods(LPHTtButtonArg arg)
{
    /* ocj[^XÑtO𗧂Ă */
    KeieiMenuTask_ChangeFlag(KEIEIMENUTASK_FLAG_GOODS);
    HTtDrawButton(arg);
}

/*************************************************************************
 *  ֐  : PushItem
 *  e    : ACe{^ꂽ̃R[obN
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-01 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : LPHTtButtonArg arg
 *  out: void
 *************************************************************************
 */
static void PushItem(LPHTtButtonArg arg)
{
    /* ocj[^XÑtO𗧂Ă */
    KeieiMenuTask_ChangeFlag(KEIEIMENUTASK_FLAG_ITEM);
    HTtDrawButton(arg);
}

/*************************************************************************
 *  ֐  : PushReturn
 *  e    : Ƃɖ߂{^ꂽ̃R[obN
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-07-01 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : LPHTtButtonArg arg
 *  out: void
 *************************************************************************
 */
static void PushReturn(LPHTtButtonArg arg)
{
    /* ocj[^XÑtO𗧂Ă */
    KeieiMenuTask_ChangeFlag(KEIEIMENUTASK_FLAG_RETURN);
    HTtDrawButton(arg);
}

