
/*************************************************************************
 *  t@C     : toptask.c
 *  e           : gbv^XN쐬Ǘ
 *  vtBbNX : TopTask
 *  쐬         :  j (Yoshio Hashiguchi)
 *  쐬         : 98-06-29 쐬Jn
 *  Rg       :
 *  o[W     : 0.01
 ************************************************************************/

#define __TOPTASK_C

/*
######## CN[ht@C ########
*/

#include <ninja.h>
#include <ninjawin.h>
#include <njdef.h>

#include <httask_mgr.h>

#include "jinjimenutask.h"
#include "keieimenutask.h"
#include "jouhoumenutask.h"
#include "ikuseimenutask.h"

#include "taskid.h"
#include "topwin.h"

#include "toptask.h"

/*
######## 萔錾 ########
*/
enum{ /* ^XN̏ */
    TASK_STABLE,     /* ωiV */
    TASK_SHIAI,      /* W[ */
    TASK_SHINBUN,    /* VW[ */
    TASK_YOUGOJITEN, /* pꎫTW[ */
    TASK_RENSHUU,    /* KW[ */
    TASK_KIOKU,      /* LW[ */
    TASK_JINJI,      /* l^XN */
    TASK_KEIEI,      /* oc^XN */
    TASK_JOUHOU,     /* ^XN */
    TASK_IKUSEI,     /* 琬^XN */

    TASK_END
};

/*
######## }N ########
*/

/*
######## \̐錾 ########
*/

typedef struct { /* gbv^XN\ */
    void* child;      /* q^XN*/
    Sint32 taskState; /* ^XN(enumTASK) */
} TopTask;

/*
######## Ŏg֐̃vg^Cv錾 ########
*/

static void InitTopTask(TopTask* this);
static void ControlTopTask(TopTask* this);

/*
######## ÓIϐ ########
*/

/* ^XN */
static TopTask* topTask;

/* ^XN֐̒` */
static HTTaskFunc taskFunc = {
    InitTopTask,    /*  */
    ControlTopTask, /* Rg[ */
    NULL,           /* ` */
    NULL,           /* I */
};

/*
######## O[o֐ ##################################################
*/

/*************************************************************************
 *  ֐    : TopTask_CreateTask
 *  e    : gbv^XN̍쐬
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-06-29 쐬Jn
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void* parent e^XNւ̃|C^
 *  out: void* topTask ꂽ^XNւ̃|C^
 *************************************************************************
 */
void* TopTask_CreateTask(void* parent)
{
    topTask = HTTask_CreateChild(parent, sizeof(TopTask), &taskFunc);
    return topTask;
}

/*************************************************************************
 *  ֐    : TopTask_ChangeFlag
 *  e    : W[ړorCj[ύXtO𗧂Ă
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-06-29 쐬Jn
 *  Rg:
 *------------------------------------------------------------------------
 *  in : Sint32 flag tO(enumTOPTASK_FLAG)
 *  out: void
 *************************************************************************
 */
void TopTask_ChangeFlag(Sint32 flag)
{
    if (flag == TOPTASK_FLAG_SHIAI) { /* W[ */
        topTask->taskState = TASK_SHIAI;
    }
    else if (flag == TOPTASK_FLAG_SHINBUN) { /* VW[ */
        topTask->taskState = TASK_SHINBUN;
    }
    else if (flag == TOPTASK_FLAG_YOUGOJITEN) { /* pꎫTW[ */
        topTask->taskState = TASK_YOUGOJITEN;
    }
    else if (flag == TOPTASK_FLAG_RENSHUU) { /* KW[ */
        topTask->taskState = TASK_RENSHUU;
    }
    else if (flag == TOPTASK_FLAG_KIOKU) { /* LW[ */
        topTask->taskState = TASK_KIOKU;
    }
    else if (flag == TOPTASK_FLAG_JINJI) { /* l^XN */
        topTask->taskState = TASK_JINJI;
    }
    else if (flag == TOPTASK_FLAG_KEIEI) { /* oc^XN */
        topTask->taskState = TASK_KEIEI;
    }
    else if (flag == TOPTASK_FLAG_JOUHOU) { /* ^XN */
        topTask->taskState = TASK_JOUHOU;
    }
    else if (flag == TOPTASK_FLAG_IKUSEI) { /* 琬^XN */
        topTask->taskState = TASK_IKUSEI;
    }
}

/*
######## [J֐ ####################################################
*/

/*************************************************************************
 *  ֐  : InitTopTask
 *  e    : gbv^XN̏
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-06-29 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : TopTask* this ^XNւ̃|C^
 *  out: void
 *************************************************************************
 */
static void InitTopTask(TopTask* this)
{
    /* ϐ */
    this->child = NULL;

    /* ŏɕ\郁j[^XN߂ */
    this->taskState = TASK_JINJI;

    /* gbvEBhE쐬 */
    TopWin_CreateWindow(TASKID_TOP);
}

/*************************************************************************
 *  ֐  : ControlTopTask
 *  e    : EBhE
 *            ^XÑRg[֐
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-06-29 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : TopTask* this ^XNւ̃|C^
 *  out: void
 *************************************************************************
 */
static void ControlTopTask(TopTask* this)
{
    /* ^XNԃ`FbN */
    if (this->taskState == TASK_STABLE) { /* ωiVȂ牽Ȃ */
    }
    else if (this->child != NULL && HTTask_isActive(this->child) == TRUE) {
        /* q^XNANeBuȂ牽Ȃ */
    }
    else if (this->taskState == TASK_SHIAI) { /* W[ */
        this->taskState = TASK_STABLE; /* ̂ƂiV */
    }
    else if (this->taskState == TASK_SHINBUN) { /* VW[ */
        this->taskState = TASK_STABLE; /* ̂ƂiV */
    }
    else if (this->taskState == TASK_YOUGOJITEN) { /* pꎫTW[ */
        this->taskState = TASK_STABLE; /* ̂ƂiV */
    }
    else if (this->taskState == TASK_RENSHUU) { /* KW[ */
        this->taskState = TASK_STABLE; /* ̂ƂiV */
    }
    else if (this->taskState == TASK_KIOKU) { /* LW[ */
        this->taskState = TASK_STABLE; /* ̂ƂiV */
    }
    else if (this->taskState == TASK_JINJI) { /* lj[쐬 */
        /* afύX */
        TopWin_ChangeBGMode(TOPWIN_BGMODE_JINJI);
        /* lj[^XN쐬 */
        this->child = JinjiMenuTask_CreateTask(this);
        /* ^XNԂɖ߂ */
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_KEIEI) { /* ocj[쐬 */
        TopWin_ChangeBGMode(TOPWIN_BGMODE_KEIEI);
        this->child = KeieiMenuTask_CreateTask(this);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_JOUHOU) { /* 񃁃j[쐬 */
        TopWin_ChangeBGMode(TOPWIN_BGMODE_JOUHOU);
        this->child = JouhouMenuTask_CreateTask(this);
        this->taskState = TASK_STABLE;
    }
    else if (this->taskState == TASK_IKUSEI) { /* 琬j[쐬 */
        TopWin_ChangeBGMode(TOPWIN_BGMODE_IKUSEI);
        this->child = IkuseiMenuTask_CreateTask(this);
        this->taskState = TASK_STABLE;
    }
}

/*
######## ܂ ########################################################
*/
