
/*************************************************************************
 *  t@C     : topwin.c
 *  e           : gbvEBhE쐬Ǘ
 *                   ɕ\Ԍ̃EBhE
 *  vtBbNX : TopWin
 *  쐬         :  j (Yoshio Hashiguchi)
 *  쐬         : 98-06-29 쐬Jn
 *  Rg       :
 *  o[W     : 0.01
 ************************************************************************/

#define __TOPWIN_C

/*
######## CN[ht@C ########
*/

#include <ninja.h>
#include <ninjawin.h>
#include <njdef.h>

#include <htwindow.h>
#include <htwinitem.h>
#include <htwinitembox.h>

#include "windef.h"
#include "wintex.h"

#include "toptask.h"
#include "taskid.h"

#include "topwin.h"

/*
######## 萔錾 ########
*/

/* EBhEW */
#define WINPOS_LEFT (20)
#define WINPOS_TOP (20)
#define WINPOS_RIGHT (620)
#define WINPOS_BOTTOM (460)

/* EBhE̔zF */
#define WINFGCOLOR ARGB(0, 0, 0, 0) /* OʐF(iKł͕sgp) */
#define WINBGCOLOR ARGB(0, 0, 0, 0) /* ʐF */
#define WINBGCOLOR_JINJI ARGB(64, 0, 255, 0)    /* ʐF(l[h) */
#define WINBGCOLOR_KEIEI ARGB(64, 0, 255, 255)  /* ʐF(oc[h) */
#define WINBGCOLOR_JOUHOU ARGB(64, 0, 0, 255)   /* ʐF(񃂁[h) */
#define WINBGCOLOR_IKUSEI ARGB(64, 255, 255, 0) /* ʐF(琬[h) */


enum { /* ACehc(EBhE̕) */
    ITEMID_JINJI = 0,
    ITEMID_KEIEI,
    ITEMID_JOUHOU,
    ITEMID_IKUSEI,

    ITEMID_END
};

enum { /* ACe{bNXhc(EBhE̕) */
    ITEMBOXID_TITLE = 0,

    ITEMBOXID_END
};

/*
######## }N ########
*/

/*
######## \̐錾 ########
*/

/*
######## Ŏg֐̃vg^Cv錾 ########
*/

static Sint32 BGCallBack(Float left, Float top, Float right, Float bottom);

/*
######## ÓIϐ ########
*/

/* EBhEnh */
HTWINHANDLE topWin;

/* Ǘ^XN̂hc */
Sint32 taskID;

/* wiF[h */
Sint32 bgMode;

/* ACẽAgr[g */
static HTtItemAttr itemAttr[] = {
  /* Polygon/Texture      TextureID               COLOR         UV */
    /* ^CgpbZ[W(ItemBox) */
    ITEM_ATTR_TEXTURE, WINTEXID_TITLE_0,     COL4_WHITE_GRAY, UV4_88,
    ITEM_ATTR_TEXTURE, WINTEXID_TITLE_1,     COL4_WHITE_GRAY, UV4_48,
    /* ݂̃j[\(Item) */
    ITEM_ATTR_TEXTURE, WINTEXID_MENU_JINJI,  COL4_GREEN_WHITE, UV4_88,
    ITEM_ATTR_TEXTURE, WINTEXID_MENU_KEIEI,  COL4_GREEN_WHITE, UV4_88,
    ITEM_ATTR_TEXTURE, WINTEXID_MENU_JOUJOU, COL4_GREEN_WHITE, UV4_88,
    ITEM_ATTR_TEXTURE, WINTEXID_MENU_IKUSEI, COL4_GREEN_WHITE, UV4_88,
};

/* ACe{bNXpACe̍쐬 */
static HTtItem itemTitle[] = { /* ^Cg */
  /*  ItemPtr                 TCY                    */
    1,  &itemAttr[0], STRTEXSIZE_X(8), STRTEXSIZE_Y(1),   0, 0,
    1,  &itemAttr[1], STRTEXSIZE_X(4), STRTEXSIZE_Y(1), STRTEXSIZE_X(8), 0,
};

/* ACe{bNX̍쐬 */
static HTtItemBox itemBox[] = {
  /* Itm ItmAryPtr      R[obN */
    2,     itemTitle,   0,  0,   NULL,
};

/* ACe̍쐬 */
static HTtItem itemMenu[] = {
  /*  ItemPtr                 TCY                    */
    /* ݂̃j[\ */
    1,  &itemAttr[2], STRTEXSIZE_X(8), STRTEXSIZE_Y(1), 20, 20,
    1,  &itemAttr[3], STRTEXSIZE_X(8), STRTEXSIZE_Y(1), 20, 20,
    1,  &itemAttr[4], STRTEXSIZE_X(8), STRTEXSIZE_Y(1), 20, 20,
    1,  &itemAttr[5], STRTEXSIZE_X(8), STRTEXSIZE_Y(1), 20, 20,
};

/*
######## O[o֐ ##################################################
*/

/*************************************************************************
 *  ֐    : TopWin_CreateWindow
 *  e    : gbvEBhE̍쐬
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-06-29 쐬Jn
 *  Rg:
 *------------------------------------------------------------------------
 *  in : Sint32 id EBhEǗ^XN̂hc (enumTASKID)
 *  out: void
 *************************************************************************
 */
void TopWin_CreateWindow(Sint32 id)
{
    extern NJS_TEXLIST winTexList; /* eNX`Xg(wintex.c) */

    /* gbvEBhE쐬 */
    topWin = HTCreateSimpleWindow(WINPOS_LEFT, WINPOS_TOP,
        WINPOS_RIGHT, WINPOS_BOTTOM, WINFGCOLOR, WINBGCOLOR);

    /* eNX`Xg̐ݒ */
    HTSetTextureList(topWin, &winTexList);

    /* gbvEChÊafR[obN֐o^ */
    HTSetBGCallBack(topWin, BGCallBack);

    /* Ǘ҃^XN̂hc𓾂 */
    taskID = id;

    /* EBhE}bv */
    HTMapWindow(topWin);
}

/*************************************************************************
 *  ֐    : TopWin_CloseWindow
 *  e    : gbvEBhE
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-06-29 쐬Jn
 *  Rg:
 *------------------------------------------------------------------------
 *  in : void
 *  out: void
 *************************************************************************
 */
void TopWin_CloseWindow(void)
{
    HTCloseWindow(topWin);
}

/*************************************************************************
 *  ֐    : TopWin_ChangeBGMode
 *  e    : gbvEBhE̔wiύX
 *      : O[o֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-06-29 쐬Jn
 *  Rg:
 *------------------------------------------------------------------------
 *  in : Sint32 mode [h (enumTOPWIN_BGMODE)
 *  out: void
 *************************************************************************
 */
void TopWin_ChangeBGMode(Sint32 mode)
{
    bgMode = mode;
}

/*
######## [J֐ ####################################################
*/

/*************************************************************************
 *  ֐  : BGCallBack
 *  e    : gbvEBhÊaf`悷Ƃ̃R[obN֐
 *      : [J֐
 *  쐬  :  j (Yoshio Hashiguchi)
 *  쐬  : 98-06-29 (ŏIXV)
 *  Rg:
 *------------------------------------------------------------------------
 *  in : Float left   EBhEwW
 *       Float top    EBhExW
 *       Float right  EBhEEwW
 *       Float bottom EBhEExW
 *  out: TRUE
 *************************************************************************
 */
static Sint32 BGCallBack(Float left, Float top, Float right, Float bottom)
{
    static NJS_POINT2 p[4];  /* S_̍W */
    static NJS_COLOR col[4]; /* S_̐F */
    static NJS_POINT2COL p2c = { p, col, NULL, 4 };

    /* WZbg */
    p[0].x = left;  p[0].y = top;
    p[1].x = right; p[1].y = top;
    p[2].x = right; p[2].y = bottom;
    p[3].x = left;  p[3].y = bottom;

    /* ݂̔wi[hĐFς */
    if (bgMode == TOPWIN_BGMODE_JINJI) {
        col[0].color = WINBGCOLOR_JINJI;
        col[1].color = WINBGCOLOR_JINJI;
        col[2].color = WINBGCOLOR_JINJI;
        col[3].color = WINBGCOLOR_JINJI;
        HTtDrawItem(&itemMenu[ITEMID_JINJI]);
    }
    else if (bgMode == TOPWIN_BGMODE_KEIEI) {
        col[0].color = WINBGCOLOR_KEIEI;
        col[1].color = WINBGCOLOR_KEIEI;
        col[2].color = WINBGCOLOR_KEIEI;
        col[3].color = WINBGCOLOR_KEIEI;
        HTtDrawItem(&itemMenu[ITEMID_KEIEI]);
    }
    else if (bgMode == TOPWIN_BGMODE_JOUHOU) {
        col[0].color = WINBGCOLOR_JOUHOU;
        col[1].color = WINBGCOLOR_JOUHOU;
        col[2].color = WINBGCOLOR_JOUHOU;
        col[3].color = WINBGCOLOR_JOUHOU;
        HTtDrawItem(&itemMenu[ITEMID_JOUHOU]);
    }
    else if (bgMode == TOPWIN_BGMODE_IKUSEI) {
        col[0].color = WINBGCOLOR_IKUSEI;
        col[1].color = WINBGCOLOR_IKUSEI;
        col[2].color = WINBGCOLOR_IKUSEI;
        col[3].color = WINBGCOLOR_IKUSEI;
        HTtDrawItem(&itemMenu[ITEMID_IKUSEI]);
    }

    HTtDrawItemBox(&itemBox[ITEMBOXID_TITLE]);
    njDrawPolygon2D(&p2c, 4, -65535.0F, NJD_FILL | NJD_TRANSPARENT);

    return TRUE;
}

/*
######## ܂ ########################################################
*/
