/*
 * Zp֘Ã}N
 *
 * $Id: hmath.h,v 1.1 1998/02/23 07:46:51 horita Exp horita $
 *
 * $Log: hmath.h,v $
 * Revision 1.1  1998/02/23 07:46:51  horita
 * Initial revision
 *
 */

#ifndef __MATH_H__
#define __MATH_H__

#include "system.h"

#ifdef __cplusplus
extern "C" {
#endif

// CC֐Q
	// }gNXZ
 	static __inline void push_matrix(void) {	
		njPushMatrix(NULL);
	}
	
	static __inline void pop_matrix(void) { 
		njPopMatrix(1); 
	}

	static __inline void scale(Float x, Float y, Float z) {
		njScale(NULL, x, y, z);
	}
	
	static __inline void rotate_x(Angle x) {
		njRotateX(NULL, x);
	}

	static __inline void rotate_y(Angle x) {
		njRotateY(NULL, x);
	}

	static __inline void rotate_z(Angle x) {
		njRotateZ(NULL, x);
	}

	static __inline void translate(Float x, Float y, Float z) {
		njTranslate(NULL, x, y, z);
	}

	static __inline void translate_v(NJS_POINT3* x) {
		njTranslateV(NULL, x);
	}

	static __inline void get_matrix(NJS_MATRIX* x) {
		njGetMatrix(x);
	}

	static __inline void multi_matrix(NJS_MATRIX* x)	{
		njMultiMatrix(NULL, x);
	}
	
	static __inline void unit_matrix(void) {
		njUnitMatrix(NULL);
	}

	static __inline void load_matrix(NJS_MATRIX* x)	{
		njSetMatrix(NULL, x);
	}

	// view
	static __inline void rotate_view_x(Angle ang) {
		njRotateX(&view.m, ang);
	}
	static __inline void rotate_view_y(Angle ang) {
		njRotateY(&view.m, ang);
	}
	static __inline void rotate_view_z(Angle ang) {
		njRotateZ(&view.m, ang);
	}
	static __inline void translate_view_v(NJS_POINT3* pos) {
		njTranslateV(&view.m, pos);
	}
	static __inline void translate_view(Float x, Float y, Float z) {
		njTranslate(&view.m, x, y, z);
	}
	static __inline void unit_view(void) {
		njUnitMatrix(&view.m);
	}
	
enum {
    X, Y, Z,
};

#define XYZ	3

#define FRAME	20.0				    // Default Frame
#define SPD_FRM(x)	((x) / 60.0 / 60.0 / FRAME) // m/h -> m/frame
#define ACC_FRM(x)	((x) / FRAME / FRAME)	    // m/s^2 -> m/(frame^2)

#ifdef __cplusplus
}
#endif

#endif // __MATH_H__
