/*============================================================
 * Name  : htanime.h
 *
 * Desc  : Aj[VNX̒`
 *
 * prefix: HTAnim_
 *
 * $Id: htanime.h,v 1.1 1998/04/24 12:34:44 horita Exp horita $
 *
 * $Log: htanime.h,v $
 * Revision 1.1  1998/04/24 12:34:44  horita
 * Initial revision
 *
 *============================================================*/
#ifndef __HTANIME_H__
#define __HTANIME_H__

#if DOCUMENT
#endif

/*============================================================
  Include
  ============================================================*/
#include <stdio.h>
#include <ninja.h>
#include "mytype.h"

/*============================================================
  Define
  ============================================================*/
enum {
      OIDX_C_HARA = 1,
      OIDX_A_KAO,
      OIDX_A_MUNE,
      OIDX_AL_KOBU,
      OIDX_AR_KOBU,
      OIDX_AR_ASHI1,
      OIDX_AR_ASHI2,
      OIDX_AL_ASHI1,
      OIDX_AL_ASHI2,
	  OIDX_MAX
};

typedef enum {
	HTANIM_KIND_FILEDER, 
	HTANIM_KIND_PITCHER,
	HTANIM_KIND_BATTER,
	HTANIM_KIND_RUNNER
} HTAnim_Kind;

/*============================================================
  Macro
  ============================================================*/

/*============================================================
  Structure
  ============================================================*/

typedef struct tagHTAnim HTAnim, *LPHTAnim;
struct tagHTAnim {
	/* VXegpf[^ */
	Int iStatus;									/* ݂̏ԃtO */
	NJS_MATRIX mat_list[OIDX_MAX];					/* }gNXobt@ */
	Float curFrame;									/* ݃Ñt[ItZbg */
	Float facFrame;									/* Nt[ɂW */
	NJS_MOTION_LINK mot_link;						/* [VNf[^(Link\bh) */

	/* [U[ݒ肵VXeŎQƂf[^ */
	HTAnim_Kind kind;								/* I̎ */
	Float frame;									/* t[ʒu */
	Float speed;									/* Đx */
	int mot_num;									/* [Vԍ */
	int next_num;									/* Ɏs郂[Vԍ */
	NJS_POINT3 pos;									/* ʒu */
	Angle ang[3];									/*  */

	/* [U[QƂf[^ */
	NJS_POINT3 hara_pos;							/*  */
	NJS_POINT3 lkob_pos;							/*  */
	NJS_POINT3 rkob_pos;							/* E */
	NJS_POINT3 kao_pos;								/*  */
	NJS_POINT3 lleg_pos;							/*  */
	NJS_POINT3 rleg_pos;							/* E */
};
typedef void (*LPHTAnim_LinkCallBack)(LPHTanim);

/*============================================================
  Inline Function
  ============================================================*/
/*============================================================
 Name: HTAnim_ChangeKind
 Desc: ނ̕ύX
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/27 (Monday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
static void __inline HTAnim_ChangeKind (LPHTAnim this, HTAnim_Kind kind) {
	this->kind = kind;
}

/*============================================================
  API
  ============================================================*/
void HTAnim_Init(LPHTAnim this);					/* Init */
void HTAnim_Change(LPHTAnim this, Int nMotion);	/* Change */
void HTAnim_Calc(LPHTAnim this);					/* Calc */
void HTAnim_Next(LPHTAnim this);					/* next */
void HTAnim_Draw(LPHTAnim this);					/* Draw */
void HTAnim_Link(LPHTAnim this, Int nMotion, Float fStartFrame, Int nFrame);	/* Link */
void HTAnim_SetLinkCallBack(LPHTAnim_LinkCallBack);	/* R[obN̓o^ */

#endif /* __HTANIME_H__ */
/*============================================================*
 * End of File                                                *
 *============================================================*/
