/*============================================================
 * Name  : httask_mgr.h
 *
 * Desc  : ^XN}l[WC^[tFCX
 *
 * prefix: HTTask_
 *
 * $Id: httask_mgr.h,v 1.1 1998/04/27 07:07:45 horita Exp $
 *
 * $Log: httask_mgr.h,v $
 * Revision 1.1  1998/04/27 07:07:45  horita
 * Initial revision
 *
 *============================================================*/
#ifndef __HTTASK_MGR_H__
#define __HTTASK_MGR_H__

#if DOCUMENT
#endif

/*============================================================
  Include
  ============================================================*/
#include <stdio.h>

/*============================================================
  Macro
  ============================================================*/
#define ASG_BIT(NAME, NUM) NAME = (1 << NUM)

/*============================================================
  Define
  ============================================================*/
enum {
	ASG_BIT(M_ACTIVE, 0),							/* ^XNANeBu */
	ASG_BIT(M_SLEEP, 1),							/* ^XN͊ */
};
#define TASK_MAGIC	0x15012345						/*  */
#define TASK_HEADER	(sizeof(struct taskheader))		/* ^XNwb_̑傫 */

enum {
	HTTASK_SIG_KILL,
	HTTASK_SIG_DELETE,
	HTTASK_SIG_FAIL,
	HTTASK_SIG_USR
};
	
/*============================================================
  Structure
  ============================================================*/
/*  ^XNRg[ */
struct taskheader {
    long magic;										// }WbNԍ
    struct taskheader* child;						/* Ẽ^XNւ̃|C^ */
    struct taskheader* sibling;						/* ̃^XNւ̃|C^ */
	struct taskheader* leader;						// e^XNւ̃|C^
    void *execute;									/* s֐ */
    void *display;									/* `֐ */
    void *signal;									/* VOinh[ */
    int flag;										/* tO */
    char body[0];									/*  */
};

extern struct taskheader *Curtask;					/* ݎs̃^XN */

typedef void (*FuncP)(const void *);				// [U[֐Ă΂֐̃^Cv
typedef void (*FuncS)(const void *, int);

typedef struct tagHTTaskFunc {
    void* init;										// 
    void* execute;									// s
    void* display;									// `
    void* signal;									// VOinh
} HTTaskFunc;

/*============================================================
  Inline Function
  ============================================================*/
/*============================================================
 Name: HTTask_ChangeExe
 Desc: s֐̕ύX
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/27 (Monday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void __inline HTTask_ChangeExe(const void *task, const void *execute)
{
    register struct taskheader *p = (struct taskheader *) ((char *) task - TASK_HEADER);
    p->execute = (void *)execute;
}


/*============================================================
 Name: HTTask_ChangeDsp
 Desc: `֐̕ύX
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/27 (Monday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void __inline HTTask_ChangeDsp(const void *task, const void *display)
{
    register struct taskheader *p = (struct taskheader *) ((char *) task - TASK_HEADER);
    p->display = (void *)display;
}


/*============================================================
 Name: HTTask_ChangeDie
 Desc: I֐̕ύX
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/27 (Monday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void __inline HTTask_ChangeDie(const void *task, const void *fin)
{
    register struct taskheader *p = (struct taskheader *) ((char *) task - TASK_HEADER);
    p->signal = (void *)fin;
}


/*============================================================
 Name: HTTask_Sleep
 Desc: ^XN̋x~
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/27 (Monday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void __inline HTTask_Sleep(const void* task)
{
    register struct taskheader *p = (struct taskheader *) ((char *) task - TASK_HEADER);
    p->flag &= ~M_ACTIVE;
}


/*============================================================
 Name: HTTask_Active
 Desc: ^XN̍ĊJ
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/27 (Monday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void __inline HTTask_Active(const void* task)
{
    register struct taskheader *p = (struct taskheader *) ((char *) task - TASK_HEADER);
    p->flag |= M_ACTIVE;
}



/*============================================================
 Name: HTTask_Toggel
 Desc: ^XN̏Ԃ̕ύX(gO)
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/27 (Monday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void __inline HTTask_Toggel(const void* task)
{
    register struct taskheader *p = (struct taskheader *) ((char *) task - TASK_HEADER);
    p->flag ^= M_ACTIVE;
}

//
// ݂̃^XNւ̏
//
/*============================================================
 Name: HTTask_Exe
 Desc: s֐̕ύX
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/27 (Monday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void __inline HTTask_Exe(const void *execute)
{
    Curtask->execute = (void *)execute;
}


/*============================================================
 Name: HTTask_Dsp
 Desc: `֐̕ύX
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/27 (Monday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void __inline HTTask_Dsp(const void *display)
{
    Curtask->display = (void *)display;
}


/*============================================================
 Name: HTTask_Die
 Desc: I֐̕ύX
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/27 (Monday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void __inline HTTask_Die(const void *fin)
{
    Curtask->signal = (void *)fin;
}

/*============================================================
  API
  ============================================================*/
void *HTTask_CreateChild(const void *leader, int size, const HTTaskFunc * FuncTbl);
void *HTTask_CreateChildP(const void* leader, int size, const HTTaskFunc *FuncTbl, void *param);
void *HTTask_CreateRoot(int size, const HTTaskFunc * FuncTbl);
void HTTask_Sigal(const void* task, int signal);
void HTTask_CtrlLoop(void);
void HTTask_DrawLoop(void);
void HTTask_Delete(void);
void HTTask_DeleteOther(void* BasePtr);
int HTTask_isActive(void* task);

#endif /* __HTTASK_MGR_H__ */
/*============================================================*
 * End of File                                                *
 *============================================================*/
