/*============================================================
 * Name  : anime.c
 *
 * Desc  : Aj[VTv
 *
 * prefix:
 *
 * $Id: htanime.c,v 1.1 1998/04/24 12:34:38 horita Exp horita $
 *
 * $Log: htanime.c,v $
 * Revision 1.1  1998/04/24 12:34:38  horita
 * Initial revision
 *
 *============================================================*/

#if DOCUMENT
#endif

/*============================================================
  Include
  ============================================================*/
#include <stdio.h>
#include <ninja.h>
#include <NjDef.h>
#include "mytype.h"
#include "motion.h"
#include "htanime.h"
#include "hmath.h"
#include "fbtouch1_null.nja"						/* Tvf(fielder/pitcher) */
#include "bkam2_null.nja"							/* Tvf(batter) */
#include "rbase_null.nja"							/* Tvf(runner) */

/*============================================================
  Define
  ============================================================*/
	
/*============================================================
  Macro
  ============================================================*/

/*============================================================
  Structure
  ============================================================*/

/*============================================================
  Globals
  ============================================================*/

/*============================================================
  Static
  ============================================================*/
static LPNJS_OBJECT lppobj_list[] = {
	object_fbtouch1_null_null,
	object_fbtouch1_null_null,
	object_bkam2_null_null,
	object_rbase_null_null,
};

static LPNJS_OBJECT lpobj_list[OIDX_MAX];
static LPNJS_MODEL model_list[OIDX_MAX];
static LPNJS_MATRIX cur_mat;
static int cur_index = 0;
static LPHTAnim lp_anim = NULL;
static LPHTAnim_LinkCallBack link_func = NULL;

/*============================================================
  Local Prototypes
  ============================================================*/
static void MotionCallBack(LPNJS_OBJECT lp_object);

/*************************************************************
 *-----------------------------------------------------------*
 * Local Functions                                           *
 *-----------------------------------------------------------*
 *************************************************************/
/*============================================================
 Name: MotionCallBack
 Desc: }gNX̋zグ
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/24 (Friday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
static void MotionCallBack(LPNJS_OBJECT lp_object)
{
	LPFloat lp_pos = (LPFloat)(*cur_mat);

	/* f̕ۑ */
	model_list[cur_index] = lp_object->model;		
	lpobj_list[cur_index] = lp_object;

	/* Ninjaɕ`悳Ȃ */
	lp_object->model = NULL;

	/* }gNX̕ۑ */
	get_matrix(cur_mat);

	/* gX̒o */
	if (lp_anim->kind == HTANIM_KIND_BATTER) {
		switch (cur_index) {
		case OIDX_C_HARA:
			lp_anim->hara_pos.x = lp_pos[M30];
			lp_anim->hara_pos.y = lp_pos[M31];
			lp_anim->hara_pos.z = lp_pos[M32];
			break;
		case OIDX_AL_ASHI1:
			lp_anim->lkob_pos.x = lp_pos[M30];
			lp_anim->lkob_pos.y = lp_pos[M31];
			lp_anim->lkob_pos.z = lp_pos[M32];
			break;
		case OIDX_AL_ASHI2:
			lp_anim->rkob_pos.x = lp_pos[M30];
			lp_anim->rkob_pos.y = lp_pos[M31];
			lp_anim->rkob_pos.z = lp_pos[M32];
			break;
		case OIDX_AR_ASHI2:
			lp_anim->lleg_pos.x = lp_pos[M30];
			lp_anim->lleg_pos.y = lp_pos[M31];
			lp_anim->lleg_pos.z = lp_pos[M32];
			break;
		case OIDX_AR_KOBU:
			lp_anim->rleg_pos.x = lp_pos[M30];
			lp_anim->rleg_pos.y = lp_pos[M31];
			lp_anim->rleg_pos.z = lp_pos[M32];
			break;
		case OIDX_A_KAO:
			lp_anim->kao_pos.x = lp_pos[M30];
			lp_anim->kao_pos.y = lp_pos[M31];
			lp_anim->kao_pos.z = lp_pos[M32];
			break;
		}
	} else {
		switch (cur_index) {
		case OIDX_C_HARA:
			lp_anim->hara_pos.x = lp_pos[M30];
			lp_anim->hara_pos.y = lp_pos[M31];
			lp_anim->hara_pos.z = lp_pos[M32];
			break;
		case OIDX_AL_KOBU:
			lp_anim->lkob_pos.x = lp_pos[M30];
			lp_anim->lkob_pos.y = lp_pos[M31];
			lp_anim->lkob_pos.z = lp_pos[M32];
			break;
		case OIDX_AR_KOBU:
			lp_anim->rkob_pos.x = lp_pos[M30];
			lp_anim->rkob_pos.y = lp_pos[M31];
			lp_anim->rkob_pos.z = lp_pos[M32];
			break;
		case OIDX_AL_ASHI2:
			lp_anim->lleg_pos.x = lp_pos[M30];
			lp_anim->lleg_pos.y = lp_pos[M31];
			lp_anim->lleg_pos.z = lp_pos[M32];
			break;
		case OIDX_AR_ASHI2:
			lp_anim->rleg_pos.x = lp_pos[M30];
			lp_anim->rleg_pos.y = lp_pos[M31];
			lp_anim->rleg_pos.z = lp_pos[M32];
			break;
		case OIDX_A_KAO:
			lp_anim->kao_pos.x = lp_pos[M30];
			lp_anim->kao_pos.y = lp_pos[M31];
			lp_anim->kao_pos.z = lp_pos[M32];
			break;
		}
	}
	/* Index/MatrixPointeri߂ */
	cur_mat++;
	cur_index++;
}


/*************************************************************
 *-----------------------------------------------------------*
 * Global Functions                                          *
 *-----------------------------------------------------------*
 *************************************************************/

/*============================================================
 Name: HTAnim_Init
 Desc: [V̏
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/24 (Friday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTAnim_Init(LPHTAnim this)
{
	this->mot_num = 0;
	this->speed = 1.0F;
	this->frame = 0.F;
	this->pos.x = this->pos.y = this->pos.z = 0.F;
	this->ang[0] = this->ang[1] = this->ang[2] = 0;
	this->kind = cmd_tbl[0].type;
}


/*============================================================
 Name: HTAnim_Change
 Desc: [V̐؂ւ
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/24 (Friday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTAnim_Change(LPHTAnim this, Int nMotion)
{
	this->mot_num = nMotion;
	this->frame = 0.F;
}


/*============================================================
 Name: HTAnim_Calc
 Desc: [V̌vZ
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/24 (Friday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTAnim_Calc(LPHTAnim this)
{
	push_matrix();
	unit_matrix();
	rotate_y(this->ang[1]);
	rotate_x(this->ang[0]);
	rotate_z(this->ang[2]);
	lp_anim = this;
	cur_index = 0;
	cur_mat = this->mat_list;
	njSetMotionCallback(MotionCallBack);
	if (this->iStatus & 1) {
		njFastDrawMotionLink(lppobj_list[this->kind], &this->mot_link, this->curFrame);
		this->curFrame += this->facFrame;
		if (this->curFrame > 1.0) {
			this->iStatus &= 0xfffffffe;
			HTAnim_Change(this, this->next_num);
			if (link_func != NULL) {
				link_func(this);
			}
		}
	} else {
		njFastDrawMotion(lppobj_list[this->kind], cmd_tbl[this->mot_num].motion, this->frame);
	}
	pop_matrix();
}


/*============================================================
 Name: HTAnim_Next
 Desc: [Vi߂
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/24 (Friday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTAnim_Next(LPHTAnim this) 
{
	this->frame += this->speed;
	if (this->frame >= cmd_tbl[this->mot_num].motion->nbFrame) {
		this->frame = 0.F;
	}
}

/*============================================================
 Name: HTAnim_Draw
 Desc: f̕`
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/24 (Friday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTAnim_Draw(LPHTAnim this)
{
	int i;
	LPNJS_MATRIX cur_mat;

	push_matrix();
	translate_v(&this->pos);
	cur_mat = this->mat_list;
	for (i = 0 ; i < OIDX_MAX ; i++) {
		push_matrix();
		multi_matrix(cur_mat);
		/* ۑĂf[^ƂɃf̕`model̕ */
		if (model_list[i] != NULL) {
			njDrawModel(model_list[i]);
		}
		lpobj_list[i]->model = model_list[i];
		pop_matrix();
		cur_mat++;
	}
	pop_matrix();
}


/*============================================================
 Name: HTAnim_Link
 Desc: [V̐ڑ
 Kind: Global 
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/25 (Saturday)
 Misc:
 ------------------------------------------------------------
 in  : nMotion.. Ȃ郂[V̔ԍ
 	   nFrame..  Kvȃt[
 out : none
 ============================================================*/
void HTAnim_Link(LPHTAnim this, int nMotion, Float fStartFrame, int nFrame)
{
	this->mot_link.motion[0] = cmd_tbl[this->mot_num].motion;
	this->mot_link.motion[1] = cmd_tbl[nMotion].motion;
	this->mot_link.frame[0] = this->frame;
	this->mot_link.frame[1] = fStartFrame;
	this->next_num = nMotion;
	this->curFrame = 0.F;
	this->facFrame = 1.0F / (float)nFrame;
	this->iStatus |= 1;
}


/*============================================================
 Name: 
 Desc: 
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/28 (Tuesday)
 Misc: 
 ------------------------------------------------------------
 in  : 
 out : 
 ============================================================*/
void HTAnim_SetLinkCallBack(LPHTAnim_LinkCallBack func)
{
	link_func = func;
}


/*============================================================*
 *------------------------------------------------------------*
 * End of File                                                *
 *------------------------------------------------------------*
 *============================================================*/
