/*============================================================
 * Name  : game.c
 *
 * Desc  : game ̐
 *
 * prefix:
 *
 * $Id$
 *
 * $Log$
 *============================================================*/

/*============================================================
  Include
  ============================================================*/
#include <Ninjawin.h>
#include <NjDef.h>
#include "hmath.h"
#include "pad.h"
#include "httask_mgr.h"
#include "game.h"
#include "smoke.h"
#include "motenum.h"
#include "motion.h"

/*============================================================
  Local
  ============================================================*/
/*
 * ^XN֐̒`
 */
static void game_ctrl(game_task*);
static void game_draw(game_task*);


/*============================================================
  Static
  ============================================================*/
/*
 * ^XN֐̒`
 */
static HTTaskFunc game_taskf = {
	NULL,
	game_ctrl,
	game_draw,
	NULL,
};


/*============================================================
 Name: 
 Desc: 
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/28 (Tuesday)
 Misc: 
 ------------------------------------------------------------
 in  : 
 out : 
 ============================================================*/
static void kind_change(LPHTAnim this)
{
	this->kind = cmd_tbl[this->next_num].type;
}
	
/*============================================================
 Name: set_game_task
 Desc: Zbgp֐
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date:   98/04/24 (Fri)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
game_task* set_game_task(void* leader)
{
	game_task* this;

	this = HTTask_CreateChild(leader, sizeof(game_task), &game_taskf);
	HTAnim_Init(&this->anime);
	this->anime.pos.z = -100.F;
/*	this->anime.ang[1] = NJM_DEG_ANG(90.0); */
	HTAnim_Change(&this->anime, MOTIDX_MOTION_POVRWU_NULL);
	HTAnim_SetLinkCallBack(kind_change);
	return this;
}

/*============================================================
 Name: game_ctrl
 Desc: game^XN̐֐
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
 Date:   98/04/24 (Fri)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
static void game_ctrl(game_task* this)
{
	static NJS_POINT3 pos;

	/* [Vԍ̕ύX */
	if (isPush(PORT0, NJD_DGT_KL)) {
		this->anime.next_num++;
		if (this->anime.next_num >= Max_Motnum) {
			this->anime.next_num = Max_Motnum - 1;
		}
	} else if (isPush(PORT0, NJD_DGT_KR)) {
		this->anime.next_num--;
		if (this->anime.next_num < 0) {
			this->anime.next_num = 0;
		}
	}
	njPrintD(NJM_LOCATION(3, 10), this->anime.next_num, 3);

	if (isPush(PORT0, NJD_DGT_TX)) {
		HTAnim_Link(&this->anime, this->anime.next_num, 0, 10);
	}

	if (isPush(PORT0, NJD_DGT_TY)) {
		HTAnim_Change(&this->anime, this->anime.next_num);
		this->anime.kind = cmd_tbl[this->anime.next_num].type;
	}

	/* f̌vZ */
	push_matrix();
	HTAnim_Calc(&this->anime);
	{
		static NJS_POINT3 dst;
		pos.x = 0.0F;
		pos.y = 8.0F;
		pos.z = 0.0F;
		njCalcPoint(&this->anime.mat_list[OIDX_AL_ASHI2], &pos, &dst);
		njAddVector(&dst, &this->anime.pos);
		set_smoke_task(this, &dst);
		pop_matrix();
	}
	HTAnim_Next(&this->anime);
	pop_matrix();
}

/*============================================================
 Name: game_draw
 Desc: game^XN̕`֐
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
 Date:   98/04/24 (Fri)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
static void game_draw(game_task* this)
{
	push_matrix();
	HTAnim_Draw(&this->anime);
	pop_matrix();
}
