/*============================================================
 * Name  : smoke.c
 *
 * Desc  : smoke ̐
 *
 * prefix:
 *
 * $Id$
 *
 * $Log$
 *============================================================*/

/*============================================================
  Include
  ============================================================*/
#include <Ninjawin.h>
#include <NjDef.h>
#include "hmath.h"
#include "pad.h"
#include "httask_mgr.h"
#include "smoke.h"

/*============================================================
  Local
  ============================================================*/
/*
 * ^XN֐̒`
 */
static void smoke_ctrl(smoke_task*);
static void smoke_draw(smoke_task*);


/*============================================================
  Static
  ============================================================*/
/*
 * ^XN֐̒`
 */
static HTTaskFunc smoke_taskf = {
	NULL,
	smoke_ctrl,
	smoke_draw,
	NULL,
};

static NJS_POINT3 vert[4] = {
	-1., 0.,  1.,
	 1., 0.,  1.,
	 1., 0., -1.,
	-1., 0., -1.,
};

static NJS_COLOR color[4] = {
	0x40ffffff,
	0x40ffffff,
	0x40ffffff,
	0x40ffffff,
};

static NJS_POINT3COL p[] = {
	vert,
	color,
	NULL,
	4,
};

/*============================================================
 Name: set_smoke_task
 Desc: Zbgp֐
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date:   98/04/24 (Fri)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
smoke_task* set_smoke_task(void* leader, LPNJS_POINT3 pos)
{
	smoke_task* this;

	this = HTTask_CreateChild(leader, sizeof(smoke_task), &smoke_taskf);
	this->pos = *pos;
	this->timer = 10;
	return this;
}

/*============================================================
 Name: smoke_ctrl
 Desc: smoke^XN̐֐
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
 Date:   98/04/24 (Fri)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
static void smoke_ctrl(smoke_task* this)
{
	this->ang[0] += NJM_DEG_ANG(15.0);
	this->ang[1] += NJM_DEG_ANG(38.0);
	this->ang[2] += NJM_DEG_ANG(43.0);
	if (--this->timer == 0) {
		HTTask_Delete();
	}
}

/*============================================================
 Name: smoke_draw
 Desc: smoke^XN̕`֐
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
 Date:   98/04/24 (Fri)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
static void smoke_draw(smoke_task* this)
{
	push_matrix();
	translate_v(&this->pos);
	rotate_y(this->ang[1]);
	rotate_x(this->ang[0]);
	rotate_z(this->ang[2]);
	njDrawPolygon3D(p, 4, NJD_FILL | NJD_TRANSPARENT);
	pop_matrix();
}
