#!/Perl/bin/perl

#
# Usage
#
sub Usage() {
    printf(STDERR "mot_conv [options] Filename[s]\n");
    printf(STDERR "options: -sa.. Save Action Structure.\n");
    printf(STDERR "         -nh.. don't Add Header Files.\n");
}

#
# Convert
#
sub MotConvert() {
    local($fname) = @_;
    local($status);
    local(@strbuff);
    local($file_name);
    local($tag_name);

    # init status
    $status = 1;

    # open source file
    open(MOT_FILE, $fname) || die "File: $fname not found";

    # Create file_name(only)
    @strbuff = split(/\//, $fname);
    $file_name = $strbuff[$#strbuff];

    # Create basename
    @strbuff = split(/\./, $file_name);
    $tag_name = $strbuff[0];

    $file_name =~ s/\.nam/\.c/;
    # open destination file
    open(DST_FILE, "> $file_name") || die "File: $file_name can't Create.";

    printf(STDERR "%s .. ", $fname);
    if ($act_nh == 0) {
	printf(DST_FILE "#include <ninja.h>\n#include <njdef.h>\n");
    }
    # converter main
    while (<MOT_FILE>) {
	if (/^ACTION/) {
	    if ($act_save == 0) {
		# sACTIONȍ~݂͂Ȃ̂łĂ
		$status = 0;
	    }
	} elsif (/^DEFAULT/) {
	    $status = 0;
	}
	if ($status > 0) {
	    # oKv
	    if (/^\/\*\/\/ MOTION : motion_cs102/) {
		# O̕ϊKvׂ
		$status = 2;
	    }
	    if ($status == 2) {
		# O̕ύXKvȂϊ
		s/cs102/$tag_name/g;
	    }
	    if (/^ROTATION/ || /^POSITION/ || /^MDATA2/) {
		printf(DST_FILE "static ");
	    }
	    print DST_FILE $_;
	}
    }
    printf(STDERR "done.\n");
}


#
# main
#
if ($#ARGV < 0)  {
    # t@C̎w肪Ύg̕\
    &Usage;
} else {
    $i = 0;
    $act_save = 0;
    $act_nh = 0;
    for ( ; $i <= $#ARGV ; $i++) {
	if ($ARGV[$i] =~ /^-sa$/) {
	    $act_save = 1;
	} elsif ($ARGV[$i] =~ /^-nh$/) {
	    $act_nh = 1;
	} else {
	    last;
	}
    }
    if ($i > $#ARGV) {
	&Usage && die "No file specifiled.\n";
    }
    for ( ; $i <= $#ARGV ; $i++) {
	&MotConvert($ARGV[$i]);
    }
}
