/*============================================================
 * Name  : window.h 
 *
 * Desc  : EBhEɊւ`
 *
 * prefix:
 *
 * $Id: htwindow.h,v 1.4 1998/06/11 06:23:24 horita Exp horita $
 *
 * $Log: htwindow.h,v $
 * Revision 1.4  1998/06/11 06:23:24  horita
 * EBhËړATCYA{^̕AKWFbg̕\E\Ɋ
 * ֐Q̒ǉB
 *
 * HTWindowMove, HTWindowMoveRelative, HTWindowResize
 * HTSetWinButtonDir, HTSetGadgetVisible, HTSetGadgetHyde
 *
 * Revision 1.3  1998/04/09 15:02:08  horita
 * KWFbg̃Xe[^XǉB
 * ɔ֐Q̒ǉ
 * void HTSetGadgetDefault(HTWINHANDLE win, LPHTWINGadget arg);
 * void HTSetGadgetSetButton(LPHTWINGadget arg);
 *
 * Revision 1.2  1998/04/02 07:59:54  horita
 * ToolBox̓
 * DrawBox̒ǉ
 * KWFbg̊Ǘ\bh̒ǉ
 *
 * Revision 1.1  1998/04/02 00:31:42  horita
 * Initial revision
 *
 *============================================================*/
#ifndef __WINDOW_H__
#define __WINDOW_H__

#if DOCUMENT
#endif

/*============================================================
  Include
  ============================================================*/
#include <stdio.h>
#include <ninja.h>
#include <njdef.h>
#include "x_rgb.h"									/*  Color Data */

/*============================================================
  Macro
  ============================================================*/
#define BIT_ASG(_name_, _num_) _name_ = 1 << (_num_)

/*============================================================
  Define
  ============================================================*/
/* KWFbg̃J[\ɑ΂ */
enum {
	GADGET_NONE,
	GADGET_ONBUTTON,
	GADGET_PUSH
};

/* GADGET̏ԃtO */
enum {
	BIT_ASG(GADGET_STATE_SELECTABLE, 	0),			/* I */
	BIT_ASG(GADGET_STATE_BUTTON, 		1),			/* {^ */
	BIT_ASG(GADGET_STATE_VISIBLE, 		2),			/*  */
};

/* {^AC̕ */
typedef enum {
	HTBUTTONARRAY_DIRECTION_HORIZ,
	HTBUTTONARRAY_DIRECTION_VERT
} HTtButtonArrayDirection;

/*============================================================
  Structure
  ============================================================*/
typedef Sint32 HTWINHANDLE;							/* nh */
typedef Sint32 (*LPHtWinCallBack) (Float left, Float top, Float right, Float bottom);	/* `R[obN */
typedef void (*LPHtWinGadgetCallBack)(void *);		/* KWFbgpR[obN */

typedef struct tagHTWINGadget {
	void* leader;									/* Link node pointer(for leader) */
	void* child;									/* Link node pointer(for child) */
	void* method;									/* `֐ */
	void* param_tbl;								/* `֐ĂԂƂ̈ */
	Sint16 status;									/* (selected) */
	Sint16 flags;									/* tO(selectable) */
	Sint16 nIndex;									/* Windowł̒ʂԍ */
} HTWINGadget;
typedef HTWINGadget* LPHTWINGadget;

/*============================================================
  Globals
  ============================================================*/

/*============================================================
  API
  ============================================================*/
/*
 * VXe֘A 
 */
void HTWindowInit(void);
HTWINHANDLE HTCreateSimpleWindow(Float left, Float top, Float right, Float bottom, Sint32 foreground, Sint32 background); /* Create */
void HTCloseWindow(HTWINHANDLE win);				/* delete */
void HTMapWindow(HTWINHANDLE);						/* Map */
void HTUnMapWindow(HTWINHANDLE);					/* UnMap */
void HTDrawWindowLoop(void);						/* EBhE̕` */
void HTSetTextureList(HTWINHANDLE cur_win, NJS_TEXLIST *list); /* eNX`[Xg̓o^ */
void HTSetWinProc(HTWINHANDLE cur_win, void* func);	/* WinProc̐ݒ */

/* 1998/05/23 (Saturday) ǉ */
void HTWindowMove(HTWINHANDLE cur, Float left, Float top); /* EBhËړ() */
void HTWindowMoveRelative(HTWINHANDLE cur, Float x, Float y); /* EBhËړ() */
/* 1998/05/23 (Saturday) ǉI */

/* 1998/06/11 (Thursday) ǉ */
void HTSetWinButtonDir(HTWINHANDLE cur_win, HTtButtonArrayDirection dir);/* EBhẼ{^Q̕w */
void HTWindowResize(HTWINHANDLE cur_win, Float x, Float y); /* EBhȆ傫̕ύX */
/* 1998/06/11 (Thursday) ǉI */

/*
 * t[ȂǃrWAɊւ 
 */
Bool HTSetBGCallBack(HTWINHANDLE cur_win, LPHtWinCallBack func);/* wi̕` */
Bool HTSetFrameStartCallBack(LPHtWinCallBack func);	/* t[g`(Global) */
Bool HTSetFrameCallBack(LPHtWinCallBack func);		/* t[gm(Global) */
Bool HTSetWinFrameStartCallBack(HTWINHANDLE cur_win, LPHtWinCallBack func); /* t[g`(Window) */
Bool HTSetWinFrameCallBack(HTWINHANDLE cur_win, LPHtWinCallBack func);	/* t[gm(Window) */

/*
 * KWFbgɊւ
 */
void HTManagedGadget(HTWINHANDLE win, LPHTWINGadget arg);/* KWFbgEBhE(win)̊Ǘɂ */
Bool HTUnManagedGadget(HTWINHANDLE win, LPHTWINGadget arg); /* KWFbgEBhE(win)̊Ǘ͂ */
void HTSetGadgetSelectable(LPHTWINGadget arg);		/* KWFbgI\ɂ */
void HTSetGadgetButton(LPHTWINGadget arg);			/* KWFbg{^ƂĈ */
void HTSetGadgetDefault(HTWINHANDLE win, LPHTWINGadget arg); /* ftHgKWFbg̐ݒ */
/* 1998/05/23 (Saturday) ǉ */
void HTSetGadgetVisible(LPHTWINGadget arg);			/* KWFbg\ */
void HTSetGadgetHyde(LPHTWINGadget arg);			/* KWFbgB */
/* 1998/05/23 (Saturday) ǉI */

/* KWFbg̕`֐̓o^ */
static __inline void HTSetGadgetMethod(LPHTWINGadget arg, LPHtWinGadgetCallBack func) {
	arg->method = func;
}

/*
 * {c[{bNX
 */
void HTtDraw2DObject(NJS_POINT2COL *p, Int n, Float z, Uint32 attr);
void HTtDrawLine(Float left, Float top, Float right, Float bottom, Float z, Sint32 color);	
Sint32 HTtDrawDefaultFrame(Float left, Float top, Float right, Float bottom);
void HTtDrawBox(Float left, Float top, Float right, Float bottom, Float z, Sint32 color);

#endif // __WINDOW_H__
