/*============================================================
 * Name  : main.c 
 *
 * Desc  : Ninja Main
 *
 * prefix:
 *
 * $Id: main.c,v 1.1 1998/04/20 11:49:39 horita Exp horita $
 *
 * $Log: main.c,v $
 * Revision 1.1  1998/04/20 11:49:39  horita
 * Initial revision
 *
 *============================================================*/

#if DOCUMENT
#endif

/*============================================================
  Include
  ============================================================*/
#include <stdio.h>
#include <ninjawin.h>
#include "system.h"
#include "htwindow.h"
#include "htfont.h"

/*============================================================
  Define
  ============================================================*/

/*============================================================
  Macro
  ============================================================*/

/*============================================================
  Structure
  ============================================================*/

/*============================================================
  Globals
  ============================================================*/

/*============================================================
  Static
  ============================================================*/
static int frame;
static int wframe;
static int time;

/*============================================================
  Local Prototypes
  ============================================================*/


/*============================================================
 Name: njUserInit
 Desc: Ninja Init
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/20 (Monday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void njUserInit(void)
{
	extern Sint32 Draw_Active_Frame(Float left, Float top, Float right, Float bottom);
	extern Sint32 Draw_Frame(Float left, Float top, Float right, Float bottom);

	InitSystem(NJD_RESOLUTION_VGA, NJD_FRAMEBUFFER_MODE_ARGB1555, 1);
    njClipZ(10.0, -30000.0);
    njSetBackColor(ROYAL_BLUE_COL, ROYAL_BLUE_COL, BLACK_COL);
	htFontInit();
	htFontLoad("jpnhn16x.fnt", "JPNZN16X.X11");
	htFontLoadAnk("roman1.fnt");
	HTWindowInit();
	HTSetFrameStartCallBack(Draw_Active_Frame);
	HTSetFrameCallBack(Draw_Frame);

	Create_Sample_Window();

	/* counter */
	wframe = 0;
	time = GetCurrentTime();

	njPrintSize(16);
}


/*============================================================
 Name: njUserMain
 Desc: Ninja Main
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/20 (Monday)
 Misc:
 ------------------------------------------------------------
 in  : none
 out : current status
 ============================================================*/
Sint32 njUserMain(void)
{
//    njTextureFilterMode(NJD_TEXTUREFILTER_BILINEAR); 

	njSetView(&view);

	njPushMatrix(NULL);
	HTDrawWindowLoop();
	njPopMatrix(1);

	/* Frame rate */
	wframe++;
	if (GetCurrentTime() > (time + (5 * 1000))) {
		frame = wframe / 5;
		wframe = 0;
		time = GetCurrentTime();
	}
	njPrintD(NJM_LOCATION(2, 3), frame, 3);
	njPrintC(NJM_LOCATION(6, 3), "frame/s");

	return NJD_USER_CONTINUE;
}


/*============================================================
 Name: njUserExit
 Desc: Ninja Exit
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/20 (Monday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void njUserExit(void)
{
	njExitSystem();
}

