 /*************************************************************************
 *	t@C	:	file.c
 *
 *	e		:	t@C֌W
 *
 *	vtBbNX:	File
 *
 *	쐬		:	s.kuwata
 *
 *	쐬		:	1998.7.3 6
 *
 *	Rg	:Xe[^Xe[ũhLgAŊmFKv
 *				 gdFsStopRdGD-DRIVÊݗLAGD-Mirageł͌ł͎gȂ
 *				274,333s̐ݒł͑Ȃࡂep[^ݒ͗pӂĂȂ
 *				
 *				
 *
 ************************************************************************/
#define __FILE_C

#define KU_DEBUG YES

/*
######## CN[ht@C ########
*/
#include <string.h>
#include "File.h"


/*
######## 萔錾 ########
*/


enum FILE_REQUESTMODE{ /* t@Cǂݍ݃V[PX */
	FILE_REQUESTMODE_OPEN,			/* t@CJ */
	FILE_REQUESTMODE_GETFILESIZE,	/* t@CTCY擾	*/
	FILE_REQUESTMODE_REQUEST,		/* ǂ݃NGXg	*/
	FILE_REQUESTMODE_COMPLETECHECK,	/* t@Cǂݍ݊`FbN */
	FILE_REQUESTMODE_CLOSE,			/* t@CN[Y */ 
	FILE_REQUESTMODE_STOP,			/* t@CNGXg~ */
	FILE_REQUESTMODE_ALLSTOP,		/* ׂĂ̓o^NA */
	FILE_REQUESTMODE_FALSE,			/* t@Cǂݍݎs */
	FILE_REQUESTMODE_ELSE,			/* ftHg */

	FILE_REQUESTMODE_END
};


/*
######## }N ########
*/
/* o[WǗp */
#define FILE_VER1   NO			/* [JŒ胁obt@ */
#define FILE_VER2	YES			/* Imۃobt@ */
#define FILE_VER3   YES			/* AhX */
#define FILE_VER4   YES			/* A */
#define FILE_VER5   YES			/* t@Cbv֐ */

/* t@CTCYmۂ邽߂̎ʗp */
#define FILE_WHOLELOAD			-99	/* t@CTCYہXobt@mۗp */
/*
######## \̐錾 ########
*/

typedef struct REQUEST_BUFFER{ /* t@CNGXgobt@ */
	FILE_NAME	 		 	*readFileName;		/*  t@C */
	FILE_NAME	 		 	*readDirectoryName;	/* fBNg */
	struct REQUEST_BUFFER 	*prev;				/* O̗vfւ̃|C^ */
	struct REQUEST_BUFFER 	*next;				/* ̗vfւ̃|C^ */
	Sint32				 	status;				/* t@Cobt@̗p */
	Uint32				 	*readAddress;		/* t@C[hAhX */
} RequestBuffer;


/*
######## ÓIϐ ########
*/
static FILE_HANDLE		hFileForCompletion;
static FILE_HANDLE		hFileReturnAtOnce;
static FILE_NAME 		*readFileName;
static FILE_NAME 		*readDirectoryName;
static RequestBuffer 	requestBuffer[FILE_RING_BUFFER_MAX];
static RequestBuffer    *requestBufferOpenPtr;/* t@CI[vp|C^ */
static RequestBuffer	*requestBufferAddPtr;/* t@CNGXgobt@̒ǉ */
static Sint32			atOnceMode = FILE_REQUESTMODE_ELSE;
static Uint32			*readBufferForCompletion;

static Sint32			bufferIndex 		= 0; /* Oobt@̒T */
static Sint32			fileOpenCounter		= 0; /* foOp */

/*
######## Ŏg֐̃vg^Cv錾 ########
*/
static Sint32 OpenFileForCompletion(FILE_NAME *readFileName, FILE_NAME *readDirectoryName);
static Sint32 CloseFileForCompletion(void);
static Sint32 LoadWaitForCompletion(Uint32 *readAddress);
static Uint32* NewBufferForCompletion(Sint32 size);
static Sint32 DeleteBufferForCompletion(void);
static Sint32 SetDirectory(FILE_NAME *readDirectoryName, GDFS_DIRREC *hdirrec);
static void ErrorMessage(void);
static Sint32 ExistFileHandle(FILE_HANDLE hFile);
static Sint32 CloseFileForCompletion(void);
static Sint32 GetFileSectorSize(FILE_HANDLE hfile,Sint32 *sectorSize);
static void OpenTest(FILE_NAME *fileName, GDFS_DIRREC hdirrec, Sint32 *result);
static void CloseTest(void);
static Sint32 SearchFileOpenIndex(void);
static Sint32 StartLoadReturnAtOnce(void);
static Sint32 LoadReturnAtOnce(void);


/*
######## Oϐ ##################################################
*/
Uint32 		dirBuf[GDFS_DIRREC_SIZE(FILE_DIRSIZE)/4]; 	/* fBNgobt@ */
#if FILE_VER1==YES
Uint32 		readBuffer[FILE_BUFFER_SIZE]; 			/* ǂݍݗpCDobt@ */
#endif


/*********************** O[o֐  *********************************/
/*********************** A֐  *********************************/
/*************************************************************************
 *	֐	:	File_AutoLoadToRealAddressForCompletion(void)
 *	e	:	AhXɃt@C[h
 *		:	O[o֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.9
 *	Rg:  
 * 
 *------------------------------------------------------------------------
 *	in : 	FILE_NAME 	*readFileName, 		t@C
 *			FILE_NAME 	*readDirectoryName,	fBNg
 *			Uint32 		*readAddress		[hAhX
 *
 *	out:	Sint32:	G[R[h
 *************************************************************************/
Sint32 File_AutoLoadToRealAddressForCompletion(FILE_NAME *readFileName, 
											   FILE_NAME *readDirectoryName,
											   Uint32 *readAddress)
{
	Sint32 errorCode;

	/* t@CJ */
	if((errorCode=OpenFileForCompletion(readFileName, readDirectoryName))!=FILE_OK){
		return errorCode;
	}
	/* t@CǂŏI */
	if((errorCode=LoadWaitForCompletion(readAddress))!=FILE_OK){
		return errorCode;
	}
	return errorCode;
}


/*************************************************************************
 *	֐	:	File_AutoLoadToHeapMemoryForCompletion(void)
 *	e	:	q[v̈̃obt@Ƀt@C[h
 *		:	O[o֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.9
 *	Rg:  
 * 
 *------------------------------------------------------------------------
 *	in : 	FILE_NAME 	*readFileName, 		t@C
 *			FILE_NAME 	*readDirectoryName,	fBNg
 *			Uint32 		**readAddress		[hobt@ւ̃|C^
 *	out:	Sint32:	G[R[h
 *************************************************************************/
Sint32 File_AutoLoadToHeapMemoryForCompletion(FILE_NAME *readFileName, 
											   FILE_NAME *readDirectoryName,
											   Uint32 **readAddress)
{
	Sint32	errorCode;

	if((errorCode=OpenFileForCompletion(readFileName,readDirectoryName))!=FILE_OK){
		return errorCode;
	}
	if((*readAddress = NewBufferForCompletion(FILE_WHOLELOAD))==NULL){
		return FILE_FATAL;
	}
	if((errorCode=LoadWaitForCompletion(*readAddress))!=FILE_OK){
		return errorCode;
	}
	return errorCode;
}


/**************************   A֐Q   *************************/
/*------------------------ NGXgobt@ ------------------------*/
/*************************************************************************
 *	֐	:	File_InitEntryFileRequest
 *	e	:	t@CNGXg̏
 *		:	O[o֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.18
 *	Rg:   Oobt@Ƃč\z
 *------------------------------------------------------------------------
 *	in:		void
 *	out:	G[R[h
 *************************************************************************/
Sint32 File_InitEntryFileRequest(void)
{
	Sint32 i;
	RequestBuffer *rbPtr;

	rbPtr = &requestBuffer[0];

	/* obt@ׂ͂Ėgpɐݒ */
	for( i=0 ; i<FILE_RING_BUFFER_MAX ; i++ ){
		if(	i==0 ){/* wb_ƂĂ̏ */
			rbPtr->status = FILE_STATUS_DUMMYHEADER;
			/* wb_̃|C^̏iwb_͐΂ɏ邱Ƃ͂Ȃ) */
			rbPtr->prev  	= rbPtr->next = rbPtr;
			/* SQƃ|C^̃ftHg̓wb_ɐݒ */
			requestBufferOpenPtr = rbPtr;
			requestBufferAddPtr  = rbPtr->prev;
		}else{
			rbPtr->status 			= FILE_STATUS_NOUSE;
			rbPtr->prev 			= NULL;
			rbPtr->next 			= NULL;
		}
		rbPtr->readAddress		= NULL;
		rbPtr->readFileName 	= NULL;
		rbPtr->readDirectoryName= NULL;
		rbPtr++;

	}
	/* SNGXgobt@t@C[h̏(A) */
	StartLoadReturnAtOnce();
	bufferIndex = 0;

	return(FILE_MEMORY_OK);
}


/*************************************************************************
 *	֐	:	File_SetEntryFileRequest
 *	e	:	t@CNGXg̓o^
 *		:	O[o֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.18
 *	Rg:   Oobt@Ƃč\z
 *------------------------------------------------------------------------
 *	in:		FILE_NAME *readFileName 		t@C
 *			FILE_NAME *readDirectoryName	fBNg
			Uint32	 *readAddress		AhX[hԒn
 *	out:	쐬obt@̃CfbNX(FILE_MEMORY_ERROR)
 *************************************************************************/
Sint32 File_SetEntryFileRequest(FILE_NAME *readFileName, 
								FILE_NAME *readDirectoryName,
								Uint32	 *readAddress)
{
	RequestBuffer 	*rbPtr;			/* gpłobt@T[`p */
	Sint32			searchIndex;

	rbPtr = &requestBuffer[0];
	for( searchIndex=0 ; searchIndex<FILE_RING_BUFFER_MAX ; searchIndex++ ){ /* Oobt@ */
		if(rbPtr->status==FILE_STATUS_NOUSE){ /* gobt@T */
			break;
		}
		rbPtr++;
	}
	/* łȂƂ̃G[Kv */
	if(searchIndex==FILE_RING_BUFFER_MAX){
		return(FILE_BUFFER_OVERFLOW);
	}
	/* Xgւ̒ǉ */
	rbPtr->prev = requestBufferAddPtr;
	rbPtr->next = requestBufferAddPtr->next;
	requestBufferAddPtr->next->prev = rbPtr;
	requestBufferAddPtr->next = rbPtr;

	/* Xgvf̏ */
	rbPtr->readFileName			=	readFileName;
	rbPtr->readDirectoryName	=	readDirectoryName;
	rbPtr->status 				= 	FILE_STATUS_REQUEST; /* 炩̔ԍׂ */
	rbPtr->readAddress			=   readAddress;

	/* Xgǉʒũ|C^͏Ƀwb_prev */
	requestBufferAddPtr = requestBuffer[0].prev;

	return (searchIndex);

}


/*************************************************************************
 *	֐	:	File_DeleteEntryFileRequestAll
 *	e	:	t@CNGXg̑S폜
 *		:	O[o֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.18
 *	Rg:   Oobt@Ƃč\z
 *------------------------------------------------------------------------
 *	in:		void
 *	out:	G[R[h(FILE_MEMORY_ERROR)
 *************************************************************************/
Sint32 File_DeleteEntryFileRequestAll(void)
{
	Sint32 i;
	RequestBuffer *rbPtr;

	for( i=1 ; i<FILE_RING_BUFFER_MAX ; i++ ){
		File_DeleteEntryFileRequest(i);
	}
	/* T[`|Cg擪 */
	requestBufferOpenPtr = &requestBuffer[0];
	requestBufferAddPtr  = requestBuffer[0].prev;

	return(FILE_MEMORY_OK);
}


/*************************************************************************
 *	֐	:	File_DeleteEntryFileRequest
 *	e	:	w肵t@CNGXg̍폜
 *		:	O[o֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.18
 *	Rg:   Oobt@Ƃč\z
 *------------------------------------------------------------------------
 *	in:		Sint32	requestNumber 폜ÕNGXgobt@vf
 *									
 *	out:	NANGXgԍG[R[h(FILE_MEMORY_ERROR)
 *			폜ɐȂ-1Ԃ
 *************************************************************************/
Sint32 File_DeleteEntryFileRequest(Sint32 requestNumber)
{	
	RequestBuffer *rbPtr;

	if(requestNumber<1){/* z`FbN */
		return(FILE_INDEX_APPOINT_MISS);
	}

	/* |C^ǂ̂ł͂Ȃ_CNgɎw */
	rbPtr=&requestBuffer[requestNumber];

	/* vf2x폜悤Ƃꍇ */
	if(rbPtr->status == FILE_STATUS_NOUSE){
		return(FILE_DUPLICATE_DELETE);
	}

	/* 폜vfʂȃ|C^ɂčĂ */
	if(rbPtr==requestBufferOpenPtr){ 		/* t@CI[v */
		requestBufferOpenPtr = rbPtr->next;	/* ̃NGXgɂ邽ߤ̗vfɐ؂ւ */
		if(requestBufferOpenPtr==&requestBuffer[0]){
			requestBufferOpenPtr=requestBufferOpenPtr->next;
		}
	} 
	else if( rbPtr==requestBufferAddPtr){ 	/* } */
		requestBufferAddPtr = rbPtr->prev; 	/* }ʒuςȂ߂ɈOɐ؂ւ */
	}

	/* 폜镪߂ */
	rbPtr->prev->next = rbPtr->next;
	rbPtr->next->prev = rbPtr->prev;

	/* vȂȂvf폜 */
	rbPtr->status 			= FILE_STATUS_NOUSE;
	rbPtr->readAddress		= NULL;
	rbPtr->readFileName 	= NULL;
	rbPtr->readDirectoryName= NULL;
	rbPtr->prev 			= NULL;
	rbPtr->next 			= NULL;
	return(FILE_MEMORY_OK);
}


/*************************************************************************
 *	֐	:	File_GetEntryNumber
 *	e	:	SGg[𓾂 
 *		:	O[o֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.18
 *	Rg:   Oobt@Ƃč\z
 *------------------------------------------------------------------------
 *	in:		void
 *									
 *	out:	o^ĂGg[
 *************************************************************************/
Sint32 File_GetEntryNumber(void)
{
	RequestBuffer *rbPtr;
	Sint32	counter;
	
	counter = 0;
	rbPtr=requestBuffer[0].next;
	if(rbPtr==&requestBuffer[0]){ /* wb_Ȃ */
		return(counter); /* 0Ԃ */
	}
	/* Oobt@ׂ̂Ă̗vf */
	for( ; rbPtr!=&requestBuffer[0] ; rbPtr=rbPtr->next ){
		counter++;
	}
	return(counter);
}


/*  ------------------------- t@C암 ---------------------------*/
/*************************************************************************
 *	֐	:	File_StopLoadReturnAtOnce
 *	e	:	t@C[h~(A)
 *		:	O[o֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.9
 *	Rg:  ݌Ăłt@C̃[ĥ݂𒆎~
 * *
 *------------------------------------------------------------------------
 *	in : 	void
 *	out:	Sint32:		G[R[h
 *************************************************************************/
Sint32 File_StopLoadReturnAtOnce(void)
{
	bufferIndex--;	/* Oobt@TfNg */
	atOnceMode = FILE_REQUESTMODE_STOP;
	return(FILE_OK);
}


/*************************************************************************
 *	֐	:	File_AllStopLoadReturnAtOnce
 *	e	:	t@C[hS~(A)
 *		:	O[o֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.9
 *	Rg:  SOobt@̃[hv폜A
 * *
 *------------------------------------------------------------------------
 *	in : 	void
 *	out:	Sint32:		G[R[h
 *************************************************************************/
Sint32 File_AllStopLoadReturnAtOnce(void)
{
	bufferIndex = 0;		/* Oobt@TNA */
	atOnceMode = FILE_REQUESTMODE_ALLSTOP;
	return(FILE_OK);
}


/*************************************************************************
 *	֐	:	File_AllLoadReturnAtOnce
 *	e	:	SNGXgobt@t@C[h(A)
 *		:	O[o֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.9
 *	Rg:  ̊֐͎s̐擪ŌĂł
 * *
 *------------------------------------------------------------------------
 *	in : 	void
 *	out:	Sint32:		G[R[h 
 *************************************************************************/
Sint32 File_AllLoadReturnAtOnce(void)
{
	Sint32 endCheck;

	if(bufferIndex<FILE_RING_BUFFER_MAX){
		if((endCheck=LoadReturnAtOnce())==FILE_OK){/* t@C[h */
			bufferIndex++;
			StartLoadReturnAtOnce();	/* ̃t@Cǂޏ */
		}
	}
	return(endCheck);
}


/*************************************************************************
 *	֐	:	File_GetFileStatusReturnAtOnce
 *	e	:	w肵t@Cobt@݂̌̏Ԃo(A)
 *		:	O[o֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.9
 *	Rg:  foOp
 * 
 *------------------------------------------------------------------------
 *	in : 	Sint32		requestNumber	t@Cobt@̔ԍ
 *	out:	Sint32		t@C̏	gp	FILE_STATUS_NOUSE
 *										gp	FILE_STATUS_REQUSET
 *************************************************************************/
Sint32 File_GetFileStatusReturnAtOnce(Sint32 requestNumber)
{
	RequestBuffer *rbPtr;

	rbPtr=&requestBuffer[requestNumber];
	return(rbPtr->status);
}


/*************************************************************************
 *	֐	:	File_GetAllFileStatusReturnAtOnce(void)
 *	e	:	St@CǂݏIǂԂ
 *		:	O[o֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.9
 *	Rg:  foOp
 * 
 *------------------------------------------------------------------------
 *	in : 	void
 *	out:	Sint32:		St@C̓ǂݍݏ
 *						TRUEȂǂݍݏIAFALSEȂǂݍݒ
 *************************************************************************/
Sint32 File_GetAllFileStatusReturnAtOnce(void)
{
	RequestBuffer *rbPtr;

	rbPtr = &requestBuffer[0];
	if( rbPtr->next == rbPtr ){ /* wb_̗̎vfwb_Ȃ */
		return(TRUE);			/* Xg->ǂݍݏI */
	}else{
		return(FALSE);
	}
}



/*************************************************************************
 *	֐	:	File_PrintInformationAtOnce
 *	e	:	t@Cǂݍݏo(A)
 *		:	O[o֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.9
 *	Rg:  foOp
 * 
 *------------------------------------------------------------------------
 *	in : 	void
 *	out:	Sint32:		G[R[h
 *************************************************************************/
Sint32 File_PrintInformationAtOnce(void)
{
	Sint32 i;

	njPrintColor(0xff00ff00);
	njPrintSize(16);

	/* Oobt@̒go */
	for( i=1 ; i<FILE_RING_BUFFER_MAX ; i++ ){
		if(requestBuffer[i].readFileName!=NULL){
			njPrintD(NJM_LOCATION(10,10+i),i,2);
			njPrintC(NJM_LOCATION(15,10+i),requestBuffer[i].readFileName);
		}
	}
	/* Oobt@ŁAI[vׂt@Co */
	njPrintColor(0xff00ffFF);
	if(requestBufferOpenPtr->readFileName!=NULL){
		njPrintC(NJM_LOCATION(10,10+FILE_RING_BUFFER_MAX+1),requestBufferOpenPtr->readFileName);
	}
	/* Oobt@̒ŁAvfǉɒǉ閖vf */
	if(requestBufferOpenPtr->readFileName!=NULL){
		njPrintC(NJM_LOCATION(10,10+FILE_RING_BUFFER_MAX+2),requestBufferAddPtr->readFileName);
	}
	/* p */
	njPrintD(NJM_LOCATION(10,10+FILE_RING_BUFFER_MAX+3),requestBufferOpenPtr->status,4);
	njPrintD(NJM_LOCATION(10,10+FILE_RING_BUFFER_MAX+4),requestBufferAddPtr->status,4);
	/* t@Cǂݍݗv */
	njPrintD(NJM_LOCATION(10,10+FILE_RING_BUFFER_MAX+5),File_GetEntryNumber(),4);
	/* t@Cnh */
	njPrintH(NJM_LOCATION(10,10+FILE_RING_BUFFER_MAX+6),(Uint32 )hFileReturnAtOnce,8);
	/* t@C̃I[vAN[Ỹ`FbNp */
	njPrintD(NJM_LOCATION(10,10+FILE_RING_BUFFER_MAX+7),fileOpenCounter,4);

	njPrintColor(0xffffffFF);
	for(i=1 ; i<FILE_RING_BUFFER_MAX ; i++ ){
		njPrintD(NJM_LOCATION(2,10+i),File_GetFileStatusReturnAtOnce(i),4);
	}
	njPrintD(NJM_LOCATION(10,10+FILE_RING_BUFFER_MAX+8),File_GetAllFileStatusReturnAtOnce(),4);
	njPrintD(NJM_LOCATION(20,10+FILE_RING_BUFFER_MAX+8),bufferIndex,4);

	return(FILE_OK);
}




/*********************** VXebv֐  ****************************/
/*************************************************************************
 *	Function	: FILE_gdFsInit
 *	Contents	:
 *	Kind		: Global Function
 *	Producer	: S.Kuwata
 *	ProduceDate	: 98/6/22
 *	Comment		:
 *------------------------------------------------------------------------
 *ḿnmax_open     ... ɃI[vłt@C
 *       gdfs_work    ... [NGÃ|C^ ([U[̈悩)
 *       max_dirent   ... JgfBNg̃Gg
 *       gdfs_dirrec  ... JgfBNg̃obt@ ([U[̈悩)
 *mónȂ
 *m߂lnGDFS_ERR_OK ... I
 *          ̑      ... G[
 *m@\nCȕB
 *
 *************************************************************************
*/
Sint32 FILE_gdFsInit(Sint32 max_open, void *gdfs_work, Sint32 max_dirent, void *gdfs_dirrec)
{
	return(gdFsInit(max_open, gdfs_work, max_dirent, gdfs_dirrec));
}


/*************************************************************************
 *	Function	: FILE_gdFsCreateDirhn
 *	Contents	:
 *	Kind		: Global Function
 *	Producer	: S.Kuwata
 *	ProduceDate	: 98/6/22
 *	Comment		:
 *------------------------------------------------------------------------
 *ḿngdfs_dirrec  ...  fBNg̃obt@
 * 		  max_dirent   ...  fBNg̃Gg
 *mónȂ
 *m߂lnfBNgR[hnh
 *************************************************************************
*/
GDFS_DIRREC FILE_gdFsCreateDirhn(void *gdfs_dirrec, Sint32 max_dirent)
{
	return(gdFsCreateDirhn(gdfs_dirrec, max_dirent));
}


/*************************************************************************
 *	Function	: FILE_gdFsLoadDir
 *	Contents	:
 *	Kind		: Global Function
 *	Producer	: S.Kuwata
 *	ProduceDate	: 98/6/22
 *	Comment		:
 *------------------------------------------------------------------------
 *ḿndirname      ...  fBNg
 *móngdfs_dirrec  ...  fBNgR[hnh
 *                       (NULL ̏ꍇ̓JgfBNg)
 *m߂lnGDFS_ERR_OK ... I
 *          ̑      ... G[
 *************************************************************************
*/
Sint32 FILE_gdFsLoadDir(Sint8 *dirname, GDFS_DIRREC gdfs_dirrec)
{
	return(gdFsLoadDir(dirname, gdfs_dirrec));
}


/*************************************************************************
 *	Function	: FILE_gdFsChangeDir
 *	Contents	:
 *	Kind		: Global Function
 *	Producer	: S.Kuwata
 *	ProduceDate	: 98/6/22
 *	Comment		:
 *------------------------------------------------------------------------
 *ḿndirname  ...  fBNg
 *mónȂ
 *m߂lnGDFS_ERR_OK ... I
 *          ̑      ... G[
 *************************************************************************
*/
Sint32 FILE_gdFsChangeDir(Sint8 *dirname)
{
	return(gdFsChangeDir(dirname));
}


/*************************************************************************
 *	Function	: FILE_gdFsOpen
 *	Contents	:
 *	Kind		: Global Function
 *	Producer	: S.Kuwata
 *	ProduceDate	: 98/6/22
 *	Comment		:
 *------------------------------------------------------------------------
 *ḿnfname        ...  t@C
 *        gdfs_dirrec  ...  t@CfBNgR[hnh
 *                          (NULL ̏ꍇ̓Jg猟)
 *mónȂ
 *m߂lnNULL      ...  s
 *          ȊO  ...  t@Cnh
 *************************************************************************
*/
GDFS FILE_gdFsOpen(Sint8 *fname, GDFS_DIRREC gdfs_dirrec)
{
	return(gdFsOpen(fname, gdfs_dirrec));
}


/*************************************************************************
 *	Function	: FILE_gdFsGetFileSize
 *	Contents	:
 *	Kind		: Global Function
 *	Producer	: S.Kuwata
 *	ProduceDate	: 98/6/22
 *	Comment		:
 *------------------------------------------------------------------------
 *ḿngdfs     ...  t@Cnh
 *món*fsize   ...  t@CTCY (oCg)
 *m߂lnTRUE / FALSE
 *************************************************************************
*/
Bool FILE_gdFsGetFileSize(GDFS gdfs, Sint32 *fsize)
{
	return(gdFsGetFileSize(gdfs, fsize));
}


/*************************************************************************
 *	Function	: FILE_gdFsRead
 *	Contents	:
 *	Kind		: Global Function
 *	Producer	: S.Kuwata
 *	ProduceDate	: 98/6/22
 *	Comment		:
 *------------------------------------------------------------------------
 *ḿngdfs     ...  t@Cnh
 *       nsct     ...  ǂݍރZN^
 *       buf      ...  i[obt@
 *mónȂ
 *m߂l] GDFS_ERR_OK ... I
 *          ̑      ... G[
 *************************************************************************
*/
Sint32 FILE_gdFsRead(GDFS gdfs, Sint32 nsct, void *buf)
{
	return(gdFsRead(gdfs, nsct, buf));
}


/*************************************************************************
 *	Function	: FILE_gdFsClose
 *	Contents	:
 *	Kind		: Global Function
 *	Producer	: S.Kuwata
 *	ProduceDate	: 98/6/22
 *	Comment		:
 *------------------------------------------------------------------------
 *ḿngdfs   ...  t@Cnh
 *mónȂ
 *
 *************************************************************************
*/
void FILE_gdFsClose(GDFS gdfs)
{
	gdFsClose(gdfs);
}


/*************************************************************************
 *	Function	: FILE_gdFsReqRd32
 *	Contents	:
 *	Kind		: Global Function
 *	Producer	: S.Kuwata
 *	ProduceDate	: 98/6/22
 *	Comment		:
 *------------------------------------------------------------------------
 *ḿngdfs     ...  t@Cnh
 *       nsct     ...  ǂݍރZN^
 *mónbuf      ...  i[obt@
 *m߂lnۂɃNGXgꂽZN^ (> 0)B̂Ƃ̓G[R[hB
 *************************************************************************
*/
Sint32 FILE_gdFsReqRd32(GDFS gdfs, Sint32 nsct, void *buf)
{
	return(gdFsReqRd32(gdfs, nsct, buf));
}


/*************************************************************************
 *	Function	: FILE_gdFsGetStat
 *	Contents	:
 *	Kind		: Global Function
 *	Producer	: S.Kuwata
 *	ProduceDate	: 98/6/22
 *	Comment		:
 *------------------------------------------------------------------------
 *ḿngdfs   ...  t@Cnh
 *mónȂ
 *m߂lnt@CXe[^X
 *************************************************************************
*/
Sint32 FILE_gdFsGetStat(GDFS gdfs)
{
	return(gdFsGetStat(gdfs));
}


/*************************************************************************
 *	Function	: FILE_gdFsGetNumRd
 *	Contents	:
 *	Kind		: Global Function
 *	Producer	: S.Kuwata
 *	ProduceDate	: 98/6/22
 *	Comment		:
 *------------------------------------------------------------------------
 *ḿngdfs  ...  t@Cnh
 *mónȂ
 *m߂ln0 ȏ  ...  ǂݍ񂾃oCg
 *************************************************************************
*/
Sint32 FILE_gdFsGetNumRd(GDFS gdfs)
{
	return(gdFsGetNumRd(gdfs));
}


/************* [J֐ *********************************************/
/*************************************************************************
 *	֐	:	OpenFileForCompletion
 *	e	:	t@CI[v
 *		:	[J֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.3
 *	Rg:
 *------------------------------------------------------------------------
 *	in :	FILE_NAME 		*fileName		   t@C
 * 			FILE_NAME		*readDirectoryName ǂݍރfBNg
 *											(JĝƂNULLɐݒ肷邱)
 *	out:	Sint32:		G[R[h
 *************************************************************************/
static Sint32 OpenFileForCompletion(FILE_NAME *readFileName, FILE_NAME *readDirectoryName)
{
	GDFS_DIRREC hdirrec; /* fBNgR[hnh */

	Sint32 ret;

	hdirrec = NULL;
	if(readDirectoryName!=NULL){
		if((ret=SetDirectory(readDirectoryName, &hdirrec))!=FILE_OK){	/* fBNgR[hǂݍ߂ȂƂ */
			return(ret);
		}
	}
	/* fBNgAt@CɊÂt@CJ */
	if((hFileForCompletion = gdFsOpen(readFileName, hdirrec))==NULL){ 
		return (FILE_CANTOPEN); /* t@CI[vs */
	}
	return(FILE_OK);

}


/*************************************************************************
 *	֐	:	CloseFileForCompletion
 *	e	:	t@CN[Y
 *		:	[J֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.3
 *	Rg:
 *------------------------------------------------------------------------
 *	in :	
 *	out:	Sint32:		G[R[h
 *************************************************************************/
static Sint32 CloseFileForCompletion(void)
{
	gdFsClose(hFileForCompletion);
	return(FILE_OK);
}


/*************************************************************************
 *	֐	:	LoadWaitForCompletion
 *	e	:	t@C[h(Aj
 *		:	[J֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.3
 *	Rg:
 *------------------------------------------------------------------------
 *			Uint32 		*readAddress
 *	out:	Sint32:		G[R[h
 *************************************************************************/
static Sint32 LoadWaitForCompletion(Uint32 *readAddress)
{
	Sint32 ret;
	Sint32 sectorSize;
	Sint32 errorCode;

	/* get file size */
	if((errorCode=GetFileSectorSize(hFileForCompletion, &sectorSize))!=FILE_OK){
		return errorCode;	/* t@CnhȂ΃G[ */
	}
	/* read file */
	ret = gdFsRead(						/* Aɂǂݍ */
				hFileForCompletion, 	/* t@Cnh */
				sectorSize, 			/* ǂݍރZN^ */
				(Uint32 *)readAddress); /* i[ꏊ */
	/* close file */
	CloseFileForCompletion();
	
	if (ret == FILE_OK){
		return (ret); 			  /* t@Cǂݍݐ */
	}
	return (FILE_FATAL);		  /* t@Cǂݍݎs */
}


/*************************************************************************
 *	֐	:   NewBufferForCompletion
 *	e	:	ǂݍ݃obt@̐
 *		:	[J֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.9
 *	Rg:	ZN^TCYPʂŃm
 *------------------------------------------------------------------------
 *	in : 	Sint32		 size		mۂobt@TCY
 *									ǂݍރt@CTCYۂ
 *									mۂƂFILE_WHOLELOADw
 *	out:	Uint32 *:	蓖Ăobt@ւ̃|C^
 *						G[NULLԂ
 *************************************************************************/
static Uint32* NewBufferForCompletion(Sint32 size)
{
	Sint32 openSize;
	Sint32 sectorSize;
	Sint32 errorCode;

	if(size==FILE_WHOLELOAD || size<0){ /* obt@̃TCYwȂA͕sȂ */
		/* IɊmۂt@CTCYvZ */
		/* ݃I[vĂt@C̑傫𓾂 */
		if((errorCode=GetFileSectorSize(hFileForCompletion, &sectorSize))!=FILE_OK){
			return NULL;	/* t@CnhȂ΃G[ */
		}
		openSize = sectorSize*GDD_FS_SCTSIZE; 	/* KvȍőZN^TCY */
	}else{ /* w肳ꂽobt@TCYGDD_FS_SCTSIZEoE_ɕϊ */
		sectorSize=size/GDD_FS_SCTSIZE;
		openSize=GDD_FS_SCTSIZE*sectorSize;
		if((size-openSize)>0){
			openSize += GDD_FS_SCTSIZE; /* oE_␳ */
		}
	}
	/* oE_␳ꂽt@C̑傫m */
	readBufferForCompletion=syMalloc(openSize);
	return(readBufferForCompletion);
}


/*************************************************************************
 *	֐	:   DeleteBufferForCompletion
 *	e	:	obt@̊J
 *		:	[J֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.9
 *	Rg:	
 *------------------------------------------------------------------------
 *	in : 	void
 *	out:	Sint32:		G[R[h(FILE_OK𔭍s)
 *************************************************************************/
static Sint32 DeleteBufferForCompletion(void)
{
	syFree(readBufferForCompletion);	/* ǂݍ݃obt@J */
	return(FILE_OK);
}


/*************************************************************************
 *	֐	:	GetFileSectorSize
 *	e	:	t@C傫ZN^TCYŎ擾
 *		:	[J֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.3
 *	Rg:
 *------------------------------------------------------------------------
 *	in :	void
 *	out:	Sint32:		G[R[h
 *************************************************************************/
static Sint32 GetFileSectorSize(FILE_HANDLE hFile, Sint32 *sectorSize)
{
	Sint32 openSize;
	Sint32 errorCode;

	if((errorCode=ExistFileHandle(hFile))==FILE_OK){ 
		gdFsGetFileSize(hFile, &openSize);		/* ǂݍރt@C̑傫𓾂ioCg) */
		*sectorSize=gdFsCalcSctSize(openSize);	/* mۂɕKvȑ傫ZN^PʂŎ擾 */
	}
	return(errorCode);
}


/*************************************************************************
 *	֐	:	ExistFileHandle
 *	e	:	t@Cnh݂̑`FbN
 *		:	[J֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.9
 *	Rg:
 *------------------------------------------------------------------------
 *	in : 	void
 *	out:	Sint32	G[R[h
 *************************************************************************/
static Sint32 ExistFileHandle(FILE_HANDLE hFile)
{
	if(hFile==NULL){ /* nhȂ */
		return FILE_NOHNDL; /* G[bZ[WԂ */
	}else{
		return FILE_OK;
	}
}

/*************************************************************************
 *	֐	:	SetDirectory
 *	e	:	ǂݍރfBNg̐ݒ
 *		:	[J֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.9
 *	Rg:
 *------------------------------------------------------------------------
 *	in : 	FILE_NAME		*readDirectoryName ǂݍރfBNg
 *			GDFS_DIRREC *hdirrec			   fBNgR[hnh
 *	out:	Sint32:		G[R[h
 *************************************************************************/
static Sint32 SetDirectory(FILE_NAME *readDirectoryName, GDFS_DIRREC *hdirrec)
{
	Sint32 ret;

	*hdirrec = gdFsCreateDirhn(						/* fBNgnh̐ */
					(void *) dirBuf,				/* fBNgobt@ */
 					FILE_DIRSIZE); 						/* fBNg̃Gg */
	ret = gdFsLoadDir(readDirectoryName, *hdirrec); /* fBNgR[h̓ǂݍ */
	return(ret);
}


/*************************************************************************
 *	֐	:	OpenTest
 *	e	:	eXgJE^tt@CI[v
 *		:	[J֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.3
 *	Rg:   t@CI[vAN[Y`FbNp
 *------------------------------------------------------------------------
 *	in:		FILE_NAME fileName, t@C
 *			GDFS_DIRREC hdirrec, fBNg
 *			Sint32 *result		 G[
 *
 *	out:	void
 *************************************************************************/
static void OpenTest(FILE_NAME *fileName, GDFS_DIRREC hdirrec, Sint32 *result)
{
	hFileReturnAtOnce = gdFsOpen(fileName, hdirrec);
	if (hFileReturnAtOnce == NULL) { /* t@CJ̎s */
		*result = FILE_CANTOPEN;
		atOnceMode = FILE_REQUESTMODE_FALSE;
	}else{
		fileOpenCounter++;/* foOpt@XJE^CNg */
		atOnceMode = FILE_REQUESTMODE_GETFILESIZE;
	}
}


/*************************************************************************
 *	֐	:	CloseTest
 *	e	:	eXgJE^tt@CN[Y
 *		:	[J֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.3
 *	Rg:   t@CI[vAN[Y`FbNp
 *------------------------------------------------------------------------
 *	in:		void
 *	out:	void
 *************************************************************************/
static void CloseTest(void)
{
	if(ExistFileHandle(hFileReturnAtOnce)==FILE_OK){ /* t@Cnh݂ */
		gdFsClose(hFileReturnAtOnce);	/* t@CN[Y */
		fileOpenCounter--;				/* t@XJE^fNg */
	}
}


/*************************************************************************
 *	֐	:	SearchFileOpenIndex
 *	e	:	Jׂt@C̃Oobt@CfbNXԂ
 *		:	[J֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.3
 *	Rg:   
 *------------------------------------------------------------------------
 *	in:		void
 *	out:	Sint32	Oobt@CfbNXl
 *************************************************************************/
static Sint32 SearchFileOpenIndex(void)
{
	Sint32 i;
	Sint32 requestNumber = 0;

	for( i=1 ; i<FILE_RING_BUFFER_MAX ; i++ ){/* Oobt@ */
		if(requestBufferOpenPtr==&requestBuffer[i]){ /* ړĨobt@T */
			requestNumber = i;
			break;
		}
	}
	return(requestNumber);
}


/*************************************************************************
 *	֐	:	ErrorMessage
 *	e	:	t@C֘AG[bZ[W̏o
 *		:	[J֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.3
 *	Rg:   uvƂƂ̂߂̃IvV
 *------------------------------------------------------------------------
 *	in:		Ȃ
 *	out:	Ȃ
 *************************************************************************/
static void ErrorMessage(void)
{
	while (TRUE){ /* AăbZ[Wo */
		/* G[bZ[Wo */
		njPrintC(NJM_LOCATION(4,3),"FILE LOAD ERROR");
	}
}


/*************************************************************************
 *	֐	:	StartLoadReturnAtOnce
 *	e	:	t@C[hJn(A)
 *		:	[J֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.9
 *	Rg:  
 * *
 *------------------------------------------------------------------------
 *	in : 	void
 *	out:	Sint32:		G[R[h
 *************************************************************************/
static Sint32 StartLoadReturnAtOnce(void)
{
	atOnceMode = FILE_REQUESTMODE_OPEN;
	return(FILE_OK);
}


/*************************************************************************
 *	֐	:	File_LoadReturnAtOnce
 *	e	:	t@C[h(A)
 *		:	[J֐
 *	쐬	:	s.kuwata
 *	쐬	:	1998.6.9
 *	Rg:  
 * *
 *------------------------------------------------------------------------
 *	in : 	void
 *	out:	Sint32:		G[R[h
 *************************************************************************/
static Sint32 LoadReturnAtOnce(void)
{
	static Sint32			fileSize;
	static RequestBuffer 	*rbPtr;
	Sint32		  			result = FILE_BUSY; /* ʏ͓ǂݍݒ */
	Sint32					requestSector;
	Sint32					readByte;
	Sint32					requestNumber;
	GDFS_DIRREC 			hdirrec; /* fBNgR[hnh */
	Sint32					i;

/*	NGXgO𒼐ڃANZX */
	switch(atOnceMode){
		case FILE_REQUESTMODE_OPEN:	/* t@CJ */
			/* |C^ݒ */
			if(requestBufferOpenPtr==&requestBuffer[0]){	/* t@CI[ṽ|C^wb_Ȃ */
				requestBufferOpenPtr = requestBufferOpenPtr->next;	/* wb_΂ */
			}
			rbPtr = requestBufferOpenPtr;					/* |C^ݒ */
			hdirrec = NULL;
			if(rbPtr->readDirectoryName!=NULL){
				if((SetDirectory(rbPtr->readDirectoryName, &hdirrec))
										!=FILE_OK){	/* fBNgR[hǂݍ߂ȂƂ */
					result = FILE_NOTDIR;
					atOnceMode = FILE_REQUESTMODE_FALSE;
					break;
				}
			}
			OpenTest(rbPtr->readFileName, hdirrec, &result); /* t@CI[ṽeXg */
			break;
	
		case FILE_REQUESTMODE_GETFILESIZE: 	/* t@CTCY𓾂 */
			GetFileSectorSize(hFileReturnAtOnce, &fileSize);
			atOnceMode = FILE_REQUESTMODE_REQUEST;
			break;
	
		case FILE_REQUESTMODE_REQUEST:	/* t@Cǂݍݗv */
			/* read file */
			requestSector = gdFsReqRd32(hFileReturnAtOnce, fileSize, (Uint32 *)rbPtr->readAddress );
			if (requestSector < 0) { /* ǂݍ񂾃ZN^̂Ƃs */
				result = FILE_NOTREAD;
				atOnceMode = FILE_REQUESTMODE_FALSE;
				break;
			}
			atOnceMode = FILE_REQUESTMODE_COMPLETECHECK;
			break;
	
		case FILE_REQUESTMODE_COMPLETECHECK:/* t@Cǂݍ݊`FbN */
			readByte = gdFsGetNumRd(hFileReturnAtOnce); /* ǂݍ񂾃oCgi`FbNp) */
			if (gdFsGetStat(hFileReturnAtOnce) == GDD_STAT_COMPLETE) { /* ǂ݊? */
				atOnceMode = FILE_REQUESTMODE_CLOSE; 
				break;
			}
			break;
	
		case FILE_REQUESTMODE_CLOSE: /* t@C */
			requestNumber = SearchFileOpenIndex();				/* Oobt@̃t@CI[vʒuԂ */
			requestBufferOpenPtr = requestBufferOpenPtr->next;	/* ̃T[`|Cg */
			CloseTest();										/* foOpN[Y */
			File_DeleteEntryFileRequest(requestNumber);			/* NGXgobt@玩̃Gg폜 */
			if(requestBufferOpenPtr==&requestBuffer[0]){		/* Gg[폜At@CI[ṽ|C^wb_Ȃ */
				requestBufferOpenPtr = requestBufferOpenPtr->next;	/* wb_XLbv */
			}
			atOnceMode = FILE_REQUESTMODE_END;
			break;

		case FILE_REQUESTMODE_STOP:	/* NGXg~ */
			requestNumber = SearchFileOpenIndex();			/* Oobt@̃t@CI[vʒuԂ */
			CloseTest();									/* foOpN[Y */
			File_DeleteEntryFileRequest(requestNumber);		/* NGXgobt@玩̃Gg폜 */
			if(requestBufferOpenPtr==&requestBuffer[0]){		/* Gg[폜At@CI[ṽ|C^wb_Ȃ */
				requestBufferOpenPtr = requestBufferOpenPtr->next;	/* wb_XLbv */
			}
			atOnceMode = FILE_REQUESTMODE_ELSE;
			break;

		case FILE_REQUESTMODE_ALLSTOP:	/* Oobt@S */
			CloseTest();									/* foOpN[Y */
			File_DeleteEntryFileRequestAll();
			atOnceMode = FILE_REQUESTMODE_END;
			break;
		
		case FILE_REQUESTMODE_END:	/* I */
			result = FILE_OK;
		case FILE_REQUESTMODE_FALSE: /* ǂݍݎs */
			/* X̃G[R[hԂ */
			atOnceMode = FILE_REQUESTMODE_ELSE;
			break;

		case FILE_REQUESTMODE_ELSE:
		default: /* ̑ */
			StartLoadReturnAtOnce(); /* ǂݍݗvI */
			if(File_GetAllFileStatusReturnAtOnce()==TRUE){ /* ׂẴobt@̒gǂݍ񂾂 */
				bufferIndex = 0;	/* obt@̎QƐ͏Ԃɖ߂ */
			}
			return FILE_NOTREADY;

			break;
	}
	return result;
}
