/*============================================================
 * Name  :
 *
 * Desc  :
 *
 * prefix:
 *
 * $Id: htwinbutton.c,v 1.3 1998/04/20 06:03:06 horita Exp horita $
 *
 * $Log: htwinbutton.c,v $
 * Revision 1.3  1998/04/20 06:03:06  horita
 * {^item̔hɕύX
 *
 * Revision 1.2  1998/04/02 07:57:57  horita
 * {^ɑ΂ANV̒ǉ
 *
 * Revision 1.1  1998/04/02 00:29:33  horita
 * Initial revision
 *
 *============================================================*/

/*============================================================
  Include
  ============================================================*/
#include <stdio.h>
#include <shinobi.h>
#include "htwindow.h"
#include "htwinbutton.h"

/*============================================================
  Define
  ============================================================*/

/*============================================================
  Macro
  ============================================================*/

/*============================================================
  Structure
  ============================================================*/

/*============================================================
  Globals
  ============================================================*/

/*============================================================
  Static
  ============================================================*/

/*============================================================
  Local Prototypes
  ============================================================*/
static void button_method(LPHTtButtonArg arg, Sint32 state);

/*============================================================
 Name: HTtCreateButton
 Desc: {^̍쐬
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/01 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
void HTtCreateButton(HTWINHANDLE win, LPHTtButtonArg arg)
{
	HTManagedGadget(win, (LPHTWINGadget)arg);
	arg->node.method = button_method;
	arg->lp_push_action = NULL;
	arg->lp_onbutton_action = NULL;
}


/*============================================================
 Name:
 Desc:
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/01 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
static void button_method(LPHTtButtonArg arg, Sint32 state)
{
	switch (state) {
	case GADGET_NONE:								/* W */
		HTtDrawButton(arg);
		break;
	case GADGET_ONBUTTON:							/* On Button */
		if (arg->lp_onbutton_action != NULL) {
			arg->lp_onbutton_action(arg);
		} else {
			HTtDrawButton(arg);
		}
		HTtDrawBox(arg->item.lefttop.x - 1, 
				   arg->item.lefttop.y - 1, 
				   arg->item.lefttop.x + arg->item.size.x + 1, 
				   arg->item.lefttop.y + arg->item.size.y + 1, 0, 0xffffff00L);
		HTtDrawBox(arg->item.lefttop.x - 2, 
				   arg->item.lefttop.y - 2, 
				   arg->item.lefttop.x + arg->item.size.x + 2, 
				   arg->item.lefttop.y + arg->item.size.y + 2, 0, 0xffffff00L);
		break;
	case GADGET_PUSH:								/* When Pushed Button */
		if (arg->lp_push_action != NULL) {
			arg->lp_push_action(arg);
		} else {
			HTtDrawButton(arg);
		}
		break;
		
	}
}

/*============================================================
 Name:
 Desc:
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/01 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
void HTtDrawButton(LPHTtButtonArg arg)
{
	HTtDrawItem(&arg->item);
}


/*============================================================
 Name:
 Desc:
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/01 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
void HTtSetPushButtonCallBack(LPHTtButtonArg arg, LPHtWinGadgetCallBack func)
{
	arg->lp_push_action = func;
}


/*============================================================
 Name:
 Desc:
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/01 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
void HTtSetOnButtonCallBack(LPHTtButtonArg arg, LPHtWinGadgetCallBack func)
{
	arg->lp_onbutton_action = func;
}
