/*============================================================
 * Name  : 
 *
 * Desc  : mF_CAO(yes/no)
 *
 * prefix:
 *
 * $Id: winconfirm.c,v 1.2 1998/04/07 03:24:42 horita Exp horita $
 *
 * $Log: winconfirm.c,v $
 * Revision 1.2  1998/04/07 03:24:42  horita
 * V{^tH[}bgɑΉ
 *
 * Revision 1.1  1998/04/02 07:58:40  horita
 * Initial revision
 *
 *============================================================*/

/*============================================================
  Include
  ============================================================*/
#include <stdio.h>
#include <shinobi.h>
#include "htwindow.h"
#include "htwinbutton.h"
#include "htwinbuttonarray.h"
#include "htfont.h"
#include "x_rgb.h"

/*============================================================
  Define
  ============================================================*/
enum {
	BUTTON_CNT = 2,
	BUTTON_OFFSET = 20
};

#define BUTTON_WIDTH	64
#define BUTTON_HIEGHT	16
/*============================================================
  Macro
  ============================================================*/

/*============================================================
  Structure
  ============================================================*/

/*============================================================
  Globals
  ============================================================*/

/*============================================================
  Static
  ============================================================*/
static HTWINHANDLE confirm_win;
static HTtButtonArg button_args[BUTTON_CNT];
static LPHtWinGadgetCallBack func[BUTTON_CNT];
static NJS_TEXINFO button_info[BUTTON_CNT];
static NJS_TEXNAME button_name[BUTTON_CNT];
static NJS_TEXLIST button_list = {
	button_name, BUTTON_CNT,
};
static Uint16 ButtonTextureBuffer[BUTTON_CNT][BUTTON_WIDTH * BUTTON_HIEGHT];
static NJS_COLOR button_col[BUTTON_CNT][4] = {
	WHITE_COL, WHITE_COL, WHITE_COL, WHITE_COL, 
	GRAY50_COL, GRAY50_COL, GRAY50_COL, GRAY50_COL, 
};
static NJS_COLOR button_uv[4] = {
	UV(0, 0), UV(256, 0), UV(256, 256), UV(0, 256),
};

static HTtItemAttr button_attr[BUTTON_CNT] = {
	ITEM_ATTR_TEXTURE, 0,
	button_col[0],
	button_uv,
	
	ITEM_ATTR_TEXTURE, 1,
	button_col[1],
	button_uv,
};	

/*============================================================
  Local Prototypes
  ============================================================*/
static void yes_button_pushed(LPHTtButtonArg arg);
static void no_button_pushed(LPHTtButtonArg arg);




/*============================================================
 Name:
 Desc:
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/07 (Tuesday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTtCreateConfirmButton(void)
{
	/* Create Button Texture */
	{
		int i;

		memset(ButtonTextureBuffer, 0, sizeof(ButtonTextureBuffer));
		for (i = 0 ; i < BUTTON_CNT ; i++) {
			njSetTextureInfo(button_info + i, ButtonTextureBuffer[i], NJD_TEXFMT_ARGB_1555 | NJD_TEXFMT_RECTANGLE, BUTTON_WIDTH, BUTTON_HIEGHT);
			njSetTextureName(button_name + i, button_info + i, i + BUTTON_OFFSET, NJD_TEXATTR_TYPE_MEMORY|NJD_TEXATTR_GLOBALINDEX);
		}
		htFontGetStr(" YES", ButtonTextureBuffer[0], BUTTON_WIDTH, HTFONTATTR_POS_CENTER);
		htFontGetStr("~  NO", ButtonTextureBuffer[1], BUTTON_WIDTH, HTFONTATTR_POS_CENTER);
		njLoadTexture(&button_list);
	}
	
	/* {^Q̑̐ݒ */
	{
		int i;
		LPHTtItemAttr lp_item_attr = button_attr;

		for (i = 0 ; i < BUTTON_CNT ; i++) {
			button_args[i].item.lp_item_attr = lp_item_attr;
			button_args[i].item.nItem = 1;
			button_args[i].item.size.x = BUTTON_WIDTH * 2;
			button_args[i].item.size.y = BUTTON_HIEGHT * 2;
			lp_item_attr++;
		}
	}
}

/*============================================================
 Name:
 Desc:
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/02 (Thursday)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
HTWINHANDLE HTtCreateConfirmWindow(Float left, Float top, LPHtWinGadgetCallBack yes_func, LPHtWinGadgetCallBack no_func)
{
	/* {^Q̍쐬 */
	HTtSetButtonArrayAttribute(HTBUTTONARRAY_ATTR_VERT);
	confirm_win = HTtCreateButtonArrayWindow(left, top, button_args, BUTTON_CNT, WHITE_COL, GRAY20_COL);
	HTSetTextureList(confirm_win, &button_list);
	HTtSetPushButtonCallBack((LPHTtButtonArg)button_args, yes_button_pushed);
	if (yes_func != NULL) {
		func[0] = yes_func;
	}
	HTtSetPushButtonCallBack((LPHTtButtonArg)(button_args + 1), no_button_pushed);
	if (no_func != NULL) {
		func[1] = no_func;
	}
	return confirm_win;
}


/*============================================================
 Name:
 Desc:
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/02 (Thursday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
static void yes_button_pushed(LPHTtButtonArg arg)
{
	HTCloseWindow(confirm_win);
	if (func[0] != NULL) {
		func[0](arg);
	}
}

/*============================================================
 Name:
 Desc:
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/02 (Thursday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
static void no_button_pushed(LPHTtButtonArg arg)
{
	HTCloseWindow(confirm_win);
	if (func[1] != NULL) {
		func[1](arg);
	}
}
