/*============================================================
 * Name  : htwinitem.c
 *
 * Desc  : ACeNX
 *
 * prefix: HTt
 *
 * $Id: htwinitem.c,v 1.3 1998/04/21 03:09:33 horita Exp horita $
 *
 * $Log: htwinitem.c,v $
 * Revision 1.3  1998/04/21 03:09:33  horita
 * HTtDrawItemZ֐ǉ̂ŁAHtDrawItem֐IɏC
 * HTtDrawItem(arg) = HTtDrawItemZ(arg, 0);
 *
 * Revision 1.2  1998/04/21 03:07:24  horita
 * HTtDrawItemZ֐ǉ
 *
 * Revision 1.1  1998/04/20 06:02:02  horita
 * Initial revision
 *
 *============================================================*/

/*============================================================
  Include
  ============================================================*/
#include <stdio.h>
#include <shinobi.h>

#include "htwindow.h"
#include "htwinitem.h"

/*============================================================
  Define
  ============================================================*/

/*============================================================
  Macro
  ============================================================*/

/*============================================================
  Structure
  ============================================================*/

/*============================================================
  Globals
  ============================================================*/

/*============================================================
  Static
  ============================================================*/

/*============================================================
  Local Prototypes
  ============================================================*/


/*============================================================
 Name: HTtDrawItem
 Desc: Item̕`
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/20 (Monday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTtDrawItem(LPHTtItem arg)
{
	HTtDrawItemZ(arg, 0.F);
}

/*============================================================
 Name: HTtDrawItem
 Desc: Item̕`
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/20 (Monday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTtDrawItemZ(LPHTtItem arg, Float z)
{
	LPHTtItemAttr lp_item_attr = arg->lp_item_attr;
	static NJS_POINT2 vert[4];
	static NJS_POINT2COL p = {
		vert, NULL, NULL, 4,
	};
	Float z_ofs = z;
	int i;

	vert[0] = arg->lefttop;
	vert[1] = arg->lefttop;
	vert[2] = arg->lefttop;
	vert[3] = arg->lefttop;
	vert[1].x += arg->size.x;
	vert[2].x += arg->size.x;
	vert[2].y += arg->size.y;
	vert[3].y += arg->size.y;
	for (i = 0 ; i < arg->nItem ; i++) {
		p.col = lp_item_attr->color;
		p.tex = lp_item_attr->texture;
		if (lp_item_attr->attr == ITEM_ATTR_POLYGON) {
			HTtDraw2DObject(&p, 4, z_ofs, NJD_FILL | NJD_TRANSPARENT);
		} else {
			njSetTextureNum(lp_item_attr->tex_no);
			HTtDraw2DObject(&p, 4, z_ofs, NJD_USE_TEXTURE | NJD_FILL | NJD_TRANSPARENT);
		}
		z_ofs += 1.F;
		lp_item_attr++;
	}
}
