/*
 *	jctype.h		kanji character handling
 */

#ifndef	__JCTYPE_H__
#define	__JCTYPE_H__

#include <ctype.h>

extern	const	unsigned char	_jctype[];

#define	_J_KPUN_P	0x01							/* katakana punctuation character */
#define	_J_KANA_P	0x02							/* katakana character */
#define	_J_KNJ1_P	0x04							/* kanji 1st character */
#define	_J_KNJ2_P	0x08							/* kanji 2nd character */

#define	iskana(c)	((_jctype[(c)+1] & (_J_KPUN_P | _J_KANA_P)) != 0)
#define	iskpun(c)	((_jctype[(c)+1] & _J_KPUN_P) != 0)
#define	iskmoji(c)	((_jctype[(c)+1] & _J_KANA_P) != 0)
#define	isalkana(c)	(isalpha(c) || iskmoji(c))
#define	ispnkana(c)	(ispunct(c) || iskpun(c))
#define	isalnmkana(c)	(isalnum(c) || iskmoji(c))
#define	isprkana(c)	(isprint(c) || iskana(c))
#define	isgrkana(c)	(isgraph(c) || iskana(c))

#define	iskanji(c)	((_jctype[(c)+1] & _J_KNJ1_P) != 0)
#define	iskanji2(c)	((_jctype[(c)+1] & _J_KNJ2_P) != 0)

#endif /* __JCTYPE_H__ */
