/*
 * system -- [Upӂ֐Q
 *
 * $Id: system.h,v 1.1 1998/02/23 07:47:57 horita Exp horita $
 *
 * $Log: system.h,v $
 * Revision 1.1  1998/02/23 07:47:57  horita
 * Initial revision
 *
 */

#ifndef __SYSTEM_H__
#define __SYSTEM_H__

#include <Ninja.h>
#include "x_rgb.h"

/*
 * define
 */
#define MAX_MATRIX	32
#define MAX_VERTEX	60000
#define MAX_VERTEX_BUFF	10000
#define MAX_TEXTURE	256

#define MAX_TIMER	4
#define USTR(str) ((unsigned char *)str)

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Value
 */
extern NJS_VIEW 	view;
extern NJS_MATRIX 	matrix[MAX_MATRIX];
extern NJS_TEXMEMLIST 	tex[MAX_TEXTURE];
extern NJS_VERTEX_BUF	vbuf[MAX_VERTEX_BUFF];
extern NJS_LIGHT	light;
extern NJS_FOG_TABLE	fog;

/*
 * API
 */
extern void InitSystem(int res, int frame_mode, int interval);
extern void init_system(int interval);
extern Float StdRand(void);							// Kz闐Ԃ
extern void InitTimer(int);							// ^C}[̏
extern Uint32 GetTimer(int);						// ݂̃^C}[̏
extern void PrintMatrix(Int loc, NJS_MATRIX m);		// }gNX̕\
extern void Dbg_PrintMatrix(NJS_MATRIX m);			// fobOp
extern void print_pos(int ofs, NJS_POINT3* pos);	// Wf[^̕\
extern void disable_ambient_light();				// ̏
extern void enable_ambient_light();					// ̓_
extern void gen_fog(NJS_FOG_TABLE, Float);			// foge[u̍쐬(1)
extern void CreateFogTable(NJS_FOG_TABLE, Float);	// foge[u̍쐬(2)
extern void spline(NJS_VECTOR*, Float,				// B-spline
				   NJS_VECTOR*, NJS_VECTOR*, NJS_VECTOR*, NJS_VECTOR*);

#ifdef __cplusplus
}
#endif

#endif
