/*============================================================
 * Name  : htfont.c
 *
 * Desc  : tHgT[o[
 *
 * prefix: htFont
 *
 * $Id: htfont.c,v 1.3 1998/04/13 06:22:09 horita Exp horita $
 *
 * $Log: htfont.c,v $
 * Revision 1.3  1998/04/13 06:22:09  horita
 * ANK̃x^tHg̃[h֐htFontLoadAnkǉ
 *
 * Revision 1.2  1998/04/09 15:03:46  horita
 * tHg̐F|S̒_̐FŎw肷悤ɂ̂łɔύXB
 * {Iɂ́A\i܂́A2lȂ킯)
 *
 * Revision 1.1  1998/04/07 03:23:59  horita
 * Initial revision
 *
 *============================================================*/

/*

Font server

ER[hShift-JISv撆(Font data̎dl)
EtHgtH[}bg 2l

*/

/*============================================================
  Include
  ============================================================*/
#include <stdio.h>
#include <string.h>
#include <ninja.h>
#include <njdef.h>
#include "jctype.h"
#include "mytype.h"
#include "system.h"
#include "htfont.h"

/*============================================================
  Define
  ============================================================*/
#define MAX_FONT_SIZE	300000						// ǂݍފtHg̍őTCY
#define MAX_FONT_TABLE	128							// tHge[u̍ő吔
#define MAX_ANK_SIZE	0x2000						/* ptHg̍őTCY */

#define FOREGROUND_COLOR	0xffff
#define BACKGROUND_COLOR	0x0000

/*============================================================
  Macro
  ============================================================*/

/*============================================================
  Structure
  ============================================================*/
typedef struct taghtFontHeader htFontHeader;
struct taghtFontHeader {
	Uint8 u8ID[6];
	Uint8 u8Name[8];
	Uint8 u8xsize;
	Uint8 u8ysize;
	Uint8 u8Type;
	Uint8 u8ntable;
};
	
/*============================================================
  Globals
  ============================================================*/

/*============================================================
  Static
  ============================================================*/
static Uint32 u32Font_Hsize;						// tHg̑傫 
static Uint32 u32Font_Vsize;						//     V           
static LPUint16 lp_code_table;						// R[he[uւ̃|C^
static Uint32 u32CodeTableCnt;						// R[he[u̐
static Uint8 u8kFontBuffer[MAX_FONT_SIZE];			// tHgobt@
static Uint8 u8aFontBuffer[MAX_ANK_SIZE];			// ANKtHgobt@
static htFontHeader ht_font_header;					// tHgwb_
static LPUint8 lp_font_base_table[MAX_FONT_TABLE];	// tHgAhX̃e[u

/*============================================================
  Local Prototypes
  ============================================================*/
static Uint32 htFontGetIndex(Uint16 Code);


/*************************************************************
 *************************************************************															  
 **                                                         **
 ** [J֐Q                                          **
 **                                                         **
 *************************************************************															  
 *************************************************************/

/*============================================================
 Name: htFontGetIndex
 Desc: tHgԍtHge[ũCfbNX
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/03/16 (Monday)
 Misc: oCiT[`ɂCfbNX̌
 ------------------------------------------------------------
 in  : tHgԍ(Shift-JIS)
 out : CfbNXԍ
 ============================================================*/
static Uint32 htFontGetIndex(Uint16 u16kcode)
{
	int mid;
	int left = 0;
	int right = u32CodeTableCnt - 1; 
	
	right++;
	while (left < right) {
		mid = (left + right) / 2;
		if (lp_code_table[mid] <= u16kcode) {
			left = mid + 1;
		} else {
			right = mid;
		}
	}
	return left - 1;
}

/*************************************************************
 *************************************************************															  
 **                                                         **
 ** O[o֐Q                                        **
 **                                                         **
 *************************************************************															  
 *************************************************************/

/*============================================================
 Name: htFontInit
 Desc: (Ȃɂ邩͖)
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/03/13 (Friday)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
void htFontInit(void)
{
}



/*============================================================
 Name:
 Desc:
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/13 (Monday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void htFontLoadAnk(LPUint8 fname)
{
	FILE* font_file;
	
	/* ANKtHg̓ǂݍ */
	if ((font_file = fopen(fname, "r")) == NULL) {
		exit(1);
	} else {
		/* tHg̃[h */
		fread(u8aFontBuffer, 1, MAX_ANK_SIZE, font_file);
		fclose(font_file);
	}
}

/*============================================================
 Name: htFontLoad
 Desc: tHg̃[h
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/03/13 (Friday)
 Misc: ȂȂ邩Ȃ....
 ------------------------------------------------------------
 in  : ank_name.. t@C(ANK)
     : knj_name.. t@C(KANJI)
 out :
 ============================================================*/
void htFontLoad(LPUint8 ank_name, LPUint8 knj_name)
{
	FILE* font_file;
	
	/* ANKtHg̓ǂݍ */
	if ((font_file = fopen(ank_name, "r")) == NULL) {
		exit(1);
	} else {
		/* tHgwb_̏ */
		fread(&ht_font_header, 17, 1, font_file);

		/* tHg̃[h */
		fread(u8aFontBuffer, 1, MAX_ANK_SIZE, font_file);
		fclose(font_file);
	}
	/* tHg̓ǂݍ */
	if ((font_file = fopen(knj_name, "r")) == NULL) {
		exit(1);
	} else {
		/* tHgwb_̏ */
		fread(&ht_font_header, sizeof(htFontHeader), 1, font_file);
		u32CodeTableCnt = ht_font_header.u8ntable * 2;

		/* tHg̃[h */
		fread(u8kFontBuffer, 1, MAX_FONT_SIZE, font_file);
		lp_code_table = (LPUint16)u8kFontBuffer;

		/* tHgAhXe[u̍쐬 */
		{
			Uint32 i;
			LPUint8 image_base = u8kFontBuffer + 2 * u32CodeTableCnt;
			LPUint16 lp_code_table = (LPUint16)u8kFontBuffer;

			for (i = 0 ; i < u32CodeTableCnt ; i += 2) {
				lp_font_base_table[i / 2] = image_base;
				image_base += (lp_code_table[i + 1] - lp_code_table[i] + 1) * 32;
			}
		}
	}
}


/*============================================================
 Name: htFontGet
 Desc: tHg̏
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/03/13 (Friday)
 Misc:
 ------------------------------------------------------------
 in  : Font_Code.. R[h
 out : Addr .. WJ̊f[^i[AhX 
 ============================================================*/
void htFontGetKanji(Uint16 Font_Code, void* Addr, Sint32 with)
{
	Uint32 u32table_index;
	LPUint8 lp_font_addr;
	int x, y;
	LPUint16 lp_tag_addr = (LPUint16)Addr;
	Uint8 u8_pix;

	u32table_index = htFontGetIndex(Font_Code);
	lp_font_addr = lp_font_base_table[u32table_index / 2] + (Font_Code - lp_code_table[u32table_index]) * 32;
	{
		for (y = 0 ; y < 16 ; y++) {
			lp_tag_addr += 15;
			u8_pix = *(lp_font_addr + 1);
			for (x = 0 ; x < 8 ; x++) {
				if ((u8_pix & 1) == 1) {
					*lp_tag_addr = FOREGROUND_COLOR;
				} else {
					*lp_tag_addr = BACKGROUND_COLOR;
				}
				u8_pix >>= 1;
				lp_tag_addr--;
			}
			u8_pix = *lp_font_addr;
			for (x = 0 ; x < 8 ; x++) {
				if ((u8_pix & 1) == 1) {
					*lp_tag_addr = FOREGROUND_COLOR;
				} else {
					*lp_tag_addr = BACKGROUND_COLOR;
				}
				u8_pix >>= 1;
				lp_tag_addr--;
			}
			lp_tag_addr += with + 1;					/* ̃C */
			lp_font_addr += 2;
		}
	}
}


/*============================================================
 Name:
 Desc:
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/08 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void htFontGetAnk(Uint8 ank_code, void* Addr, Sint32 with)
{
	LPUint16 lp_tag_addr = (LPUint16)Addr;
	LPUint8 lp_font_addr;
	Uint8 u8_pix;
	int x, y;

	lp_font_addr = u8aFontBuffer + ank_code * 16;	/* ł ank8x16dot */
	for (y = 0 ; y < 16 ; y++) {
		lp_tag_addr += 7;
		u8_pix = *lp_font_addr;
		for (x = 0 ; x < 8 ; x++) {
			if ((u8_pix & 1) == 1) {
				*lp_tag_addr = FOREGROUND_COLOR;
			} else {
				*lp_tag_addr = BACKGROUND_COLOR;
			}
			u8_pix >>= 1;
			lp_tag_addr--;
		}
		lp_tag_addr += with + 1;					/* ̃C */
		lp_font_addr++;
	}
}

/*============================================================
 Name: htFontGetStr
 Desc: ̃tHg̏
 Kind: Global - Extend
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/03/13 (Friday)
 Misc:
 ------------------------------------------------------------
 in  : Kanji_Str.. Kȕ
 out : Addr .. WJ̊f[^i[AhX 
 ============================================================*/
void htFontGetStr(LPUint8 Kanji_Str, LPUint8 Addr, Sint32 with, HTFontAttr attr)
{
	int i;
	int lengs = strlen(Kanji_Str);
	
	/* ̑WJAhX̐ */
	{
		/* ̒eNX`[̃TCY */
		int str_width = lengs * 8;					/* Ƃ肠1byte = 8 dot(=16byte) */

		switch (attr) {
		case HTFONTATTR_POS_LEFT:
			break;
		case HTFONTATTR_POS_CENTER:
			Addr += with - str_width;
			break;
		case HTFONTATTR_POS_RIGHT:
			Addr += (with - str_width) * 2;
			break;
		}
	}
		
	for (i = 0 ; i < lengs ; i++) {
		if (iskanji(*Kanji_Str)) {
			Uint16 k_code = (*(Kanji_Str) << 8) + *(Kanji_Str + 1);

			htFontGetKanji(k_code, Addr, with);
			Kanji_Str += 2;
			Addr += 32;
			i++;
		} else {
			htFontGetAnk(*Kanji_Str, Addr, with);
			Kanji_Str++;
			Addr += 16;
		}
	}
}


/*============================================================*
 * End of File                                                *
 *============================================================*/
