
/*============================================================
 * Name  :
 *
 * Desc  : {^AC̎
 *
 * prefix:
 *
 * $Id: winbuttonarray.c,v 1.2 1998/04/09 15:02:37 horita Exp horita $
 *
 * $Log: winbuttonarray.c,v $
 * Revision 1.2  1998/04/09 15:02:37  horita
 * KWFbg̊Ǘ@ς̂łɔC
 *
 * Revision 1.1  1998/04/02 07:58:04  horita
 * Initial revision
 *
 *============================================================*/

#if DOCUMENT
#endif

/*============================================================
  Include
  ============================================================*/
#include <stdio.h>
#include "htwindow.h"
#include "htwinbutton.h"
#include "htwinbuttonarray.h"

/*============================================================
  Define
  ============================================================*/

/*============================================================
  Macro
  ============================================================*/

/*============================================================
  Structure
  ============================================================*/

/*============================================================
  Globals
  ============================================================*/

/*============================================================
  Static
  ============================================================*/
static HTtButtonArrayAttr attr = HTBUTTONARRAY_ATTR_VERT;

static struct {
	Sint16 nWidth;									/* {^AC̉̐ */
	Sint16 nHeight;									/* {^AĈĕ̐ */
	Sint16 Direction;								/* {^AC̊ */
	Float width;									/* {^̉̊Ԋu */
	Float height;									/* {^̏c̊Ԋu */
} ButtonArrayAttr = {
	1, 1, HTBUTTONARRAY_DIRECTION_VERT, 64, 16
};

/*============================================================
  Local Prototypes
  ============================================================*/



/*============================================================
 Name:
 Desc:
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/08 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
HTWINHANDLE HTtCreateButtonArrayWindow(Float left, Float top, LPHTtButtonArg args, Sint32 nButton, Sint32 fore, Sint32 back)
{
	int i;
	Float width = 0;
	Float height = 0;
	LPHTtButtonArg arg_list;
	HTWINHANDLE button_win;

	arg_list = args;
	switch (attr) {
	case HTBUTTONARRAY_ATTR_USERSET:
		/* 
		 * USERSET ̂Ƃ̓[U[ʒuĂ
		 * āAVXe䂷̂̓EBhȆ傫̂
		 */
		for (i = 0 ; i < nButton ; i++) {
			if ((args->item.lefttop.x + args->item.size.x)  > width) {
				width = args->item.lefttop.x + args->item.size.x;
			}
			if ((args->item.lefttop.y + args->item.size.y)  > height) {
				height = args->item.lefttop.y + args->item.size.y;
			}
			args++;
		}
		width += 4;
		height += 4;
		break;
	case HTBUTTONARRAY_ATTR_VERT:
		height = 2;
		for (i = 0 ; i < nButton ; i++) {
			args->item.lefttop.x = 2;
			if (width < args->item.size.x) {
				width = args->item.size.x;
			}
			args->item.lefttop.y = height;
			height += args->item.size.y + 2;
			args++;
		}
		width += 4;
		break;
	case HTBUTTONARRAY_ATTR_HORIZ:
		width = 2;
		for (i = 0 ; i < nButton ; i++) {
			args->item.lefttop.y = 2;
			if (height < args->item.size.y) {
				height = args->item.size.y;
			}
			args->item.lefttop.x = width;
			width += args->item.size.x + 2;
			args++;
		}
		height += 4;
		break;
	}
		
	button_win = HTCreateSimpleWindow(left, top, left + width, top + height, fore, back);
	HTMapWindow(button_win);

	args = arg_list;
	HTSetGadgetDefault(button_win, (LPHTWINGadget)args);
	for (i = 0 ; i < nButton ; i++) {
		HTtCreateButton(button_win, args);
		HTSetGadgetSelectable((LPHTWINGadget)args);
		args++;
	}
	return button_win;
}

/*============================================================
 Name:
 Desc: {^AC̑̐ݒ
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/08 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTtSetButtonArrayAttribute(HTtButtonArrayAttr _attr)
{
	attr = _attr;
}

/*============================================================
 Name:
 Desc:
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/08 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTtSetButtonArrayAttrWidth(Float width)
{
	ButtonArrayAttr.width = width;
}


/*============================================================
 Name:
 Desc:
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/08 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTtSetButtonArrayAttrHeight(Float height)
{
	ButtonArrayAttr.height = height;
}


/*============================================================
 Name:
 Desc:
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/08 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTtSetButtonArrayAttrDirection(HTtButtonArrayDirection direction)
{
	ButtonArrayAttr.Direction = direction;
}
