/*============================================================
 * Name  : htwinbuttonbox.c
 *
 * Desc  : {^{bNXNX
 *
 * prefix:
 *
 * $Id$
 *
 * $Log$
 *============================================================*/

#if DOCUMENT
#endif

/*============================================================
  Include
  ============================================================*/
#include <stdio.h>
#include "htwinitembox.h"
#include "htwinbuttonbox.h"

/*============================================================
  Define
  ============================================================*/

/*============================================================
  Macro
  ============================================================*/

/*============================================================
  Structure
  ============================================================*/

/*============================================================
  Globals
  ============================================================*/

/*============================================================
  Static
  ============================================================*/

/*============================================================
  Local Prototypes
  ============================================================*/
static void button_method(LPHTtButtonBoxArg arg, Sint32 state);


/*============================================================
 Name:
 Desc:
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/21 (Tuesday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTtCreateButtonBox(HTWINHANDLE win, LPHTtButtonBoxArg arg)
{
	HTManagedGadget(win, (LPHTWINGadget)arg);
	arg->node.method = button_method;
	arg->lp_push_action = NULL;
	arg->lp_onbutton_action = NULL;
}

/*============================================================
 Name:
 Desc:
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/01 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
static void button_method(LPHTtButtonBoxArg arg, Sint32 state)
{
	switch (state) {
	case GADGET_NONE:								/* W */
		HTtDrawItemBox(arg->lp_item);
		break;
	case GADGET_ONBUTTON:							/* On Button */
		if (arg->lp_onbutton_action != NULL) {
			arg->lp_onbutton_action(arg);
		} else {
			HTtDrawItemBox(arg->lp_item);
		}
		HTtDrawBox(arg->lp_item->lefttop.x - 1, 
				   arg->lp_item->lefttop.y - 1, 
				   arg->lp_item->lefttop.x + arg->size.x + 1, 
				   arg->lp_item->lefttop.y + arg->size.y + 1, 0, 0xffffff00L);
		HTtDrawBox(arg->lp_item->lefttop.x - 2, 
				   arg->lp_item->lefttop.y - 2, 
				   arg->lp_item->lefttop.x + arg->size.x + 2, 
				   arg->lp_item->lefttop.y + arg->size.y + 2, 0, 0xffffff00L);
		break;
	case GADGET_PUSH:								/* When Pushed Button */
		if (arg->lp_push_action != NULL) {
			arg->lp_push_action(arg);
		} else {
			HTtDrawItemBox(arg->lp_item);
		}
		break;
		
	}
}

/*============================================================
 Name: HTtSetPushButtonBoxCallBack
 Desc: J[\{^ɗ̃ANV
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/21 (Tuesday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTtSetPushButtonBoxCallBack(LPHTtButtonBoxArg arg, LPHtWinGadgetCallBack func)
{
	arg->lp_push_action = func;
}

/*============================================================
 Name: HTtSetOnButtonBoxCallBack
 Desc: {^̃ANV
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/21 (Tuesday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTtSetOnButtonBoxCallBack(LPHTtButtonBoxArg arg, LPHtWinGadgetCallBack func)
{
	arg->lp_onbutton_action = func;
}
