/*============================================================
 * Name  : htwinbuttonboxarray.c
 *
 * Desc  : {^{bNXACNX
 *
 * prefix:
 *
 * $Id$
 *
 * $Log$
 *============================================================*/

#if DOCUMENT
#endif

/*============================================================
  Include
  ============================================================*/
#include <stdio.h>
#include "htwindow.h"
#include "htwinbutton.h"
#include "htwinbuttonarray.h"
#include "htwinbuttonbox.h"
#include "htwinbuttonboxarray.h"

/*============================================================
  Define
  ============================================================*/

/*============================================================
  Macro
  ============================================================*/

/*============================================================
  Structure
  ============================================================*/

/*============================================================
  Globals
  ============================================================*/

/*============================================================
  Static
  ============================================================*/
static HTtButtonArrayAttr attr = HTBUTTONARRAY_ATTR_VERT;

static struct {
	Sint16 nWidth;									/* {^AC̉̐ */
	Sint16 nHeight;									/* {^AĈĕ̐ */
	Sint16 Direction;								/* {^AC̊ */
	Float width;									/* {^̉̊Ԋu */
	Float height;									/* {^̏c̊Ԋu */
} ButtonArrayAttr = {
	1, 1, HTBUTTONARRAY_DIRECTION_VERT, 64, 16
};

/*============================================================
  Local Prototypes
  ============================================================*/

/*============================================================
 Name:
 Desc:
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/08 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
HTWINHANDLE HTtCreateButtonBoxArrayWindow(Float left, Float top, LPHTtButtonBoxArg args, Sint32 nButton, Sint32 fore, Sint32 back)
{
	int i;
	Float width = 0;
	Float height = 0;
	LPHTtButtonBoxArg arg_list;
	HTWINHANDLE button_win;

	arg_list = args;
	switch (attr) {
	case HTBUTTONARRAY_ATTR_USERSET:
		/* 
		 * USERSET ̂Ƃ̓[U[ʒuĂ
		 * āAVXe䂷̂̓EBhȆ傫̂
		 */
		for (i = 0 ; i < nButton ; i++) {
			if ((args->lp_item->lefttop.x + args->size.x)  > width) {
				width = args->lp_item->lefttop.x + args->size.x;
			}
			if ((args->lp_item->lefttop.y + args->size.y)  > height) {
				height = args->lp_item->lefttop.y + args->size.y;
			}
			args++;
		}
		width += 4;
		height += 4;
		break;
	case HTBUTTONARRAY_ATTR_VERT:
		height = 2;
		for (i = 0 ; i < nButton ; i++) {
			args->lp_item->lefttop.x = 2;
			if (width < args->size.x) {
				width = args->size.x;
			}
			args->lp_item->lefttop.y = height;
			height += args->size.y + 2;
			args++;
		}
		width += 4;
		break;
	case HTBUTTONARRAY_ATTR_HORIZ:
		width = 2;
		for (i = 0 ; i < nButton ; i++) {
			args->lp_item->lefttop.y = 2;
			if (height < args->size.y) {
				height = args->size.y;
			}
			args->lp_item->lefttop.x = width;
			width += args->size.x + 2;
			args++;
		}
		height += 4;
		break;
	}
		
	button_win = HTCreateSimpleWindow(left, top, left + width, top + height, fore, back);
	HTMapWindow(button_win);

	args = arg_list;
	HTSetGadgetDefault(button_win, (LPHTWINGadget)args);
	for (i = 0 ; i < nButton ; i++) {
		HTtCreateButton(button_win, (LPHTtButtonArg)args);
		HTSetGadgetSelectable((LPHTWINGadget)args);
		args++;
	}
	return button_win;
}

/*============================================================
 Name:
 Desc: {^AC̑̐ݒ
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/08 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTtSetButtonBoxArrayAttribute(HTtButtonArrayAttr _attr)
{
	attr = _attr;
}

/*============================================================
 Name:
 Desc:
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/08 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTtSetButtonBoxArrayAttrWidth(Float width)
{
	ButtonArrayAttr.width = width;
}


/*============================================================
 Name:
 Desc:
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/08 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTtSetButtonBoxArrayAttrHeight(Float height)
{
	ButtonArrayAttr.height = height;
}


/*============================================================
 Name:
 Desc:
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/08 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTtSetButtonBoxArrayAttrDirection(HTtButtonArrayDirection direction)
{
	ButtonArrayAttr.Direction = direction;
}
