/*============================================================
 * Name  :
 *
 * Desc  :
 *
 * prefix:
 *
 * $Id: htwindow.c,v 1.5 1998/04/16 00:55:34 horita Exp horita $
 *
 * $Log: htwindow.c,v $
 * Revision 1.5  1998/04/16 00:55:34  horita
 * WinProc̒ǉ
 *
 * Revision 1.4  1998/04/09 15:01:16  horita
 * KWFbg̊ǗoNɕύXB
 * ɔ\̂̌B
 *
 * Revision 1.3  1998/04/02 07:59:09  horita
 * HTtDrawLineoȌC
 *
 * Revision 1.2  1998/04/02 00:30:48  horita
 * toolbox̓
 *
 * Revision 1.1  1998/04/01 05:40:28  horita
 * Initial revision
 *
 *============================================================*/

#if DOCUMENT
#endif

/*============================================================
  Include
  ============================================================*/
#include <stdio.h>
#include <ninjawin.h>
#include "htwindow.h"

/*============================================================
  Define
  ============================================================*/
#define MAX_WINDOW	64
enum {
	STATE_NOUSE,
	STATE_INUSE,									/* LSB = gptO */
	STATE_FRAME_DRAWING = 3
};

#define ZDEPTH_TOP	   -100.F
#define ZDEPTH_WIN		 10.F
#define ZDEPTH_GAD		  1.F

/*============================================================
  Macro
  ============================================================*/

/*============================================================
  Structure
  ============================================================*/
typedef struct tag_WindowInfo {
	Sint16 state;									/* ԁitOj */
	Sint16 nWidth;									/* {^AC̉̐ */
	Sint16 nHeight;									/* {^AĈĕ̐ */
	Sint16 Direction;								/* {^AC̊ */
	Float left;										/*  */
	Float top;										/*  */
	Float right;									/* E */
	Float bottom;									/*  */
	Sint32 foreground;								/* OiF */
	Sint32 background;								/* wiF */
	Float  priority;								/* Dx */
	LPHtWinCallBack lpbg_callback;					/* wi`R[obN */
	LPHtWinCallBack lpstframe_callback;				/* g`͂߃R[obN */
	LPHtWinCallBack lpframe_callback;				/* g`R[obN */
	void* lpWinProc;								/* EBhE֐ */
	HTWINGadget* managed_window;					/* ǗEBhEւ̃|C^ */
	HTWINGadget* cur_gadget;						/* ݑIĂGadget */
	NJS_TEXLIST *texture_list;						/* eNX`[Xg(eEBhEƂɂ悳) */
} WindowInfo;
typedef struct tag_WindowInfo *LPWindowInfo;

static WindowInfo win_info_buffer[MAX_WINDOW];

/*============================================================
  Globals
  ============================================================*/

/*============================================================
  Static
  ============================================================*/
static LPWindowInfo cur_ptr;
static LPWindowInfo current_ptr;
static LPHtWinCallBack lpstframe_callback = NULL;	/* g`͂߃R[obN(Global) */
static LPHtWinCallBack lpframe_callback = NULL;		/* g`R[obN(Global) */
static NJS_POINT2 vert[4];
static NJS_COLOR attr[4];
static NJS_POINT2COL p = {
	vert, attr,	NULL, 4,
};


/*============================================================
  Local Prototypes
  ============================================================*/
static void draw_back_color(LPWindowInfo cur_win);
static HTWINHANDLE get_free_node(void);

/*============================================================
 Name:
 Desc: EBhEVXe
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/01 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
void HTWindowInit(void)
{
	extern void HTtCreateConfirmButton(void);
	int i;
	LPWindowInfo lp_winptr = win_info_buffer;
	
	for (i = 0 ; i < MAX_WINDOW ; i++) {
		lp_winptr->state = 0;
		lp_winptr++;
	}
	HTtCreateConfirmButton();
	lpframe_callback = HTtDrawDefaultFrame;
}

/*============================================================
 Name:
 Desc: EBhE쐬
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/01 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
HTWINHANDLE HTCreateSimpleWindow(Float left, Float top, Float right, Float bottom, Sint32 foreground, Sint32 background)
{
	HTWINHANDLE free_handle = get_free_node();
	LPWindowInfo free_ptr = win_info_buffer + free_handle;
	
	free_ptr->state  = STATE_FRAME_DRAWING;					/* gp */
	free_ptr->left   = left;
	free_ptr->top    = top;
	free_ptr->right  = right;
	free_ptr->bottom = bottom;
	free_ptr->foreground = foreground;
	free_ptr->background = background;
	free_ptr->priority = 0;
	free_ptr->lpbg_callback = NULL;
	free_ptr->managed_window = NULL;
	free_ptr->texture_list = NULL;
	free_ptr->cur_gadget = NULL;
	free_ptr->lpstframe_callback = lpstframe_callback;
	free_ptr->lpframe_callback = lpframe_callback;
	free_ptr->lpWinProc = NULL;						/* ֐͖ */
	free_ptr->nWidth = 1;
	free_ptr->nHeight = 0;
	free_ptr->Direction = HTBUTTONARRAY_DIRECTION_VERT;
	return free_handle;
}


/*============================================================
 Name:
 Desc:
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/02 (Thursday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTCloseWindow(HTWINHANDLE win)
{
	Float  max_priority = -1000.F;
	LPWindowInfo new_top_win = NULL;
	LPWindowInfo cur_ptr = win_info_buffer + win;

	{
		/* gp̃EBhEŎw肵EBhE艺ɂEBhẼvCIeB[␳ */
		int i;
		LPWindowInfo cur_win = win_info_buffer;
		for (i = 0 ; i < MAX_WINDOW ; i++) {
			if (cur_win != cur_ptr && cur_win->priority < cur_ptr->priority && (cur_win->state & 1) == STATE_INUSE) {
				if (max_priority < cur_win->priority) {
					max_priority = cur_win->priority;
					new_top_win = cur_win;
				}
				cur_win->priority += ZDEPTH_WIN;
			}
			cur_win++;
		}
	}
	current_ptr = new_top_win;
	cur_ptr->state = 0;
}

/*============================================================
 Name:
 Desc: EBhE[gɂ͂
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/01 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
void HTMapWindow(HTWINHANDLE cur)
{
	LPWindowInfo cur_ptr = win_info_buffer + cur;

	cur_ptr->priority = ZDEPTH_TOP;
	current_ptr = cur_ptr;
	{
		/* gp̃EBhẼvCIeB[␳ */
		int i;
		LPWindowInfo cur_win = win_info_buffer;
		for (i = 0 ; i < MAX_WINDOW ; i++) {
			if (cur_win != cur_ptr && (cur_win->state & 1) == STATE_INUSE) {
				cur_win->priority -= ZDEPTH_WIN;
			}
			cur_win++;
		}
	}
}


/*============================================================
 Name:
 Desc: EBhE[g͂
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/01 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
void HTUnMapWindow(HTWINHANDLE cur)
{
	LPWindowInfo cur_ptr = win_info_buffer + cur;

	{
		/* gp̃EBhEŎw肵EBhE艺ɂEBhẼvCIeB[␳ */
		int i;
		LPWindowInfo cur_win = win_info_buffer;
		for (i = 0 ; i < MAX_WINDOW ; i++) {
			if (cur_win != cur_ptr && cur_win->priority < cur_ptr->priority && (cur_win->state & 1) == STATE_INUSE) {
				cur_win->priority += ZDEPTH_WIN;
			}
			cur_win++;
		}
	}
	cur_ptr->priority = 0.F;
}


/*============================================================
 Name:
 Desc: EBhEVXe`惋[v
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/01 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
void HTDrawWindowLoop(void)
{
#define NJD_DGT_TRIGER	(NJD_DGT_TA | NJD_DGT_TB | NJD_DGT_TC | NJD_DGT_TX | NJD_DGT_TY | NJD_DGT_TZ | NJD_DGT_TL | NJD_DGT_TR)
	int i;
	static NJS_PERIPHERAL *per[1];

	/* pbhɂJ[\̈ړ */
	per[0] = njGetPeripheral(NJD_PORT_JOYSTICK1);

	/* ȂƂKWFbg݂͑ */

	if (current_ptr != NULL) {
		if (current_ptr->cur_gadget != NULL) {
			/* pbĥƂ */
			LPHTWINGadget lp_gadget;
			if (per[0]->push & NJD_DGT_KD) {
				lp_gadget = current_ptr->cur_gadget->leader;
				while (lp_gadget != NULL) {
					if (lp_gadget->flags & GADGET_STATE_SELECTABLE) {
						current_ptr->cur_gadget = lp_gadget;
						break;
					}
					lp_gadget = lp_gadget->leader;
				}
			} else if (per[0]->push & NJD_DGT_KU) {
				lp_gadget = current_ptr->cur_gadget->child;
				while (lp_gadget != NULL) {
					if (lp_gadget->flags & GADGET_STATE_SELECTABLE) {
						current_ptr->cur_gadget = lp_gadget;
						break;
					}
					lp_gadget = lp_gadget->child;
				}
			}
			/* }EXAiOfoCX̂Ƃ̏ */
			/* vcurrent_ptr->cur_gadgetKɕύX΂悵 */
			{
			}
		}
	}

	cur_ptr = win_info_buffer;
	for (i = 0 ; i < MAX_WINDOW ; i++) {
		if (cur_ptr->state == STATE_INUSE) {
			if (cur_ptr->lpWinProc != NULL) {
				void (*func)(HTWINHANDLE);

				func = cur_ptr->lpWinProc;
				func(i);
			}
		}
			
		if (cur_ptr->texture_list != NULL) {
			njSetTexture(cur_ptr->texture_list);
		}
		switch (cur_ptr->state) {
		case STATE_FRAME_DRAWING:
			/* t[̕`撆 */
			if (cur_ptr->lpstframe_callback != NULL) {
				if (cur_ptr->lpstframe_callback(
					cur_ptr->left, 
					cur_ptr->top, 
					cur_ptr->right, 
					cur_ptr->bottom 
//					) == TRUE || (cur_ptr == current_ptr && per[0]->push != 0)) {
					) == TRUE) {
					cur_ptr->state = STATE_INUSE;
				}
			} else {
				cur_ptr->state = STATE_INUSE;
			}
			break;
		case STATE_INUSE:
			/* wi̕` */
			if (cur_ptr->lpbg_callback == NULL) {
				draw_back_color(cur_ptr);
			} else {
				cur_ptr->lpbg_callback(
					cur_ptr->left, 
					cur_ptr->top, 
					cur_ptr->right, 
					cur_ptr->bottom 
					);
			}
			/* t[̕` */
			if (cur_ptr->lpframe_callback != NULL) {
				cur_ptr->lpframe_callback(
					cur_ptr->left, 
					cur_ptr->top, 
					cur_ptr->right, 
					cur_ptr->bottom 
					);
			}
			/* KWFbg̕` */
			{
				LPHTWINGadget cur_gadget = cur_ptr->managed_window;
				int i = 0;

				while (cur_gadget) {
					void (*func)(void*, Sint32);

					func = cur_gadget->method;
					if (cur_ptr == current_ptr && current_ptr->cur_gadget == cur_gadget) {
						if (per[0]->push & NJD_DGT_TRIGER) {
							// JgEBhE`撆ł{^ĂIꂽKWFbg`悵悤ƂĂ
							if (func != NULL) {
								func(cur_gadget->param_tbl, GADGET_PUSH);
							}
						} else {
							// JgEBhE`撆łIꂽKWFbg`悵悤ƂĂ
							if (func != NULL) {
								func(cur_gadget->param_tbl, GADGET_ONBUTTON);
							}
						}
					} else {
						func(cur_gadget->param_tbl, GADGET_NONE);
					}
					cur_gadget = cur_gadget->child;
					i++;
				}
			}
			break;
		}
		cur_ptr++;
	}
}

			

/*============================================================
 Name:
 Desc: wi`֐̓o^
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/01 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
Bool HTSetBGCallBack(HTWINHANDLE cur_win, LPHtWinCallBack func)
{
	LPWindowInfo cur_ptr = win_info_buffer + cur_win;
	cur_ptr->lpbg_callback = func;
	return TRUE;
}


/*============================================================
 Name:
 Desc: g`֐̓o^(Global)
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/01 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
Bool HTSetFrameCallBack(LPHtWinCallBack func)
{
	lpframe_callback = func;
	return TRUE;
}


/*============================================================
 Name:
 Desc:
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/10 (Friday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
Bool HTSetWinFrameCallBack(HTWINHANDLE cur_win, LPHtWinCallBack func)
{
	LPWindowInfo cur_ptr = win_info_buffer + cur_win;

	cur_ptr->lpframe_callback = func;
	return TRUE;
}

/*============================================================
 Name:
 Desc: g`֐̓o^(Global)
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/10 (Friday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
Bool HTSetFrameStartCallBack(LPHtWinCallBack func)
{
	lpstframe_callback = func;
	return TRUE;
}

/*============================================================
 Name:
 Desc:
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/10 (Friday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
Bool HTSetWinFrameStartCallBack(HTWINHANDLE cur_win, LPHtWinCallBack func)
{
	LPWindowInfo cur_ptr = win_info_buffer + cur_win;

	cur_ptr->lpstframe_callback = func;
	return TRUE;
}

/*============================================================
 Name: HTManagedGadget
 Desc: KWFbgWindowɓ\t
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/01 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
void HTManagedGadget(HTWINHANDLE cur_win, LPHTWINGadget arg)
{
	LPWindowInfo cur_ptr = win_info_buffer + cur_win;

	arg->param_tbl = arg;
	/* |C^̕tւ */
	arg->child = cur_ptr->managed_window;
	if (arg->child != NULL) {						/* ܂GadgetĂȂ? */
		((LPHTWINGadget)(arg->child))->leader = arg;
	}
	arg->leader = NULL;
	arg->flags = 0;									/* selectable */
	arg->status = 0;
	arg->method = NULL;
	cur_ptr->managed_window = arg;
}


/*============================================================
 Name:
 Desc:
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/20 (Monday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
Bool HTUnManagedGadget(HTWINHANDLE cur_win, LPHTWINGadget arg)
{
	LPWindowInfo cur_ptr = win_info_buffer + cur_win;

	arg->param_tbl = arg;
	/* |C^̕tւ */
	if (cur_ptr->managed_window != NULL) {			/* KWFbg͂Ȃ */
		LPHTWINGadget lp_gadget = arg->child;
		while (lp_gadget->child != NULL) {
			if (lp_gadget == arg) {
				/* 폜\̃KWFbg */
				LPHTWINGadget tmp_ptr = (LPHTWINGadget)lp_gadget->leader;
				if (lp_gadget->leader != NULL) {
					tmp_ptr->child = lp_gadget->child;
				}
				tmp_ptr = (LPHTWINGadget)lp_gadget->child;
				tmp_ptr->leader = lp_gadget->leader;
				return TRUE;
			}
		}
	}
	return FALSE;
}


/*============================================================
 Name:
 Desc: KWFbgI\ɂiW͑IłȂ)
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/01 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
void HTSetGadgetSelectable(LPHTWINGadget arg)
{
	arg->flags |= GADGET_STATE_SELECTABLE;
}


/*============================================================
 Name:
 Desc: KWFbg{^Ƃ݂ȂiW̓{^ł͂Ȃ)
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/09 (Thursday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTSetGadgetButton(LPHTWINGadget arg)
{
	arg->flags |= GADGET_STATE_BUTTON;
}


/*============================================================
 Name:
 Desc: w肵KWFbgftHgɂ
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/09 (Thursday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTSetGadgetDefault(HTWINHANDLE win, LPHTWINGadget arg)
{
	LPWindowInfo cur_ptr = win_info_buffer + win;

	cur_ptr->cur_gadget = arg;
}

/*============================================================
 Name:
 Desc:
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/02 (Thursday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTSetTextureList(HTWINHANDLE cur_win, NJS_TEXLIST *list)
{
	LPWindowInfo cur_ptr = win_info_buffer + cur_win;

	cur_ptr->texture_list = list;
}



/*============================================================
 Name:
 Desc: EBhE̐֐̒`
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/14 (Tuesday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTSetWinProc(HTWINHANDLE cur_win, void* func)
{
	LPWindowInfo cur_ptr = win_info_buffer + cur_win;

	cur_ptr->lpWinProc = func;
}
/*************************************************************
 * TOOL BOX                                                  *
 *************************************************************/														  
										  

/*============================================================
 Name:
 Desc: 2DIuWFNg`悷iEBhE)
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/01 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
void HTtDraw2DObject(NJS_POINT2COL *p, Int n, Float z, Uint32 attr)
{
	static NJS_POINT2COL _p = {
		vert, NULL, NULL, 0,
	};
	Uint32 i;
	
	_p.col = p->col;
	_p.tex = p->tex;
	_p.num = p->num;
	for (i = 0 ; i < p->num ; i++) {
		vert[i] = p->p[i];
		vert[i].x += cur_ptr->left;
		vert[i].y += cur_ptr->top;
	}
	njDrawPolygon2D(&_p, n, cur_ptr->priority + z, attr);
}

/*============================================================
 Name:
 Desc: EBhE΂Ő
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/01 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
void HTtDrawLine(Float left, Float top, Float right, Float bottom, Float z, Sint32 color)
{
	static NJS_POINT2COL p = {
		vert,
		attr,
		NULL,
		2,
	};
	vert[0].x = cur_ptr->left + left;
	vert[0].y = cur_ptr->top + top;
	vert[1].x = cur_ptr->left + right;
	vert[1].y = cur_ptr->top + bottom;
	attr[0].color = color;
	attr[1].color = color;
	njDrawLine2D(&p, 1, cur_ptr->priority + z, NJD_DRAW_NORMAL);
}


/*============================================================
 Name:
 Desc: W̔wi`֐
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/01 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
static void draw_back_color(LPWindowInfo cur_win)
{
	vert[0].x = cur_win->left;
	vert[0].y = cur_win->top;
	vert[1].x = cur_win->right;
	vert[1].y = cur_win->top;
	vert[2].x = cur_win->right;
	vert[2].y = cur_win->bottom;
	vert[3].x = cur_win->left;
	vert[3].y = cur_win->bottom;
	attr[0].color = cur_win->background;
	attr[1].color = cur_win->background;
	attr[2].color = cur_win->background;
	attr[3].color = cur_win->background;
	if (cur_win->priority < 0) {
		njDrawPolygon2D(&p, 4, cur_win->priority - 0.1F, NJD_FILL | NJD_TRANSPARENT);
//		njDrawPolygon2D(&p, 4, cur_win->priority - 0.1, NJD_FILL);
	}
}


/*============================================================
 Name:
 Desc: 󂢂ĂEBhEǗ̈T
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/01 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
static HTWINHANDLE get_free_node(void)
{
	int i;
	LPWindowInfo cur_win = win_info_buffer;

	for (i = 0 ; i < MAX_WINDOW ; i++) {
		if (cur_win->state == 0) {
			return i;
		}
		cur_win++;
	}
}


/*============================================================
 Name:
 Desc: `̕`iEBhE)
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/02 (Thursday)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
void HTtDrawBox(Float left, Float top, Float right, Float bottom, Float z, Sint32 color)
{
	attr[0].color = attr[2].color = color;
	attr[1].color = attr[3].color = color;
	vert[0].x = vert[3].x = left;
	vert[0].y = vert[1].y = top;
	vert[1].x = vert[2].x = right;
	vert[2].y = vert[3].y = bottom;
	HTtDraw2DObject(&p, 4,  z, NJD_DRAW_NORMAL);
}

/*============================================================
 Name:
 Desc: g̕`iEBhE)
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/02 (Thursday)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
Sint32 HTtDrawDefaultFrame(Float left, Float top, Float right, Float bottom)
{
	attr[0].color = attr[2].color = WHITE_COL;
	attr[1].color = attr[3].color = WHITE_COL;
	vert[0].x = vert[3].x = -1;
	vert[0].y = vert[1].y = -1;
	vert[1].x = vert[2].x = right - left;
	vert[2].y = vert[3].y = bottom - top;
	HTtDraw2DObject(&p, 4, 0, NJD_DRAW_NORMAL);
	attr[0].color = attr[2].color = WHITE_COL;
	attr[1].color = attr[3].color = WHITE_COL;
	vert[0].x = vert[3].x = -2;
	vert[0].y = vert[1].y = -2;
	vert[1].x = vert[2].x = right - left + 1;
	vert[2].y = vert[3].y = bottom - top + 1;
	HTtDraw2DObject(&p, 4, 0, NJD_DRAW_NORMAL);
	return TRUE;
}
