/*============================================================
 * Name  : htwindrawbargraph.c
 *
 * Desc  : _Otc[
 *
 * prefix:
 *
 * $Id: htwindrawbargraph.c,v 1.1 1998/04/16 00:44:33 horita Exp horita $
 *
 * $Log: htwindrawbargraph.c,v $
 * Revision 1.1  1998/04/16 00:44:33  horita
 * Initial revision
 *
 *============================================================*/

#if DOCUMENT
#endif

/*============================================================
  Include
  ============================================================*/
#include <stdio.h>
#include "htwindrawbargraph.h"

/*============================================================
  Define
  ============================================================*/

/*============================================================
  Macro
  ============================================================*/

/*============================================================
  Structure
  ============================================================*/

/*============================================================
  Globals
  ============================================================*/

/*============================================================
  Static
  ============================================================*/
static void draw_bargrapth_method(LPHTBarGraphParam param, Sint32 state);

/*============================================================
  Local Prototypes
  ============================================================*/


/*============================================================
 Name:
 Desc:
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/14 (Tuesday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTtCreateBarGraph(HTWINHANDLE win, LPHTBarGraphParam arg)
{
	HTManagedGadget(win, (LPHTWINGadget)arg);
	arg->node.method = draw_bargrapth_method;
}

/*============================================================
 Name:
 Desc:
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/14 (Tuesday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
static void draw_bargrapth_method(LPHTBarGraphParam param, Sint32 state)
{
	static NJS_POINT2 vert[4];
	static NJS_COLOR col[4];
	static NJS_POINT2COL p[] = {
		vert, col, NULL, 4,
	};
	Float rate;

	rate = (param->f_val - param->f_min) / (param->f_max - param->f_min);
	vert[0] = param->pos;
	vert[1] = param->pos;
	vert[2] = param->pos;
	vert[3] = param->pos;
	vert[1].x += param->size.x * rate;
	vert[2].x += param->size.x * rate;
	vert[2].y += param->size.y;
	vert[3].y += param->size.y;
	col[0].color = param->color;
	col[1].color = param->color;
	col[2].color = param->color;
	col[3].color = param->color;
	HTtDraw2DObject(p, 4, 0, NJD_FILL);
}
