/*============================================================
 * Name  : htwinraderchart.c
 *
 * Desc  : [_[`[gKWFbg
 *
 * prefix: HTt
 *
 * $Id: htwinraderchart.c,v 1.2 1998/04/20 06:02:45 horita Exp horita $
 *
 * $Log: htwinraderchart.c,v $
 * Revision 1.2  1998/04/20 06:02:45  horita
 * ږ̕`悪B}̕`ȊO͊??
 *
 * Revision 1.1  1998/04/17 08:24:20  horita
 * Initial revision
 *
 *============================================================*/

#if DOCUMENT
#endif

/*============================================================
  Include
  ============================================================*/
#include <stdio.h>
#include "htwindow.h"
#include "htwinitem.h"
#include "htwinraderchart.h"

/*============================================================
  Define
  ============================================================*/

/*============================================================
  Macro
  ============================================================*/

/*============================================================
  Structure
  ============================================================*/

/*============================================================
  Globals
  ============================================================*/

/*============================================================
  Static
  ============================================================*/
/* _f[^ */
static NJS_POINT2	vert[4];
static NJS_COLOR	color[4];
static NJS_COLOR	tex[4];
static NJS_POINT2COL	p[] = {
	vert, color, tex, 3
};

/*============================================================
  Local Prototypes
  ============================================================*/
static void draw_raderchart(LPHTtRaderChartArg arg, Sint32 state);


/*============================================================
 Name: HTtCreateRaderChart
 Desc: [_[`[gKWFbg̐/o^
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/16 (Thursday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void HTtCreateRaderChart(HTWINHANDLE win, LPHTtRaderChartArg arg) 
{
	int i;
	LPHTtItem item_attr = arg->lp_name;
	Float ang_ofs = 0.0F;
	Angle ang;

	/* KWFbg̓o^ */
	HTManagedGadget(win, (LPHTWINGadget)arg);
	arg->node.method = draw_raderchart;

	for (i = 0 ; i < arg->nItem ; i++) {
		if (item_attr != NULL) {
			int cur_condition;
			Float _radius = arg->radius + 2;

			if (i == 0) {
				/* ŏ */
				cur_condition = 0;
//			} else if (i == (arg->nItem / 2) && (arg->nItem & 1) == 0) {
			} else if (ang_ofs == 0.5F) {
				/* ^ */
				cur_condition = 4;
			} else if (ang_ofs == 0.25F) {
				cur_condition = 2;
			} else if (ang_ofs == 0.75F) {
				cur_condition = 6;
			} else {
				/* c͓r̊px */
				ang = NJM_DEG_ANG(360.0F * (ang_ofs - 0.25F));
				if (ang_ofs < 0.25F) {
					cur_condition = 1;
				} else if (ang_ofs > 0.25 && ang_ofs < 0.5) {
					cur_condition = 3;
				} else if (ang_ofs > 0.5 && ang_ofs < 0.75) {
					cur_condition = 5;
				} else if (ang_ofs > 0.75 && ang_ofs < 1.0) {
					cur_condition = 7;
				}
			}
			switch (cur_condition) {
			case 0:
				/* ŏ */
				item_attr->lefttop.x += arg->center.x - item_attr->size.x / 2;
				item_attr->lefttop.y += arg->center.y - _radius - item_attr->size.y;
				break;
			case 1:
				/* E */
				item_attr->lefttop.x += arg->center.x + _radius * njCos(ang);
				item_attr->lefttop.y += arg->center.y + _radius * njSin(ang) - item_attr->size.y;
				break;
			case 2:
				/* E */
				item_attr->lefttop.x += arg->center.x + _radius + 2;
				item_attr->lefttop.y += arg->center.y - item_attr->size.y / 2;
				break;
			case 3:
				/* E */
				item_attr->lefttop.x += arg->center.x + _radius * njCos(ang);
				item_attr->lefttop.y += arg->center.y + _radius * njSin(ang);
				break;
			case 4:
				/* ^ */
				item_attr->lefttop.x += arg->center.x - item_attr->size.x / 2;
				item_attr->lefttop.y += arg->center.y + _radius;
				break;
			case 5:
				/*  */
				item_attr->lefttop.x += arg->center.x + _radius * njCos(ang) - item_attr->size.x;
				item_attr->lefttop.y += arg->center.y + _radius * njSin(ang);
				break;
			case 6:
				/*  */
				item_attr->lefttop.x += arg->center.x - _radius - item_attr->size.x;
				item_attr->lefttop.y += arg->center.y - item_attr->size.y / 2;
				break;
			case 7:
				item_attr->lefttop.x += arg->center.x + _radius * njCos(ang) - item_attr->size.x;
				item_attr->lefttop.y += arg->center.y + _radius * njSin(ang) - item_attr->size.y;
				/*  */
				break;
			}
		}
		item_attr++;
		ang_ofs += 1.0F / arg->nItem;
	}
}
	

/*============================================================
 Name: draw_raderchart
 Desc: [_[`[g`悷
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/16 (Thursday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
void draw_raderchart(LPHTtRaderChartArg arg, Sint32 state)
{
	/* [Jϐ */
	int i, j;
	Float ang_ofs;
	Float cur_angf;
	Float x, y;
	Float xx, yy;
	LPFloat lp_maxtable;
	LPFloat lp_mintable;
	LPHTtItem lp_names = arg->lp_name;
	Angle cur_ang;
	
	/* R[h */
	ang_ofs = 1.F / arg->nItem;
	cur_angf = -0.25F;
	cur_ang = NJM_DEG_ANG(360.0 * cur_angf);
	x = arg->center.x + arg->radius * njCos(cur_ang);
	y = arg->center.y + arg->radius * njSin(cur_ang);
	lp_mintable = arg->lp_mintable;
	lp_maxtable = arg->lp_maxtable;
	vert[0].x = arg->center.x;
	vert[0].y = arg->center.y;

	if (state == 1) {
		HTtDrawBox(arg->center.x - arg->radius - 1,
				   arg->center.y - arg->radius - 1,
				   arg->center.x + arg->radius,
				   arg->center.y + arg->radius,
				   0, 0xffffff00L);
		HTtDrawBox(arg->center.x - arg->radius - 2,
				   arg->center.y - arg->radius - 2,
				   arg->center.x + arg->radius + 1,
				   arg->center.y + arg->radius + 1,
				   0, 0xffffff00L);
	}
	for (i = 0 ; i < arg->nItem ; i++) {
		Float z = 0.5;

		/* g̕` (1) */
		HTtDrawLine(arg->center.x, arg->center.y, x, y, 0, arg->color);
		xx = x;
		yy = y;

		/* ږ̕\ */
		if (lp_names != NULL) {
			HTtDrawItem(lp_names);
		}

		/* Ot̕` */
		for (j = 0 ; j < arg->nGraph ; j++) {
			LPFloat lp_value = *(arg->lpp_val + j);
			Sint32 _color = *(arg->lp_color + j);
			Float rate;
			int k;
			Float diff = lp_maxtable[i] - lp_mintable[i];

			cur_ang = NJM_DEG_ANG(360.0 * cur_angf);
			rate = (lp_value[i] - *lp_mintable) / diff;
			vert[1].x = arg->center.x + arg->radius * njCos(cur_ang) * rate;
			vert[1].y = arg->center.y + arg->radius * njSin(cur_ang) * rate;
			color[1].color = color[0].color = _color;
			color[2].color = _color;

			cur_ang = NJM_DEG_ANG(360.0 * (cur_angf + ang_ofs));
			{
				k = i + 1;
				if (k >= arg->nItem) k = 0;
			}
			diff = lp_maxtable[k] - lp_mintable[k];
			rate = (lp_value[k] - *lp_mintable) / diff;
			vert[2].x = arg->center.x + arg->radius * njCos(cur_ang) * rate;
			vert[2].y = arg->center.y + arg->radius * njSin(cur_ang) * rate;
			HTtDraw2DObject(p, 3, z, NJD_FILL | NJD_TRANSPARENT);
			z += 0.1F;
		}
		/* g̕` (2) */
		cur_angf += ang_ofs;
		cur_ang = NJM_DEG_ANG(360.0 * cur_angf);
		x = arg->center.x + arg->radius * njCos(cur_ang);
		y = arg->center.y + arg->radius * njSin(cur_ang);
		HTtDrawLine(x, y, xx, yy, 0, arg->color);
		lp_names++;
	}
}
