/*============================================================
 * Name  : sample.c 
 *
 * Desc  : windowsystem̃Tv
 *
 * prefix: 
 *
 * $Id: sample.c,v 1.6 1998/04/21 03:06:52 horita Exp horita $
 *
 * $Log: sample.c,v $
 * Revision 1.6  1998/04/21 03:06:52  horita
 * itembox̃Tvǉ
 *
 * Revision 1.5  1998/04/20 06:04:06  horita
 * ButtonItemɕύX̂łɔύXB
 * RaderChart̃eXgB
 *
 * Revision 1.4  1998/04/02 14:44:55  horita
 * eNX`[ɑΉȂ񂾂ǂȂ
 *
 * Revision 1.3  1998/04/02 07:57:23  horita
 * ButtonArraỹTv̍쐬
 *
 * Revision 1.2  1998/04/02 00:29:54  horita
 * ȒPȃ{^āAVɃEBhEĂ݂
 *
 * Revision 1.1  1998/04/01 05:40:20  horita
 * Initial revision
 *
 *============================================================*/

#if DOCUMENT
#endif

/*============================================================
  Include
  ============================================================*/
#include <stdio.h>
#include "htwindow.h"
#include "htwinbutton.h"
#include "htwinbuttonarray.h"
#include "htwinconfirm.h"
#include "htfont.h"
#include "htwindrawbargraph.h"
#include "htwinraderchart.h"
#include "htwinitembox.h"
#include "htwinbuttonbox.h"

/*============================================================
  Define
  ============================================================*/
enum {
	BUTTON_CNT = 5,
	BUTTON_OFFSET = 10,
	TEXCNT = 10
};

#define BUTTON_TEX_WIDTH	32
#define BUTTON_TEX_HEIGHT	16

/*============================================================
  Macro
  ============================================================*/

/*============================================================
  Structure
  ============================================================*/

/*============================================================
  Globals
  ============================================================*/
extern Sint32 Draw_Active_Frame(Float left, Float top, Float right, Float bottom);

/*============================================================
  Local Prototypes
  ============================================================*/
static void change_color2(LPHTtButtonArg arg);
static void val_change(HTWINHANDLE win);
static void yes_func(LPHTtButtonArg arg);
static void no_func(LPHTtButtonArg arg);
static void change_val_0(LPHTtButtonArg arg);
static void change_val_1(LPHTtButtonArg arg);
static void change_val_2(LPHTtButtonArg arg);
static void change_val_3(LPHTtButtonArg arg);
static void change_val_4(LPHTtButtonArg arg);

/*============================================================
  Static
  ============================================================*/
static HTWINHANDLE sample_window;

/* {^pp[^(1) */
static HTtButtonArg button_args[BUTTON_CNT];
static NJS_TEXINFO button_info[TEXCNT];
static NJS_TEXNAME button_name[TEXCNT];
static NJS_TEXLIST button_list = {
	button_name, BUTTON_CNT+1,
};
static Uint16 ButtonTextureBuffer[BUTTON_CNT][BUTTON_TEX_WIDTH * BUTTON_TEX_HEIGHT];
static NJS_COLOR button_col[][4] = {
	RED_COL, RED_COL, RED_COL, RED_COL, 
	YELLOW_COL, YELLOW_COL, YELLOW_COL, YELLOW_COL, 
	BLUE_COL, BLUE_COL, BLUE_COL, BLUE_COL, 
	CYAN_COL, CYAN_COL, CYAN_COL, CYAN_COL, 
	GREEN_COL, GREEN_COL, GREEN_COL, GREEN_COL, 
	WHITE_COL, WHITE_COL, WHITE_COL, WHITE_COL, 
};
static NJS_COLOR button_uv[][4] = {
	UV(1, 1), UV(255, 1), UV(255, 255), UV(1, 255),
	UV(0, 0), UV(256 * 2 - 1, 0,), UV(256 * 2 - 1, 256 - 1), UV(0, 256 - 1),
};

static HTtItemAttr item_attr[] = {
	ITEM_ATTR_TEXTURE, 0, 	button_col[5],	button_uv[0],
	ITEM_ATTR_TEXTURE, 1,	button_col[5],	button_uv[0],
	ITEM_ATTR_TEXTURE, 2,	button_col[5],	button_uv[0],
	ITEM_ATTR_TEXTURE, 3,	button_col[3],	button_uv[0],
	ITEM_ATTR_TEXTURE, 5,	button_col[1],	button_uv[1],
	ITEM_ATTR_TEXTURE, 4,	button_col[5],	button_uv[0],
};	
	
static char *button_str[BUTTON_CNT] = {
	"xc",
	"Ď",
	"ޯ ",
	"With",
	"Test",
};

/* _Otpp[^ */
static HTBarGraphParam graph0[1];

/* [_[`[gpp[^(sample) */
#define RADER_CHART_ITEMS	8
#define RADER_CHART_GRP		2

static HTtRaderChartArg rader_chart;
Float value_table[][RADER_CHART_ITEMS] = {
	100, 120, 60, 80, 67, 90, 50, 60, 
	 90, 130, 80, 30, 17, 80, 50, 60, 
	 30,  30, 70, 40, 27, 80, 50, 60, 
	 60,  60, 50, 50, 37, 20, 50, 60, 
	 20,  70, 70, 60, 47, 80, 50, 60, 
	 90, 100, 80, 70, 57, 50, 50, 60, 
};

LPFloat lp_value_table[] = {
	value_table[1],
	value_table[0],
};

Float min_table[RADER_CHART_ITEMS] = {
	0, 0, 0, 0, 0, 0, 0, 0,
};

Float max_table[RADER_CHART_ITEMS] = {
	150, 150, 100, 100, 100, 100, 100, 100,
};

Sint32 color_table[RADER_CHART_GRP] = {
	GREEN_COL & 0x7fffffff,
	YELLOW_COL 	& 0x7fffffff,
};

/* 
 * [_[`[gpItem̒`(Sample)
 * !! lefttopMethod̂Őݒ肵Ă !!
 */
HTtItem item_list[] = {
	/* nItem,          attr, size.x, size.y, lefttop.x, lefttop.y */
	       1, item_attr    ,     32,     16,         0,         0,
		   1, item_attr + 1, 	 32, 	 16, 		 0, 		0,
		   1, item_attr + 2, 	 32, 	 16, 		 0, 		0,
		   1, item_attr + 3, 	 32, 	 16, 		 0, 		0,
		   1, item_attr + 4, 	 32, 	 16, 		 0, 		0,
		   1, item_attr + 5, 	 32, 	 16, 		 0, 		0,
		   1, item_attr + 3, 	 32, 	 16, 		 0, 		0,
		   1, item_attr + 2, 	 32, 	 16, 		 0, 		0,
};

/* ֐̃e[u */
static void (*onButtonCallBackTable[])(LPHTtButtonArg arg) = {
	change_val_0,
	change_val_1,
	change_val_2,
	change_val_3,
	change_val_4,
};

/* ItemBox̃Tv */
static HTtItem item_aray[] = {
	1, item_attr + 4, 32 + 32 + 16, 32, 0, 0,
	1, item_attr    , 32, 32, 0, 0,
	1, item_attr + 1, 32, 32, 48, 0,
};

static HTtItemBox item_box[] = {
	3, item_aray, 0, 32, NULL,
	3, item_aray, 0, 0, NULL,
};

/* ButtonBox̃Tv */
HTtButtonBoxArg button_box;

/*============================================================
 Name:
 Desc:
 Kind: Global
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/01 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
void Create_Sample_Window(void)
{
	HTWINHANDLE buttonaray_win;

#if 1
	/* Create Button Texture */
	{
		int i;

		memset(ButtonTextureBuffer, 0, sizeof(ButtonTextureBuffer));
		for (i = 0 ; i < BUTTON_CNT ; i++) {
			njSetTextureInfo(button_info + i, ButtonTextureBuffer[i], NJD_TEXFMT_ARGB_1555 | NJD_TEXFMT_RECTANGLE, BUTTON_TEX_WIDTH, BUTTON_TEX_HEIGHT);
			njSetTextureName(button_name + i, button_info + i, i + BUTTON_OFFSET, NJD_TEXATTR_TYPE_MEMORY|NJD_TEXATTR_GLOBALINDEX);
			htFontGetStr(button_str[i], ButtonTextureBuffer + i, BUTTON_TEX_WIDTH, HTFONTATTR_POS_CENTER);
		}
		njSetTextureName(button_name + i, "redtile.pvr", i + BUTTON_OFFSET, NJD_TEXATTR_GLOBALINDEX);
		njLoadTexture(&button_list);
	}
	
	/* {^Q̑̐ݒ */
	{
		int i;
		LPHTtItemAttr lp_item_attr = item_attr;

		for (i = 0 ; i < BUTTON_CNT ; i++) {
			button_args[i].item.lp_item_attr = lp_item_attr;
			button_args[i].item.nItem = 1;
			button_args[i].item.size.x = 64;
			button_args[i].item.size.y = 32;
			lp_item_attr++;
		}
		button_args[4].item.nItem = 2;
	}

	/* {^Q̍쐬 */
	HTtSetButtonArrayAttribute(HTBUTTONARRAY_ATTR_VERT);
	buttonaray_win = HTtCreateButtonArrayWindow(100, 100, button_args, 5, 0, 0);
	HTSetGadgetDefault(buttonaray_win, (LPHTWINGadget)button_args);
	HTSetTextureList(buttonaray_win, &button_list);
	HTSetWinProc(buttonaray_win, val_change);
	HTSetWinFrameStartCallBack(buttonaray_win, NULL);
	HTSetWinFrameCallBack(buttonaray_win, NULL);
	
	HTtSetPushButtonCallBack(button_args + 2, change_color2);
	{
		int i;
		for (i = 0 ; i < BUTTON_CNT ; i++) {
			HTtSetOnButtonCallBack(button_args + i, onButtonCallBackTable[i]);
		}
	}

	/* Otpp[^̐ݒ */
	graph0[0].f_min = -100;
	graph0[0].f_max = 100;
	graph0[0].f_val = 0;
	graph0[0].pos.x = 76;
	graph0[0].pos.y = 10;
	graph0[0].size.x = 100;
	graph0[0].size.y = 32;
	graph0[0].color = RED_COL;
	HTtCreateBarGraph(buttonaray_win, graph0);

	/* [_[`[gpp[^̐ݒ */
	rader_chart.nItem = 8;
	rader_chart.nGraph = 2;
	rader_chart.lpp_val = lp_value_table;
	rader_chart.lp_explain = NULL;
	rader_chart.lp_name = item_list;
	rader_chart.lp_mintable = min_table;
	rader_chart.lp_maxtable = max_table;
	rader_chart.lp_color = color_table;
	rader_chart.center.x = 300;
	rader_chart.center.y = 100;
	rader_chart.radius = 70;
	rader_chart.color = WHITE_COL;
	HTtCreateRaderChart(buttonaray_win, &rader_chart);

	/* {^{bNX̍쐬 */
	button_box.lp_item = item_box + 1;
	button_box.size.x = 80;
	button_box.size.y = 32;
	HTtCreateButtonBox(buttonaray_win, &button_box);
	HTSetGadgetSelectable((LPHTWINGadget)&button_box);
	HTSetGadgetButton((LPHTWINGadget)&button_box);
#else
	HTtCreateConfirmWindow(200, 200, yes_func, no_func);	
#endif
}

/*============================================================
 Name: change_color2
 Desc:
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
p Date: 1998/04/01 (Wednesday)
 Misc:
 ------------------------------------------------------------
 in  :	
 out :
 ============================================================*/
static void change_color2(LPHTtButtonArg arg)
{
	HTtCreateConfirmWindow(140, 200, yes_func, no_func);
}


/*============================================================
 Name: val_change
 Desc:
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/14 (Tuesday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
static void val_change(HTWINHANDLE win)
{
	graph0[0].f_val += 1.F;
	if (graph0[0].f_val > graph0[0].f_max) {
		graph0[0].f_val = graph0[0].f_min;
	}
}


/*============================================================
 Name: change_val_0
 Desc:
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/21 (Tuesday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
static void change_val_0(LPHTtButtonArg arg)
{
	lp_value_table[0] = value_table[1];
	HTtDrawButton(arg);
};

/*============================================================
 Name: change_val_1
 Desc:
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/21 (Tuesday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
static void change_val_1(LPHTtButtonArg arg)
{
	lp_value_table[0] = value_table[2];
//	HTtDrawButton(arg);
	HTtDrawItemBox(item_box);
};

/*============================================================
 Name: change_val_2
 Desc:
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/21 (Tuesday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
static void change_val_2(LPHTtButtonArg arg)
{
	lp_value_table[0] = value_table[3];
	HTtDrawButton(arg);
};

/*============================================================
 Name: change_val_3
 Desc:
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/21 (Tuesday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
static void change_val_3(LPHTtButtonArg arg)
{
	lp_value_table[0] = value_table[4];
	HTtDrawButton(arg);
};

/*============================================================
 Name: change_val_4
 Desc:
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/21 (Tuesday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
static void change_val_4(LPHTtButtonArg arg)
{
	lp_value_table[0] = value_table[5];
	HTtDrawButton(arg);
};



/*============================================================
 Name: yes_func
 Desc:
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/21 (Tuesday)
 Misc:
 ------------------------------------------------------------
 in  :
p out :
 ============================================================*/
static void yes_func(LPHTtButtonArg arg)
{
	fprintf(stderr, "Yes\n");
}


/*============================================================
 Name: no_func
 Desc:
 Kind: Local
 User: Eiji Horita horita@cs1.sega.co.jp
 Date: 1998/04/21 (Tuesday)
 Misc:
 ------------------------------------------------------------
 in  :
 out :
 ============================================================*/
static void no_func(LPHTtButtonArg arg)
{
	fprintf(stderr, "No \n");
}

